// FLAGS


// PARAMETRES 
#ifndef _CCHESS_1_H_
#define _CCHESS_1_H_
#undef  DEBUG 
#define RELEASE_VERSION "Gibbon 2.60a"
// Version mono-thread
// Score sur short, move sur 32 bits
////////////////////////////////////////////////////////////////////////
// PARAMETRES PRINCIPAUX
#define IS_RELEASE 1 // fait des undef-redef de correction dans Cchess_2.h
#define USE_OPENING_BOOK 1
#define TIMER_ON 1 // 1 = time - 0 = allocation de nodes
#define TIMER_ON_MODE 1 // 1 = dcompte // 0 = temps fixe par coup 
#define TIMER_ON_FIXED_GAME_LENGTH_MINUTES 13
#define TIMER_OFF_NUMBER_OF_NODES 400000
#define DEBUG 0
#define STOP_ON_ERROR 0 // important => mettre  0
#define STOP_ON_MINOR_ERROR 0
#define DISPLAY_NO_ERROR 1
#define LOG_CRITICAL_ERRORS_TO_FILE 0  // to file
#define COLLECT_STATS 0 // 0 est plus rapide
///////////////////////////////////////////////////////
// AUTRES PARAMETRES - et voir Chess2 pour les autres paramtres
#define MORE_TIME_ON_WORSE_POSITIONS 1
#define RECONSTITUTION_LIGNE_PRINCIPALE 1
#define HASH_KEY_64_BITS 1
#define EXTEND_USE_CASES_ACTUALISATION_FOR_CHECKS 0 // 0 est le meilleur
#define ALLOW_SELECTIVE_CHECKS 1  // 1 est marginalement meilleur
#define ALLOW_SELECTIVE_CHECKS_BILAN_COUP 1 // 1 vite les selective checks inutiles
#define LIMIT_SELECTIVE_CHECKS 0 // flag - 0 est normal
#define AVAILABLE_SELECTIVE_CHECKS 5 // 5
#define NO_SELECTIVE_KNIGHT_CHECKS 0 // 0 pour permettre de terminer par une fourchette
#define NO_SELECTIVE_BISHOP_CHECKS 1 // 1
#define NO_SELECTIVE_ROOK_CHECKS 1 // 1
#define NO_EXTEND_QUEEN_CHECK_SACRIFICE 1 // 1 est normal
#define NO_EXTEND_QUEEN_TAKES_PROTECTED_PAWN 1 // 1 est normal 
#define EXTEND_DISABLE_PAWN_EXCHANGES 0 // 0 est normal
#define EXTEND_XEXTENDLEVEL_CHECKS 1 // 1 est meilleur - Echecs ou non  xextendlevel (plus extension d'chec ou checs slectifs)
// Best setup so far :
// EXTEND_XEXTENDLEVEL_CHECKS==1
// EXTEND_XEXTENDLEVEL_CHECKS_ONLY_PV==0
//
// Two other possible setups
// EXTEND_XEXTENDLEVEL_CHECKS==1
// EXTEND_XEXTENDLEVEL_CHECKS_ONLY_PV==1 
// et
// EXTEND_XEXTENDLEVEL_CHECKS==0 
// EXTEND_FORCE_CHECKS_ON_PV==1
// EXTEND_FORCE_CHECKS_ON_PV_LEVEL==xextendlevel
// Dans tous les cas, on autorise les selective checks
// This is a configuration that allows 
// few checks at xextendlevel
// - force checks when PV until xextendlevel+0 or 2
// - play selective_checks in all cases (check forks)
// 
// Checks only at PV
#define EXTEND_XEXTENDLEVEL_CHECKS_ONLY_PV 0 // 0 est normal
// Permet de forcer les checs en PV mme si on dit pas d'checs  xextendlevel
#define EXTEND_FORCE_CHECKS_ON_PV 0 // 0 est normal - checks at frontier xextendlevel
#define EXTEND_FORCE_CHECKS_ON_PV_LEVEL xextendlevel // xextenlevel opu xextendlevel+2
#define EXTEND_PRISES_INSUFFISANTES_CANDIDATES_ECHEC 0 // 0 is better - less nodes I suppose
#define EXTEND_PRISES_INSUFFISANTES_CANDIDATES_ECHEC_ONLY_ON_PV 1
// Si 1, on empche le programme de voir les selectives checks des prises insuffisantes
// Par contre, on peut cantonner les checs  NODE_PV pour xetendlevel
// Dans ce cas, on s'autorise quand mme un chec ventuel en selective check
#define CHECK_EXTENSION_PLAY_ALL_CHECKS 0 // 0 semble meilleur
#define NO_EXTEND_CHECKS 0 // 0 est nettement meilleur
#define NO_EXTEND_PAWN_CHECKS 1 // 1 est ok - pas d'checs sauf extension d'checs
#define NO_EXTEND_KNIGHT_CHECKS 1 // 1 est ok - pas d'checs sauf extension d'checs 
#define NO_EXTEND_BISHOP_CHECKS 1 // 1 est ok - pas d'checs sauf extension d'checs
#define NO_EXTEND_KING_CHECKS 1  // 1 est ok - pas d'checs sauf extension d'checs
#define NO_EXTEND_ROOK_CHECKS  1 // 1 est ok - pas d'checs sauf extension d'checs
// Au level+1 et +2 par rapport au node PV, on autorise n coups
// avant late move reductions (fruit pruning)
#define NO_USELESS_DEPTHTARGET_MOVES 1 // 1 est normal
#define ALLOW_EXTENSIONS 1 // 1 est normal
#define EXTENSION_ENTREE_FINALE 1 // 1 est excellent
#define EXTEND_ON_NODE_PV 0 // 0 est normal
#define LIMIT_ON_NON_CHECK_EXTENSIONS 0 // 0 est normal
#define EXTENSION_LIMIT_NODE_PV_NODES 4
#define EXTENSION_LIMIT_NODE_ALL_NODES 2
#define EXTENSION_LIMIT_NODE_CUT_NODES 2
#define USE_MATE_THREATS 1 // 1 est normal
#define MATE_THREAT_DISTANCE_FROM_DEPTHTARGET 4 // 4 minimum
#define MATE_THREAT_EXT_DISTANCE_FROM_DEPTHTARGET 4 // 4 minimum
#define USE_MATE_THREATS_EXTENSIONS 1 
#define AVAILABLE_MATE_THREAT_EXTENSIONS 4 // 4 minimum
#define QUEEN_THREATS_ONLY 0 // 0 est normal
#define MATE_THREATS_ONLY_ON_NODE_PV 0 // 0 est important pour ROTMAN
#define USE_NULLMOVE_REFUTATION 1
#define RECHERCHE_DECOUVERTES 1 // 1 amliore pas mal Rotman
#define DECOUVERTES_ON_EXTEND 1 // 1 est normal
#define USE_CASES_COUPS_FORCANTS 0 // 0 est normal
#define USE_CASES_ACTUALISATION 1 //  1 pour MATE_IN_ONE, et cases controles 
#define USE_CASES_CONTROLEES_JOUEUR 1 // 1 - oblige USE_CASES_ACTUALISATION 1
#define SEARCH_ANALYSE_COUPS_HEURISTIQUES_ONLY_ON_DEPTHTARGET 0
#define LISSAGE_POSITION 0 // 0 est normal
#define ALLOW_MODIFIED_PAWN_EXTENSIONS 1 // 1 est bon (mais en fait "non rduction")
#define DONT_TRADE_QUEENS_IF_MATERIAL_DEFICIT 1 // 1 est excellent
#define CHECK_UNCONTROLLED_PASSED_PAWN 1 // 1 ou 0
#define VALUE_MINOR_PIECES 0 // 0 de prfrence
#define VALUE_KNIGHTS_ONLY 0 // 0 de prfrence
#define USE_MATE_DISTANCE_PRUNING 1 // 1 est normal
#define ALLOW_EXTEND_SINGLE_MOVE_EXTENSION 1 // 1 est excellebt
#define USE_MATE_IN_ONE 1 // 1 est ok
#define MATE_IN_ONE_CHECK_INTERCEPTIONS 1 // 1 est obligatoire 
#define ALLOW_HASH_TRANSFORM 1 // 1 est normal
#define DISPLAY_SELECTIVE_DEPTH 1
#define ANTICIPATE_EXTEND_CUTOFF 1 // Prfrer 1
#define ANTICIPATE_EXTEND_CUTOFF_MARGIN 10
#define USE_BITBOARD_MOVE_GENERATION 0 // 0 ( => 1 est moins efficace (393/323 )
#define USE_BITBOARD_SUBACTUALISE 0 // 0 est plus rapide
#define USE_REDUCTIONS 1 // 1 est normal
#define USE_FRUIT_PRUNING 1 // 1 est obligatoire
#define NBPLAYED_BEFORE_FRUIT_PRUNING 0
//#define FIRST_LEVEL_FRUIT_REDUCTION 4     // non cumulatif
//#define SECOND_LEVEL_FRUIT_REDUCTION 6 // non cumulatif
//#define THIRD_LEVEL_FRUIT_REDUCTION 8   // non cumulatif
#define INCREMENTAL_HASH 1 // 1 normalement 
#define PERMANENT_BRAIN 1	// 1 a priori - 0 sinon
#define CHOOSE_RANDOM_OPENING 1 // 1 normalemnt
#define CHOOSE_FIRST_OPENING 0  // 0 normalement
#define CHOOSE_BEST_OPENING 0   // 0 normalement
#define ENABLE_BOOK_LEARNING 1 // 1 normalement
#define USE_BOOK_STATS 1 // 1 normalement
#define USE_HASH_TABLE 1	// 1 normalement
#define USE_PAWN_HASH_TABLE 1	// 1 normalement
#define OPENING_BOOK_LENGTH 50 // Nombre de demi-coups accepts depuis la bibliothque
#define OPENING_BOOK_NAME "small.txt"
#define MAX_HASH_SIZE 256
#define DEFAULT_HASH_SIZE 64
#define SEARCH_COUPS_HEURISTIQUES_ECHECS 1
#define USE_CASES_ATTAQUE_PION 0 // prfrer 0
#define ALLOW_FOR_CONTEMPT 0 // 0 normalement
#define CONTEMPT 0 // positif = contempt - ngatif = self_contempt !!
#define CHOIX_OUVERTURE {"e4", "d4", "Nf3", "c4"} // Attention format ANGLAIS - Ex : Nf3
#define CHOIX_OUVERTURE_SIZE 4
#define CHOIX_OUVERTURE_POIDS { 25, 25, 25, 25 }
#define USE_BOOK_TRANSPOSITIONS 1 // 1 normalement
#define ALLOW_NULLMOVE 1 // 1 normalement
#define NULLMOVE_REDUCTION 3 // 3 is clearly best
#define ADAPT_NULLMOVE 0 // 0 normalement
#define SEARCH_NO_NEED_TO_EXTEND 1 // 1 de prfrence
#define ALLOW_FUTILITY_4 1 // 1 est indispensable
// On joue une menace de  mat par coup divers  la frontire-1
// => il ne faut pas metre zro  l'extension 1
#define FUTILITY_4_ONLY_LASTDEPTH 0 // 0 de prfrence
#define ALLOW_FUTILITY_4_EXTENSION_1 1 // 1 est indispensable
#define ALLOW_FUTILITY_4_EXTENSION_2 0 // 0 est sans doute le meilleur
#define ALLOW_LEVEL_INTERMEDIAIRE 1 // 1 est normal
#define IID_REDUCTION 2 // 2 est normal
#define KING_SAFETY 1 // 1 est normal
#define ALLOW_SEARCH_BILAN_AD 1 // 1 est normal
#define ALLOW_EXTEND_ROOK_SACRIFICES 1 // 1 est normal
#define HEURISTIQUE_THREAT_GREATER_PIECE 0 // 0 est normal
#define HEURISTIC_PIECE_EVASION 0 // 0 est normal
#endif
// Experiences - plus ou moins bizarre - Mettre  zro
#define REDUCE_DEPTH_ON_PV_OTHER_MOVES 0  // 0 est normal
#define ALLOW_SEARCHROOT_MOVE_SELECTION 0 // 0 est normal
#define REDUCE_DEPTH_ON_USELESS_BRANCHES 0 // 0 est normal
#define USELESS_BRANCHES_MATERIAL_DIFFERENCE 500
#define MULTI_CONTROL 0 // prfrer 0 - Mais concept intressant
#define EXTEND_VERIFY_LINE 0 // 0 est normal 
#define USE_EXTEND_NODE_PV 0 // 0 est normal
#define TREAT_ALL_EXTEND_NODES_AS_PV 0 // 0 est normal
#define ALLOW_COMPLEMENTARY_CHECKS 0 // prfrer 0 - 1 is bad (goes for too many checks)
#define SEARCH_NO_EARLY_HEURISTIC_MOVES 0 // 0 - 1 est bad pour extend_checks
#define NO_EXTENSION_WHEN_NOT_PV 0 // 0 est normal
#define ALLOW_ADDITIONAL_CHECKS_AT_DEPTHTARGET 0 // 0 est normal
#define AVAILABLE_ADDITIONAL_CHECKS_AT_DEPTHTARGET 0 // O est normal
