#include "stdafx.h"
#include "Move.h"
#include "Cchess_3.h"

extern enum PARAMETRES;


#ifndef __SEARCHTRHEADCLASS_H__
#define __SEARCHTRHEADCLASS_H__


class SearchThreadClass
{
public:
	char ID; // Identifiant du thread (le thread 0 restant actif quoi qu'il arrive)
	// Seul le thread d'ID 0 effectue les contrles de temps et priodiques
	SearchThreadClass();
	~SearchThreadClass();
	//void					run_thread_search(SearchThreadClass *parent_thread, char wtm, SQUARE *xboard, STATEVALUES *statesptr, MOVE *lignemoins \
	//								short lastscore);
	// lance la recherche d'un thread pralablement dmarr
	void start_thread(); // dmarre un thread
	//void send_maj_alpha(short alpha); // propage les modifications de alpha au thread co-worker
	//void send_coworker_cutoff(); // informe le co-worker de l'existence d'un cut-off dans le thread appelant
	//void return_thread();  dclenche le callback du thread qui met  jour le RESULTSET du thread dans le THREAD appelant
      // pour consultation par le thread appelant
	//void provide_coworker_result(); appel par le thread co-worker pour renseigner le resultset du thread appelant
private:
	bool is_leader;
	HANDLE					hThreadInstance;
};

#endif //__SEARCHTHREADCLASS_H__



#ifndef __CIOMANAGER_H__
#define __CIOMANAGER_H__


#include <vector>
#include <io.h>
#include <direct.h>
//#include "Cchess_3.h"

class CIOManager
{
public:

	CIOManager();
	~CIOManager();
	
	// Dmarre effectivement le thread
	void start(void);

	/** true if an input line is available and needs to be processed */
	bool						InputLinesAvailable;

	//Attend jusqu'a la saisie d'une commande et retourne la commande saisie
	CString					    wait4_user_input();

	void						CheckInput();

	bool						TerminationAsked;
	//char						buffer_print[32768+1];

	/* true if the engine is running in a DOS BOX */
	//bool						Is_Dos_Box;

private:
	/* Wait for an input line and returned it */
	void						GetInputLines();

	//bool F_neutralisation;
	mutable CString				BufferInput;

	HANDLE					    hThreadCheckInput;

	/* the input line waiting to be processed */
	std::vector<CString>        InputLines;
	//std::vector<CString>::iterator InputLines_iterator_to_position_0;
};


#endif //__CIOMANAGER_H__






class parametres_globaux
{
public :
	static bool xF_make_posval_finale;
	static char xF_roi_posx_mem[2];
};




class uci_interface
{
public :
	 static char fenstring_ep;
private :
	 static unsigned short buffer_iterator;
	 static short command_iterator;
	 static bool F_command_being_given;
	 static char uci_char;
	 //static short i;
	 static bool F_new_startpos;
	 static bool F_new_fenstring;
	 static bool F_moves;
	 static char dep, arr, prom, special, num;
	 static char prise_nat;
	 static ENREGISTREMENT *rptr; // record
  	 static char cc;
	 static char finale;
	 static char set_int_parameter;	 
	 static char set_str_parameter;
	 static long value;
public :
	 static	CIOManager IOManager;
	 static short nombre_max_commandes;
	 static void allouer_nouvelles_commandes(void);
	 static void Dispose(void);
	 static void process_uci_commande(short i);
	 static void clear_uci_buffer(void);
	 static char get_uci_buffer(void);
	 static void process_uci_buffer(char call_mode);
	 static void get_and_process_uci_buffer(char call_mode);
	 static char call_mode;
	 static short uci_nombre_commandes;
	 static bool F_start_new_position;
	 static void start_new_position(void);
	 static bool F_uci_commande_1;
	 static bool F_uci_commande_2;
	 static bool F_isready;
	 static bool F_position_entered;
	 static bool F_stop;
	 static bool F_position_set_from_uci;
	 static bool F_go, F_go_ponder;
	 static bool F_setoption;
	 static bool xopeningbook_in_use_mem;
	 static short xnbcoups_mem;
	 //static char uci_info_start_string[];
	 // 60 pour le dbut de ligne, 5*120 pour la liste de coups et 40 de marge
	 static char info_buffer[60+5*120+40];
     static CString uci_buffer;
	 static char (*uci_commandes)[][UCI_COMMAND_SIZE+1];
	 static char uci_move[6];
	 static char trace_location[50];
	 static char fenstring[100]; // 8*8+7 maximum + roques
	 static bool F_suppress_bestmove_answer;
	 //static void uci_interface::enlarge_uci_buffer(void);

};



class MOVE_ITERATOR
{
public:
	MOVE get_move(void);
	void init_piece(PIECE* numptr);
	#if USE_EXTENDED_MOVE_ITERATOR==1
	bool F_maj_mobility;
	bool F_maj_pieces_attaquees;
	bool F_maj_coups_forcants;
	bool F_maj_cases_controlees;
	#endif
	static void init_tableau(void);
	MOVE_ITERATOR(void);
private:
	char level;
	char nature;
	char maxdir;
	char dir;
	PIECE* numptr;
	MOVE* mpt;
	MOVE* coup_precedent;
	MOVE move;
	bool valid;
	char direction_interrompue;
	char num_piece;
	char prise_nat;
	//char dep,arr,arr64;
	STATEVALUES *s;
	char color_case;
	char color, color01;
	bool validite_coup_precedent;
	char nature2;
	char m;
};



class SEARCH
{
public:
   char searchroot(void);
   short search(short received_depthtarget, char node_type_original,short alpha,short beta,MOVE received_hint_move, MOVE previous_level_nullmove_refutation, short valuemoins
			 #if USE_ANSWER==1 
			 ,MOVE answer
			 #endif
			 );
   short extend(
			 #if USE_EXTEND_NODE_PV==1
	         char node_type_original,
			 #endif	
			 short alpha, short beta,  MOVE received_hint_move, short valposmoins, short valuemoins,
			 char lmoins_check, char lmoins_nb_coups_liste,
			 bool F_nextlevel_try_anticipated_extend_cutoff
			 #if NO_EXTENDLEVEL_CHECKS==0
			 ,char search_node_type
			 #endif
			 );
   void search_listmoves2_create(bool F_reset_priority,
					   bool F_reset_Fplay,
					   bool F_reset_fail_lows,
					   bool F_reset_hash
					   );
   void search_complete_liste_autres_coups(void);
   void search_cree_liste_prises(void);
   void extend_cree_liste_autres_coups(void);
   void extend_cree_liste_prises(void);
   //#if USE_CASES_ACTUALISATION==1
		//bool F_mettre_a_jour_clouages[2];
   //#endif
   MOVE search_get_move(void);
   MOVE extend_get_move(void);
   void search_initialize_move_generator(void);
   void extend_initialize_move_generator(void);
   void inventaire_pieces_non_defendues(void);
    char depthtarget_level;
	#if ALLOW_SEARCH_BILAN_AD==0
    char case_objectif_dernier_coup;
    #endif
    bool check_time_and_keyboard_for_return(void);
	//MOVE *killermove;
    //KILLERMOVE killermoves[NOMBRE_KILLERMOVES+1];
	//KILLERMOVE *killermoves_ptr,*killermoves_levelplus;
	//MOVE killermoves[NOMBRE_KILLERMOVES+1];
    SEARCH *next_search_level;
	SEARCH *previous_search_level;
    char nbplayed,nbplayed_hors_prises;
	bool F_nextlevel_try_anticipated_extend_cutoff;
	bool F_extension_echecs;
	bool F_faire_maj_king_safety_0;
	bool F_faire_maj_king_safety_1;
	#if ALLOW_SELECTIVE_CHECKS==1
	  bool F_selective_checks;
      unsigned __int32 selective_checks_piece_flag;
	  unsigned __int64 selective_checks_arrival_squares;
      void maj_cases_de_fourchette_avec_echec(PIECE *wptr);
	#endif
	#if ALLOW_COMPLEMENTARY_CHECKS==1
	bool F_faire_maj_cases_roi_0;
	bool F_faire_maj_cases_roi_1;
	char check_filter;
	void maj_cases_roi_complementary_checks(char wtm);
	#endif
	#if USE_MATE_IN_ONE==1
	bool F_case_de_mat;
	unsigned __int64 cases_arrivee_roi_adverse;
	unsigned __int64 cases_controlees_adversaire_hors_roi;
	#if MATE_IN_ONE_CHECK_INTERCEPTIONS==1
	unsigned __int64 cases_interception_adversaire;
	#endif
	char roi_pos_other;
	void maj_cases_de_mat(PIECE *wptr, char nature, unsigned __int64 &cases_echec);
	#if EXTENDLEVEL_KILLERMOVE==1
	MOVE extend_oldbest;
	#endif
	#endif
	#if RECHERCHE_DECOUVERTES==1
	bool F_decouverte;
	char decouverte_num;
	char decouverte_nature;
	char decouverte_move_nature;
	unsigned __int64 u64;
	unsigned __int64 cases_cibles_decouverte, cases_menacees_decouverte;
	#endif
	bool F_depthtarget_level_reached;
	bool F_real_move_has_been_registered;
	bool Fsel;
	#if USE_MATE_THREATS==1
	bool F_allow_mate_threats;
	#endif
	char level_nullmove;
	bool F_no_listmoves2;
	SEARCH *search_level;
	MOVE *best;
	LISTLEVEL listmoves[LENGTH_SEARCHLISTMOVES+1];
	LISTLEVEL *listmoves2[LENGTH_SEARCHLISTMOVES+1];
	bool F_pas_de_prises;
	LISTLEVEL *listmovesptr;
	char phase_generation;
	PIECE *numptr;
	char num;
	char check;
	unsigned long compteur_mem;
	bool F_autorisation_echecs;
    #if REDUCE_DEPTH_ON_USELESS_BRANCHES==1
	bool F_possible_useless_branch;
	#endif
	char nb_coups_liste;
	#if USE_NULLMOVE_REFUTATION==1
	MOVE nullmove_refutation;
	char nullmove_refutation_arr;
	bool F_nullmove_refutation_cannot_be_defended;
	char nature_attaquant, nature_defenseur;
	MOVE previous_level_nullmove_refutation;
	#endif
	#if USE_SEARCH_UNDEFENDED_PIECES==1
	bool F_inventaire_pieces_non_defendues;
	unsigned __int32 pieces_non_defendues;
	bool F_piece_non_defendue;
	#endif
	short min_fail_low_value;
	unsigned __int64 cases_couverture_echecs;
	#if USE_CASES_ATTAQUE_PION==1
	unsigned __int64 cases_attaque_pion;
	#endif
	bool F_creation_liste; // La liste des coups listmoves est complte
	bool F_utilisation_liste; // On utilise une liste listmovesptr
	bool F_level_impair;
	char debut_blanc, fin_blanc, debut_noir, fin_noir;
	#if USE_CASES_ACTUALISATION==1
	bool F_initialisation_cases_actualisation;
	unsigned __int32 pieces_clouees;
	unsigned __int32 pieces_with_possible_illegal_moves;
	unsigned __int64 cases_controlees_adversaire;
    unsigned __int64 cases_controlees_pion_adversaire;
	unsigned __int64 cases_controlees_cavalier_adversaire;
    unsigned __int64 cases_controlees_fou_adversaire;
    unsigned __int64 cases_controlees_tour_adversaire;
	unsigned __int64 cases_controlees_dame_adversaire;
	unsigned __int64 cases_controlees_roi_adversaire;
	unsigned __int64 cases_controlees_fou_adversaire_avec_inclusion;
	unsigned __int64 cases_controlees_tour_adversaire_avec_inclusion;
	unsigned __int64 cases_clouage_possible;
	//unsigned __int64 cases_controlees[2];
	#if USE_CASES_CONTROLEES_JOUEUR==1
	#if _DEBUG
	bool F_calculate_case_controlees_joueur;
	#endif
	unsigned __int64 cases_controle_exclusif_roi;
	unsigned __int64 cases_controle_exclusif_dame;
	unsigned __int64 cases_controle_exclusif_tour;
	unsigned __int64 cases_controle_exclusif_fou;
	unsigned __int64 cases_controle_exclusif_cavalier;
	unsigned __int64 cases_controle_exclusif_pion;
	//unsigned __int64 cases_avancee_pions_joueur; // ne tient pas compte des prises en passant
	unsigned __int64 cases_controlees_joueur;
	#if MULTI_CONTROL==1
	unsigned __int64 cases_multi_controlees_joueur;
	#endif
	//unsigned __int64 cases_controlees_joueur_hors_cavalier;
	//unsigned __int64 cases_controlees_joueur_hors_fou;
	//unsigned __int64 cases_controlees_joueur_hors_tour;
	//unsigned __int64 cases_controlees_joueur_hors_dame;
	#endif
	#endif
	// car dans certains endroits, c'est indispensable
	#if USE_CASES_COUPS_FORCANTS==1
	bool F_existe_coup_forcant_adversaire;
	#endif
    #if COLLECT_STATS==1
	ORIGINE_COUPS_SEARCH origine_coups_analysis;
	ORIGINE_COUPS_EXTEND origine_coups_analysis_extend;
	#endif

	// Killermoves
	MOVE killermoves[NOMBRE_KILLERMOVES+1];  
	

	MOVE hint_moves[2];
	MOVE prises_favorables[LENGTH_SEARCHLISTMOVES/5];
	MOVE prises_pion_non_defendus[LENGTH_SEARCHLISTMOVES/5];
	MOVE echanges_piece[LENGTH_SEARCHLISTMOVES/5];
	MOVE echanges_pion[LENGTH_SEARCHLISTMOVES/5];
	MOVE prises_piece_inferieure[LENGTH_SEARCHLISTMOVES/5];
	MOVE prises_insuffisantes_candidates_echec[LENGTH_SEARCHLISTMOVES/5];
	MOVE autres_coups[LENGTH_SEARCHLISTMOVES];
	MOVE coups_declasses[LENGTH_SEARCHLISTMOVES/5];
	// Pour search
	LISTLEVEL listlevel_killermoves[NOMBRE_KILLERMOVES+1];

	char nb_prises_favorables, 
		 nb_prises_pion_non_defendus, 
		 nb_echanges_piece,nb_echanges_pion, 
		 nb_prises_piece_inferieure,
		 nb_prises_insuffisantes_candidates_echec,
		 nb_autres_coups, nb_coups_declasses;
		
#if EXTEND_USE_CASES_ACTUALISATION_FOR_CHECKS==1
char nb_echecs;
MOVE echecs[LENGTH_SEARCHLISTMOVES/3]; // dcouvertes aussi
void extend_creer_liste_echecs_sans_prises(void);
void extend_ajouter_echecs_piece(PIECE *wptr, unsigned __int64 &cases_echec_corrigees);
void extend_ajouter_decouvertes_piece(PIECE *wptr);
#if _DEBUG==1
bool extend_check_move_is_in_list(PIECE *wptr,MOVE move);
#endif
#endif
#if USE_SEARCH_UNDEFENDED_PIECES==1
#if USE_SEARCH_ALL_UNDEFENDED_PIECES==1
char case_cible_heuristique_protection;
#endif
#endif

#if USE_SEARCH_UNDEFENDED_PIECES==1
unsigned __int32 pieces_attaquees_dernier_coup;
//#endif
#if USE_SEARCH_ALL_UNDEFENDED_PIECES==0
// A laisser dans levelvalues
unsigned __int32 pieces_attaquees_dernier_coup;
#endif
#endif
#if USE_SEARCH_UNDEFENDED_PIECES==0 && USE_CASES_COUPS_FORCANTS==1
unsigned __int32 pieces_attaquees_dernier_coup;
#endif

MOVE* moveptr;
unsigned short analysis; // au moins 16 bits
short alpha;
char idxmove;
MOVE hint_move;
bool F_hint_move_has_been_played;
bool F_existe_coup_legal;  
bool F_listmoves2_created;
bool F_bilan_coup_effectue;
char node_type;
bool F_nouvelle_piece;
LISTLEVEL **listmoves2ptr;
char wtm, other_wtm;
STATEVALUES *s;
char num_roi;
MOVE *lignemoins;
short valpos;
short value;
short sup_alpha_value;
char player;
char level, levelplus, levelmoins;
MOVE *bestplus,*ligne;
bool F_actualisation_done;
STATEVALUES *s_plus, *s_moins;
unsigned __int64 cases_occupees, cases_occupees_color01[2];
bool is_pawn_protected(char pos, char color01);
bool is_pawn_protected2(char pos, char color01);
char levelmax_echecs;
char ep_square64;
#if USE_REDUCTIONS==1
bool F_allow_reduction;
void set_allow_reduction();
#endif
//#if USE_NULLMOVE_REFUTATION==1
MOVE suggested_heuristic_move;
//#endif
#if EXTEND_VERIFY_LINE==1
bool F_play_non_tactical_moves;
#endif
#if _DEBUG==1
bool F_at_least_some_non_tactical_moves_played;
#endif
char finale;
char localretry;
short depthtarget, depth, depthmove;
#if CHECK_CHECKS==1
char check2;
#endif
bool F_do_see_evaluation;
bool F_move_should_be_explored_without_reduction;
#if USE_MATE_THREATS==1
bool F_queen_threat_extension;
#if TRACK_QUEEN_POSITION==1
unsigned __int64 king_attack_squares;
#endif
#endif
#if USE_RESTRICT_NULLMOVE==1
bool F_restrict_nullmove;
#endif
PIECE *chkptr[2],*chkptr2[2];
char chk_inc[2];
char echecs_count; 
// Pour testcheck, indpendamment
char testcheck_echecs_count;
PIECE *full_testcheck_chkptr[2],*full_testcheck_chkptr2[2];
char full_testcheck_chk_inc[2];
#if CHECK_CHECKS==1
char echecs_count2;
PIECE *chkptr3[2],*chkptr4[2];
#endif
#if HEURISTIC_PIECE_EVASION==1
unsigned __int64 hanging_pieces;
#endif
PIECE* reactu_liste[32]; 
char reactu_liste_nombre;
CASE savesquare[4];
PIECE savepiece[2];
void copiekeep(void);
//void copiebest(char F_alphabeta_move);
void copiebest(void);
void display_best(bool &F_first_display, bool F_force);
void jouer(const MOVE move);
void dejouer(MOVE move,char actu);
char bilan_attaque_defense(char pos);
#if _DEBUG==1
char bilan_attaque_defense_avant_coup2(MOVE move);
#endif
char bilan_attaque_defense_avant_coup(MOVE move);
char bilan_attaque_defense_avant_coup_simplifie(MOVE move);
//short max_capture_value;
// Fonctions de recherche
void pion2(PIECE *wptr,PIECE_SET *psptr,
			  char &mob_others, char &mob_prises, 
				  char &mobility2, char &promo);
#if USE_BITBOARD_MOVE_GENERATION==0
// Pion2 hors #if
void fou2(PIECE *wptr,PIECE_SET *psptr,char &mob_others, char &mob_prises, char &mobility2);
void tour2(PIECE *wptr,PIECE_SET *psptr,char &mob_others, char &mob_prises, char &mobility2, char &rook);
void cava2(PIECE *wptr,PIECE_SET *psptr,char &mob_others, char &mob_prises, char &mobility2);
void dame2(PIECE *wptr,PIECE_SET *psptr,char &mob_others, char &mob_prises, char &mobility2, char &rook);
void roi2(PIECE *wptr,PIECE_SET *psptr,char &mob_others, char &mob_prises, char &mobility2);
#endif
#if USE_BITBOARD_MOVE_GENERATION==1 || CHECK_MOVE_GENERATION_WITH_BITBOARDS==1
// Pion2 hors #if
void get_moves_CR(PIECE *wptr, PIECE_SET *psptr, char &mob_others, char &mob_prises); 
void get_moves_DTF(PIECE *wptr, PIECE_SET *psptr, char &mob_others, char &mob_prises);
#endif

void searchmove(PIECE *wptr);
#if USE_PIECES_ATTAQUEES==1 || USE_CASES_COUPS_FORCANTS==1 || USE_SEARCH_UNDEFENDED_PIECES==1
void maj_prise(PIECE* wptr, char arr64, char F_prise,char F_coup_forcant);
#endif

void actualise(MOVE move);
#if USE_CASES_ACTUALISATION==1
void subactualise_cases_echecs_roi(char dep_or_arr, bool F_case_possible_arrivee_cavalier);
bool F_piece_with_possibly_illegal_moves;
#endif
#if USE_CASES_ACTUALISATION==0
void subactualise(char arr, bool F_case_arrivee,char inc_dep_arr, bool F_do_knights);
#endif
void actualise_all(void);
void king_safety(char color01);
void maj_coordonnees_roi(char wtm);
void check_reset_state_values(char level, char reset);
#if DEGOGAGE_SYMETRIE_FONCTION_EVALUATION==1
short debogage_symetrie_fctn_eval(void);
#endif
void submajroque (
                        char wtm,
				char num,
				char dep,
				char arr,
			 	char tour,
				unsigned char &modify,
				char perte_droit_roque);

void maj_roque(MOVE move);					
void maj_indicateur_finale(void);
void eval_pawnstruct(void);
#if USE_PAWN_HASH_TABLE==1
void eval_pawnstruct2(void);
#endif
short roi_vs_roi(void);
short fctn_eval();
short calcul_centralisation_rois();
bool check_pat_with_lonely_king(char wtm);
CONTROLE_MATERIEL controle_materiel(void);
char bitScanForward_Clear(unsigned __int64 &bb);
char bitScanForward(unsigned __int64 &bb);
bool full_testcheck(char pos, char side_checked01);
bool limited_testcheck(MOVE move,char pos,char side_checked01);
bool testcheck_clouage(char wtm, char roi_pos, char dep);
//void inventaire_cases_protection(char wtm,char cible_pos);
//void sub_inventaire_cases_protection(char wtm, char cible_pos,char inc,
//		unsigned __int64 *cases_protection, unsigned __int64 *cases_interception);
//bool give_protection(char cible_pos, MOVE move);
char legal(char num,MOVE move, char roi, MOVE previous_move);
void inventaire_cases_echecs(char player, char roi_pos,char nat1,char inc);
void recherche_echec_pour_testcheck(char player, char roi_pos,char nat1,char inc);
void subcheckcava(char player,char roi_pos,char inc,bool &F_echec_cava);
bool givecheck_cavalier(char arr);
bool givecheck_pion(char arr, char wtm);
CHECKING_STATUS givecheck(const MOVE move, char other_wtm);
bool givecheck_roi(const MOVE move);
void verifier_echec_cavalier(char arr);
//void recherche_case_echec(char inc, char nat1);
#if CHECK_CHECKS==1
bool looklist(char *ptr, char arr);
void inventaire_cases_echecs2(void);
PIECE* check_analysis2(char level);
CHECKING_STATUS givecheck2(MOVE move);
void subcheckcava2(char player,char roi_pos,char inc,bool &F_echec_cava2);
void search_echecs_clouages_decouvertes2(char player,char roi_pos,char nat1,char inc);
char* recherche_case_echec2(char *ptr,char attacking_player,char roi_pos,char inc, char nat1);
#endif



};


#if defined MAIN
CIOManager uci_interface::IOManager;
char uci_interface::call_mode;
bool uci_interface::F_start_new_position;
//MOVE already_played_non_capture_moves[ALREADY_PLAYED_MOVES_BUFFER_SIZE];
// memset(already_played_non_capture_moves,0,sizeof(MOVE)*ALREADY_PLAYED_MOVES_BUFFER_SIZE);
char uci_interface::fenstring[100];
unsigned short uci_interface::buffer_iterator;
short uci_interface::command_iterator;
bool  uci_interface::F_command_being_given;
bool  uci_interface::F_setoption;
short uci_interface::nombre_max_commandes;
char  uci_interface::uci_char;
short uci_interface::uci_nombre_commandes;
bool uci_interface::F_new_startpos;
bool uci_interface::F_new_fenstring;
char uci_interface::fenstring_ep;
bool uci_interface::F_moves;
char uci_interface::dep; 
char uci_interface::arr;
char uci_interface::prom;
char uci_interface::special;
char uci_interface::num;
char uci_interface::prise_nat;
ENREGISTREMENT *uci_interface::rptr; // record
char uci_interface::cc;
char uci_interface::finale;
bool uci_interface::F_uci_commande_1;
bool uci_interface::F_uci_commande_2;
bool uci_interface::F_isready;
bool uci_interface::F_position_entered;
bool uci_interface::F_stop;
bool uci_interface::F_position_set_from_uci;
bool uci_interface::F_go, uci_interface::F_go_ponder;
char uci_interface::set_int_parameter;	 
char uci_interface::set_str_parameter;
long uci_interface::value;
bool uci_interface::F_suppress_bestmove_answer;
bool uci_interface::xopeningbook_in_use_mem;
short uci_interface::xnbcoups_mem;
char uci_interface::info_buffer[60+5*120+40];
CString uci_interface::uci_buffer;
char (*uci_interface::uci_commandes)[][UCI_COMMAND_SIZE+1];
char uci_interface::trace_location[50];
char uci_interface::uci_move[6]; // Ex : e7e8Q
bool parametres_globaux::xF_make_posval_finale;
char parametres_globaux::xF_roi_posx_mem[2];
#endif

//PREFIX checkclass *xcheckinstance;


