/* EXTEND (quiescence) 
- philosophie - assurer une valuation prcise
Analyse au dela du level max d'analyse prvu
Motifs d'extension :
- Niveau 0
  Passe passif pralable si passe_search ou passe_extend
- Niveau 1
  Coups figurant dans la table de transposition  
- Niveau 2
  Prises favorables - Promotions 
- Niveau 3 :
  Prises de pions favorables
- Niveau 4 :
  Echanges gaux
  Echecs, fourchettes et coups forants 
  Echecs : autres couvertures
- Niveau 12  
  Analyse12 en cas d'chec ( fuites du roi )
  ou aux niveaux 0 1 et 2 en cas d'absence de rponses aux menaces
- Lasker UCI 
  position startpos moves d2d4 f7f5 g1f3 g8f6 b1c3 e7e6 e2e4 f5e4 c3e4 f8e7 c1g5 e8g8 f1d3 b7b6 f3e5 c8b7 g5f6 e7f6 d1h5 d8e7
- Extend checks position fen 2br2k1/1p3ppp/p1p5/2P5/2PBp1qP/P1Q1P1P1/5P2/1R4K1 b - - 0 1

  Philosophie de gnration de coups
  On pourrait penser boucler sur les prises au niveau 2 (phase_generation==PRISES)
  et sur les autres coups au niveau 4 (phase_generation==AUTRES_COUPS) sans constituer de liste.
  Ce n'est pas la bonne solution car les prises dclasses doivent pouvoir tre joues en recherche d'checs
  ce qui suppose une analyse sous liste complte au niveau de la recherche d'checs
  Donc : on analyse toujours avec liste complte au niveau 4 et on limite cette liste aux prises au cas o l'on se situe 
  au dela de la limite des checs


  SEARCH (analyse exhaustive)
- philosophie : rduire l'arbre d'analyse
- pas de recherche des checs et des coups forants !
- Nullmove : niveau 0
- Coup figurant dans la table de transposition : niveau 1
  Coups heuristiques
  Prise pice dernier coup
- Coups heuristiques 2 : niveau 2
  Prises favorables
  Evasions
- ETC : niveau 3
- Echanges quilibrs hors prises par des pices de pions protgs par des pions : niveau 4
- Slection attaque pion : niveau 6
- Slection historique : niveau 7
- Slection position : niveau 8
- Coups calmes : niveau 9
- Prises par des pices de pions protgs par des pions
  et autres coups non rpertoris : niveau 11
- Coups en liste : niveau 12
  

Ceci suppose de rpertorier les coups avec prcision

catgorie 0 : Promotions, menaces de promotions, prises avantageuses
catgorie 4 : Echanges de pices
catgorie 5 : Echanges de pions
catgorie 7 : Prises de pions par des pices
catgorie 9 : Autres coups
catgorie 12 : Coups domins
*/

#include "stdafx.h"
#include "Cchess_1.h"
#include "Cchess_2.h"
#include "Move.h"
//#include "Cchess_3.h"
#include "Cchess_4.h"
#include "Cchess_5.h"
#include "Cchess_6.h"


// NO_EXTEND
#if NO_EXTEND==1
STATEVALUES *s;
LEVELVALUES *l;
short SEARCH::extend(
			 #if USE_EXTEND_NODE_PV==1
			 char node_type_original, 
			 #endif
			 short alpha, short beta,  MOVE received_hint_move, short valposmoins, short valuemoins,
			 char lmoins_check, char lmoins_nb_coups_liste,
			 bool F_received_try_anticipated_extend_cutoff
 			 #if NO_EXTENDLEVEL_CHECKS==0
			 ,char search_node_type
			 #endif
			)
{



//char player;
//short value, valpos;



player=TO_COLOR(xwtm);
xlevel++;
SET_MOVE_ROLE(xbest[xlevel][xlevel],LIGNE_END);
value=PLAYER(player,fctn_eval());
valpos=value;
dejouer(xligne[xlevel],1);
xlevel--;
return valpos;
}
#else
short SEARCH::extend(
			 #if USE_EXTEND_NODE_PV==1
			 char node_type_original, 
			 #endif 
			 short alpha, short beta,  MOVE received_hint_move, short valposmoins, short valuemoins,
			 char lmoins_check, char lmoins_nb_coups_liste,
 			 bool F_received_try_anticipated_extend_cutoff
 			 #if NO_EXTENDLEVEL_CHECKS==0
			 ,char search_node_type
			 #endif
			 )
{



//char nature;
char draw_status;
short lplus_value;
//char cc;
//bool Fsel;		// flag : a-t-on redescendu une ligne
//short int si;
MOVE move;
short alpha_transmis, beta_transmis;
char F_alphabeta_move;
short move_value;
short si1;

#if DEBUG==1
char i;
PIECE *wptr2;
char fstop;
#endif
char hash;
#if COLLECT_STATS==1
bool F_real_move_has_been_registered;
#endif
#if COLLECT_STATS==1
ORIGINE_COUPS_EXTEND origine_coup_retenu;
char nbplayed_before_best,nbplayed_before_best_2;
#endif
#if _DEBUG==1
char cc;
//char i;
LISTLEVEL *listmovesptr;
LISTLEVEL aliste;
listmovesptr=&aliste;
#endif
//short int si1;tacti


// Spcifiques extend
#if NO_EXTEND_HASH==0
short hscore;
char hscore_status;
char hash_depth_moins_level;
#endif
MOVE hmove;
H_CODE h;
//LEVELVALUES *l;
short lastprise2;
bool Ftoregister;
#if EXTEND_VERIFY_LINE==1
bool F_extend_allow_valpos_static_evaluation_mem;
#endif
	


//cc=0;
//cc=1/cc;

// Initialisations minimales
xlevel++;
wtm=xwtm;
finale=s->finale;
other_wtm=1-wtm;
roi_pos_other=s->roi_pos[other_wtm];
player=TO_COLOR(wtm);
num_roi=xnum_roi[wtm];

#if COLLECT_STATS==1
xvisites_extend++;
#endif
Fsel=false;
hint_move=received_hint_move;
#if COLLECT_STATS==1
F_real_move_has_been_registered=false; // A laisser car sinon risque de goto QUIT sans initialisation
#endif
#if COLLECT_STATS==1
origine_coup_retenu=OR_EXTEND_DEPART;
idxmove=0;
#endif
#if USE_HASH_TABLE==0 || NO_EXTEND_HASH==1
hmove=0;
#endif
#if _DEBUG==1
compteur_mem=xcompteur;
cc=0;
#endif
#if USE_EXTEND_NODE_PV==1
this->node_type=node_type_original;
#if TREAT_ALL_EXTEND_NODES_AS_PV==1
this->node_type=NODE_PV;
node_type_original=NODE_PV;
#endif
#endif
#if USE_EXTEND_NODE_PV==0
node_type=NODE_ALL;
#endif
#if USE_CASES_ACTUALISATION==1
#if USE_MATE_IN_ONE==1
F_case_de_mat=false;
#endif
#endif
#if ALLOW_SELECTIVE_CHECKS==1
F_selective_checks=false;
#endif
#if USE_MATE_DISTANCE_PRUNING==1
// Mate distance pruning
if (alpha<-MATE_VALUE+xlevel-1) 
{
	alpha=-MATE_VALUE+xlevel-1;
	if (alpha>=beta) 
	{
		Fsel=true;
		value=alpha;
		*best=LigneEnd;
		goto QUIT;
	}
}
// Si mat au niveau +1, value=MATE_VALUE-(xlevel+1)+1
if (beta>MATE_VALUE-xlevel) 
{
	beta=MATE_VALUE-xlevel;
	if (beta<=alpha) 
	{

		Fsel=true;
		value=alpha;
		*best=LigneEnd;
		goto QUIT;
	}
}
#endif
#if RECHERCHE_DECOUVERTES==1 && DECOUVERTES_ON_EXTEND==1
F_decouverte=false;
#endif
F_actualisation_done=false;
//max_capture_value=0;


#if DEBUG==1
wptr2=&xw[31];
for (i=31;i>=0;i--,wptr2--)
{
if (wptr2->nature==0) continue;
if (wptr2->nature=='P')
{
	ASSERT(bit(s->cases_pions[wptr2->color01],wptr2->pos));
}
else
{
	ASSERT(bit(s->cases_pieces[wptr2->color01],wptr2->pos));
}
}
#endif



// RLL2 - Recherche de ligne
#if _DEBUG==1
while(1)
{

if (MOVE_DEP88(xligne[1])!=73 || MOVE_ARR88(xligne[1])!=85) break;
if (MOVE_DEP88(xligne[2])!=77 || MOVE_ARR88(xligne[2])!=88) break;
if (MOVE_DEP88(xligne[3])!=31 || MOVE_ARR88(xligne[3])!=86) break;
if (MOVE_DEP88(xligne[4])!=47 || MOVE_ARR88(xligne[4])!=44) break;
if (MOVE_DEP88(xligne[5])!=61 || MOVE_ARR88(xligne[5])!=62) break;
if (xlevel<6) break;
if (MOVE_DEP88(xligne[6])!=68 || MOVE_ARR88(xligne[6])!=78) break;
if (xlevel<7) break;
if (MOVE_DEP88(xligne[7])!=85 || MOVE_ARR88(xligne[7])!=66) break;
if (xlevel<8) break;
if (MOVE_DEP88(xligne[8])!=78 || MOVE_ARR88(xligne[8])!=77) break;
if (xlevel<9) break;
if (MOVE_DEP88(xligne[9])!=66 || MOVE_ARR88(xligne[9])!=87) break;
if (xlevel<10) break;
if (MOVE_DEP88(xligne[10])!=44 || MOVE_ARR88(xligne[10])!=11) break;
if (xlevel<11) break;
if (MOVE_DEP88(xligne[11])!=43 || MOVE_ARR88(xligne[11])!=61) break;
if (xlevel<12) break;
if (MOVE_DEP88(xligne[12])!=88 || MOVE_ARR88(xligne[12])!=78) break;
if (xlevel<13) break;
if (MOVE_DEP88(xligne[13])!=87 || MOVE_ARR88(xligne[13])!=66) break;
if (xlevel<14) break;
if (MOVE_DEP88(xligne[14])!=78 || MOVE_ARR88(xligne[14])!=68) break;
if (xlevel<15) break;
if (MOVE_DEP88(xligne[15])!=86 || MOVE_ARR88(xligne[15])!=88) break;
if (xlevel<16) break;
if (MOVE_DEP88(xligne[16])!=68 || MOVE_ARR88(xligne[16])!=57) break;
if (xlevel<17) break;


/* LASKER
if (MOVE_DEP88(xligne[1])!=85 || MOVE_ARR88(xligne[1])!=87) break;
if (MOVE_DEP88(xligne[2])!=78 || MOVE_ARR88(xligne[2])!=87) break;
if (MOVE_DEP88(xligne[3])!=54 || MOVE_ARR88(xligne[3])!=66) break;
if (MOVE_DEP88(xligne[4])!=87 || MOVE_ARR88(xligne[4])!=86) break;
if (MOVE_DEP88(xligne[5])!=55 || MOVE_ARR88(xligne[5])!=74) break;
if (MOVE_DEP88(xligne[6])!=86 || MOVE_ARR88(xligne[6])!=75) break;
if (MOVE_DEP88(xligne[7])!=82 || MOVE_ARR88(xligne[7])!=84) break;
if (MOVE_DEP88(xligne[8])!=75 || MOVE_ARR88(xligne[8])!=64) break;
if (MOVE_DEP88(xligne[9])!=72 || MOVE_ARR88(xligne[9])!=73) break;
if (MOVE_DEP88(xligne[10])!=64 || MOVE_ARR88(xligne[10])!=63) break;
if (MOVE_DEP88(xligne[11])!=43 || MOVE_ARR88(xligne[11])!=52) break;
if (MOVE_DEP88(xligne[12])!=63 || MOVE_ARR88(xligne[12])!=72) break;
if (MOVE_DEP88(xligne[13])!=81 || MOVE_ARR88(xligne[13])!=82) break;
if (MOVE_DEP88(xligne[14])!=72 || MOVE_ARR88(xligne[14])!=71) break;
*/



//if (MOVE_DEP88(xligne[8])!=75 || MOVE_ARR88(xligne[8])!=64) break;
//if (MOVE_DEP88(xligne[9])!=72 || MOVE_ARR88(xligne[9])!=73) break;
//if (MOVE_DEP88(xligne[10])!=64 || MOVE_ARR88(xligne[10])!=63) break;



//if (MOVE_DEP88(xligne[8])!=75 || MOVE_ARR88(xligne[8])!=84) break;
//if (MOVE_DEP88(xligne[9])!=72 || MOVE_ARR88(xligne[9])!=73) break;
//if (MOVE_DEP88(xligne[10])!=84 || MOVE_ARR88(xligne[10])!=83) break;
//if (MOVE_DEP88(xligne[11])!=43 || MOVE_ARR88(xligne[11])!=61) break;
//if (MOVE_DEP88(xligne[12])!=27 || MOVE_ARR88(xligne[12])!=72) break;
//if (MOVE_DEP88(xligne[13])!=74 || MOVE_ARR88(xligne[12])!=62) break;


/*
if (MOVE_DEP88(xligne[11])!=43 || MOVE_ARR88(xligne[11])!=52) break;
if (MOVE_DEP88(xligne[12])!=63 || MOVE_ARR88(xligne[12])!=72) break;
if (MOVE_DEP88(xligne[13])!=81 || MOVE_ARR88(xligne[13])!=82) break;
if (MOVE_DEP88(xligne[14])!=72 || MOVE_ARR88(xligne[14])!=71) break;
if (MOVE_DEP88(xligne[15])!=51 || MOVE_ARR88(xligne[15])!=52) break;
*/

printf("\nLigne en %d",xcompteur);
//xlstop=xlevel;
//xstop4=true;
//fstop=true;
//getch();
break;
}
#endif




#if DEBUG==1
if (reactu_liste_nombre!=0)
	log_error("\nErr S_917", xcompteur,MAJOR);
#endif


// Maj_roque (avant actualise (roques))
maj_roque(*lignemoins);
ASSERT(!F_actualisation_done);

// Actualisation pawnstruct
if (MOVE_CHANGES_PAWNSTRUCT(*lignemoins))
{
		#if COLLECT_STATS==1
		xcompteur7++;
		#endif
		eval_pawnstruct();
}
// Actualisation liste des coups

#if DEBUG_ACTUALISE_ALL==1
actualise_all();
F_actualisation_done=true;
#endif


#if ANTICIPATE_EXTEND_CUTOFF==0
actualise(*lignemoins);
F_actualisation_done=true;
#endif

#if EXTEND_VERIFY_LINE==1
// Initialisation  xextendlevel xF_extend_allow_valpos_static_evaluation
if (xlevel==xextendlevel)
{
if (!xpasse 
	// Semble meilleur sans la condition dur NODE_PV !
	//&& node_type==NODE_PV
	&& xlevel>6
	)
	// En node_pv, on ne stocke pas valpos si suprieur  alpha
	{ xF_extend_allow_valpos_static_evaluation=false; }
else // node_all, nod_cut or xpasse
     // On peut stocker valpos
	{ xF_extend_allow_valpos_static_evaluation=true; }
}
// Stockage au level
// Ne pas aurtoriser au dela d'un certain level
if (xlevel>xextendlevel+10)
{ xF_extend_allow_valpos_static_evaluation=true; }
F_extend_allow_valpos_static_evaluation_mem=xF_extend_allow_valpos_static_evaluation;
F_play_non_tactical_moves=false;
#if _DEBUG==1
F_at_least_some_non_tactical_moves_played=false;
#endif
#endif



// Anticipation cutoff
#if ANTICIPATE_EXTEND_CUTOFF==1
// Pas besoin d'appeler la fonction d'valuation
// On ajoute  valposmoins la valeur de la capture prcdente 
// (qui tient compte d'une promotion ventuelle)
// mais normalement une telle situation n'est pas possible en extend
// du fait de la futilit (on analyse seulement les prises qui font passer au dessus de alpha)
// Et si on reste en dessous de alpha, il faut actualiser pour dterminer les prises
// Donc la plupart du temps, si on arrive en dessous de alpha, c'est qu'il y a chec
// et tous les tests sont inutiles puisqu'on actualise au final pour couvrir l'chec ...
// Tout ceci est donc en apparence inutile
// Reste le cas o on vient de search (c'est  dire xextendlevel)
// Dans ce cas, on peut arriver via un hint_move ou un killermove jou  depthtarget et qui choue, 
// en dessous de alpha
// En conclusion, le test n'est pas toujours utile et est inutile si on sait qu'il y a chec
// On le rserve donc aux cas ou xlevel==xextendlevel quand on ne prsume pas d'chec et que le dernier
// coup n'est pas tactique
if (!F_received_try_anticipated_extend_cutoff) goto ACTUALISE;
#if EXTEND_VERIFY_LINE==1
if (!F_extend_allow_valpos_static_evaluation_mem) goto ACTUALISE;
#endif
//#if USE_EXTEND_NODE_PV==1
//if (node_type==NODE_PV) goto ACTUALISE;
//#endif
// Attention : en l'absence du test !MOVE_IS_TACTICAL, dcommenter la ligne MOVE_CAPTURE_VALUE
// valpos n'est pas encore calcul
#if _DEBUG
short valeur_prise;
valeur_prise=MOVE_CAPTURE_VALUE(*lignemoins);
#endif

if (- (valposmoins
      +MOVE_CAPTURE_VALUE(*lignemoins)
	)
	// Cette marge tient compte du fait 
	// que notre mobilit a chang et est infrieure 
	// car nous avons une pice qui vient d'tre prise
	// C'est une marge faible
	// Le test suivant nous pargne
	// dans le cas ou on est pasen situation de cutoff
	// les tests d'checs que l'on doit faire 
	// si on envisage de ne pas actualiser
	-ANTICIPATE_EXTEND_CUTOFF_MARGIN
	#if ALLOW_BONUS_DESEQUILIBRE==1
      - BONUS_DESEQUILIBRE
	#endif
	 >=beta)
{
	//ASSERT(!(MOVE_IS_TACTICAL(*lignemoins)));
	// On actualise que s'il y a chec possible
	// Les cases de dpart et d'arrive sont forcment des cases d'chec possible
	// si il y a chec ou chec  la dcouverte 
	// La prise en passant peut prendre le pion couvrant un chec
	// Le roque peut mettre en chec sur la case de la tour
	//|| bit(xcases_arrivee_all[s->roi_pos[wtm]],MOVE_ARR64(*lignemoins))
    // Pour la case de dpart, les cases de dames suffisent
	// puisqu'il ne peut pas y avoir de dcouverte depuis une case de cavalier
	//|| bit(xcases_arrivee_dame[s->roi_pos[wtm]],MOVE_DEP64(*lignemoins))
	//|| bit(s->cases_echec_dame[1-wtm],MOVE_ARR64(*lignemoins))
	if (MOVE_IS_SPECIAL(*lignemoins))
	{ goto ACTUALISE; }
	else
	{
		// Vrification
		// Car en pratique tous les cas d'chec et de dcouverte
		// font qu'on n'essaye pas le cutoff anticip !
		switch(MOVE_NATURE(*lignemoins))
		{
		case 'P' : //if (bit(s->cases_echec_pion[other_wtm],MOVE_ARR64(*lignemoins)))
			       if (givecheck_pion(MOVE_ARR64(*lignemoins),other_wtm))
				   { goto ACTUALISE; }
				   break;
		case 'C' : if (bit(xcases_arrivee_cavalier[s->roi_pos[wtm]],MOVE_ARR64(*lignemoins)))
				   { goto ACTUALISE; }
				   break;
		case 'F' : if (bit(s->cases_echec_fou[other_wtm],MOVE_ARR64(*lignemoins)))
				   { goto ACTUALISE; }
				   break;
		case 'T' : if (bit(s->cases_echec_tour[other_wtm],MOVE_ARR64(*lignemoins)))
				   { goto ACTUALISE;}
				   break;
		case 'D' : if (bit(s->cases_echec_dame[other_wtm],MOVE_ARR64(*lignemoins)))
				   { goto ACTUALISE;}
				   break;
		case 'R' : break;
		}
	} 


	// Recherche d'une dcouverte possible
      // Quand une dcouvert est trouve au level-1,
	// on ne fait le cutoff anticip au level+1
	// En revanche, au dela de xextendlevel, les 
	// dcouvertes ne sont pas recherches
	// et il faut donc vrifier !
	if (bit(s->cases_echec_dame[other_wtm],MOVE_DEP64(*lignemoins)))
	{
	if (SEARCH::limited_testcheck(*lignemoins,s->roi_pos[wtm],wtm)==true)
	{
		goto ACTUALISE;
	}
	}
	

	#if _DEBUG
	// Vrification absence chec
	ASSERT(!full_testcheck(s->roi_pos[wtm],wtm));
	#endif

	// Calcul valpos (qui tient compte entre autres du nouveau pawnstruct)
	// et de l'change matriel qi vient d'avoir lieu 
	valpos=PLAYER(player,fctn_eval());
	if (valpos==0)
	{
		if (finale>=FIN_DE_PARTIE_2)
		{
			if (controle_materiel()==CONTROLE_MATERIEL::PARTIE_NULLE)
			{
				value=0;
				if (value>sup_alpha_value) sup_alpha_value=0;
				Fsel=true;
				*best=LigneEnd;
				goto QUIT;
			}
		}
	}

	if (valpos-ANTICIPATE_EXTEND_CUTOFF_MARGIN>=beta) 
	{
   		// Le plus direct sans fioriture
		value=valpos-ANTICIPATE_EXTEND_CUTOFF_MARGIN;
		Fsel=true;
		#if COLLECT_STATS==1
		xorigine_extend_essais[OR_EXTEND_PASSE_PASSIF]++;
		origine_coup_retenu=OR_EXTEND_PASSE_PASSIF;
		xorigine_extend_essais_total++;
		#endif
		*best=LigneEnd;
		goto QUIT;
	}
	else 
	{
		goto ACTUALISE;
	}
}
else // Actualisation normale 
{ 
	ACTUALISE:
	actualise(*lignemoins);
	F_actualisation_done=true;
}
#endif

/* Dbogage utile
ASSERT(!F_received_try_anticipated_extend_cutoff
	   || check!=0
	   || -(valposmoins+MOVE_CAPTURE_VALUE(*lignemoins))
	       -ANTICIPATE_EXTEND_CUTOFF_MARGIN
			<beta
		//|| MOVE_IS_TACTICAL(*lignemoins)
		);
si1=MOVE_CAPTURE_VALUE(*lignemoins);
si1=-(valposmoins+MOVE_CAPTURE_VALUE(*lignemoins))-ANTICIPATE_EXTEND_CUTOFF_MARGIN;
*/

// Echecs
//check=l->check; (variable de classe)
#if DEPRECIATE_CHECKS==1
if (s->finale>=FIN_DE_PARTIE_1)
{
	s->nb_checks[wtm]++;
}
#endif



// Calcul valpos, valposmat
// Peut tre important car la fonction d'valuation peut tre 
// sensible  l'actualisation des pices
// c'est en extend que cette actualisation est peut-tre
// la plus importante

// Valpos
valpos=PLAYER(player,fctn_eval()); 
if (valpos==0)
{
	if (s->finale>=FIN_DE_PARTIE_2 /* && check==0 non calcul  ce stade !! */)
	{
		if (controle_materiel()==CONTROLE_MATERIEL::PARTIE_NULLE)
		{
			Fsel=true;
			value=0;
			*best=LigneEnd;
			goto QUIT;
		}
	}
}

#if COLLECT_STATS==1
++xcompteur6;
#endif


#if EXTENDLEVEL_KILLERMOVE==1
extend_oldbest=*best;
#endif


// Anticipation passe passif avec lagage alpha-beta
if (check!=0)
{
Fsel=false;
// OK : -MAX_VALUE
value=-MAX_VALUE;
min_fail_low_value=-MAX_VALUE;
sup_alpha_value=alpha;
*best=0;
}
else
{

    // A-t-on le droit de stocker les valpos infrieurs ou gaux  alpha
    // Oui : la suite ne sera en aucun cas retenue
    // Pour mmoire c'est une zerowindow : ni alpha, ni beta ne sont window match
    // Cela ne change rien  la recherche qui est ralis entre sup_alpha_value et beta
    min_fail_low_value=inf(valpos, alpha);
	value=valpos;

	#if EXTEND_VERIFY_LINE==1
    // On ne stocke pas valpos dans ce cas
	if (valpos>alpha 
	     && F_extend_allow_valpos_static_evaluation_mem==false)
	{
		// Limiter value  alpha (fail-low)
		value=alpha;
		// rem au level : F_extend_allow_valpos_static_evaluation_mem
		xF_extend_allow_valpos_static_evaluation=true; // pour les levels suivants
		F_play_non_tactical_moves=true;
		// On va jouer tous les coups pour confirmer le score
		// Et si on revient en fail_high, tant mieux !
	}
	#endif

	if (value<min_fail_low_value) value=min_fail_low_value;
    Fsel=true;
	*best=LigneEnd;
	sup_alpha_value=sup(value,alpha);
	#if COLLECT_STATS==1
	xorigine_extend_essais[OR_EXTEND_PASSE_PASSIF]++;
	origine_coup_retenu=OR_EXTEND_PASSE_PASSIF;
	xorigine_extend_essais_total++;
	#endif
	if (value>=beta
		// N'apporte rien
		//#if USE_MATE_IN_ONE==1
		// && !F_case_de_mat
		//#endif
		)
    {
		// Ne doit pas intervenir au dela de xextendlevel si pas chec au niveau infrieur
		// ou rarement
		goto QUIT;
    }
}

// Suite initialisations aprs cutoff anticip
#if CHECK_CHECKS==1
char check2;
PIECE* chk_ptr2;
chk_ptr2=SEARCH::check_analysis2(s,xlevel);
check2=xchk_analysis2[xlevel];
if (check!=check2)
log_error("\nErr S_374",MAJOR);
#endif
#if CHECK_CHECKS==1
SEARCH::inventaire_cases_echecs2();
#endif
analysis=0; // pour les xreturn=true;
//listmoves=&xliste_level2[xlevel];


// Pointeurs paramtres au level



// Autres initialisations
if (hint_move==0)
{
if (s->F_node_is_former_PV)
{
	if (MOVE_IS_FOR_PLAY(xkeep[xlevel])
		// Prcaution pour ne pas prendre la suite 
		// enregistre en mode alternatif 
		// quand l'autre joeur joue
		&& xboard[MOVE_DEP64(xkeep[xlevel])].color01==xwtm
		)
	{
	hint_move=xkeep[xlevel];
	//hint_hscore=PLAYER(player,xlastvalue1); 
	}
}
}
this->alpha=alpha;

#if COLLECT_STATS==1
	if (beta==alpha+1)
		xcompteur_zerowindow++;
	else
		xcompteur_fullwindow++;
#endif

F_existe_coup_legal=false;
//fstop=false;
//idxmove=-1;
// Scurit indispensable en mod DEBUG==0
#if COLLECT_STATS==1
if (xlevel>xmaxlevel_reached) xmaxlevel_reached=xlevel;
#endif
hash=HASH_NON_DETERMINE;



/*
if (xcompteur%100000)
{
display_info_force((xbuffer,"\nLevel : %d", xlevel);
display_info_force(xbuffer);
sprintf(xbuffer,"\nxpasse : %d", xpasse);
display_info_force(xbuffer);
sprintf(xbuffer,"\nxanl_moins_un : %d", xanl[xlevel-1]);
display_info_force(xbuffer);
xm2ptr=&xligne[1];
strcpy(uci_interface::info_buffer, "");
for (;xm2ptr->code<100;xm2ptr++)
{
//#if DEBUG==0
if ( xm2ptr->code==77) break;
if ( xm2ptr->code==88) break;
//#endif
if ( xm2ptr->code==77 || xm2ptr->code==88) 
{
	strcat(uci_interface::info_buffer, " passe ");
	continue;
}
formatte_move_to_uci(xm2ptr, uci_interface::uci_move);
strcat(uci_interface::info_buffer, uci_interface::uci_move);
strcat(uci_interface::info_buffer, " ");
} // fin for
display_info_force(uci_interface::info_buffer);
}
*/




#if DEBUG==1
PIECE *wptr3;
CASE *cptr;
for(i=31;i>=0;i--)
{
wptr3=&xw[i];
if (wptr3->nature==0) continue;
if (xboard[wptr3->pos].num_piece!=i)
log_error("\nErr S_811",MAJOR);
}
for(i=63;i>=0;i--)
{
cptr=&xboard[i];
if (cptr->nature==0) continue;
if (cptr->wptr->nature==0 || cptr->wptr->pos!=i)
log_error("\nErr S_811",MAJOR);
}
#endif


// Contr"le intgrit matriel
#if DEBUG==1
si1=0;
wptr3=&xw[31];
for (i=31;i>=0;i--,wptr3--)
{
if (wptr3->nature==0) continue;
si1+=wptr3->value;
}
if (si1!=xstates[xlevel].materiel)
{
log_error("\nErr EX_119 en : %d",xcompteur,MAJOR);
}
#endif




// Contrle
#if DEBUG==1
cc=0;
cptr=&xboard[63];
for (i=63;i>=0;i--,cptr--)
{
if (cptr->wptr==&xwnull) continue;
if (cptr->wptr->pos!=i) cc=1;
if (cc==0) continue;
log_error("\nErreur E_701 en : %d", xcompteur,MAJOR);
}
#endif




// Contrle 
#if DEBUG==1
CONSOLE_MODE;
if (MOVE_ARR64(xligne[1])==165)
{
cc=0;
printf("\nstop");
getch();
}
END_MODE;
#endif


#if DEBUG==1
// Contr"le xlevel
if (xlevel>STMAX || xlevel>xdepthmax_struct) // levelmax des structures
{
log_error("\nErr EX_002",MAJOR);
}
#endif


// Contr"les divers
#if DEBUG==1
if (M_2097152(xcompteur)==0)
{
cptr=&xboard[63];
for (i=63;i>=0;i--,cptr--)
{
cc=0;
if (cptr->nature==0) continue;
if (cptr->wptr!=&xw[cptr->num_piece])
	log_error("\nErr EX_003 : %d",xcompteur,MAJOR);
break;
} // fin for
} // fin test
#endif





// Modification levelmax_echecs,levelmax_fourchettes,levelmax_prises_pions
//levelmax_prises_pions=99;
// 6 suffit pour le mat de Lasker

// MAJ levelmax_echec

// Avant, pour viter les embrouilles
levelmax_echecs=0;
#if EXTEND_XEXTENDLEVEL_CHECKS==1
// Plus simple
levelmax_echecs=xextendlevel;
#endif

#if USE_EXTEND_NODE_PV==1
#if EXTEND_XEXTENDLEVEL_CHECKS_ONLY_PV==1
if (node_type!=NODE_PV)
{
levelmax_echecs=0;
}
#endif
#if EXTEND_FORCE_CHECKS_ON_PV==1
if (node_type==NODE_PV)
{
levelmax_echecs=EXTEND_FORCE_CHECKS_ON_PV_LEVEL;
}
#endif


// Limitation des echecs au cas o il y a beaucoup d'extensions
// par exemple des extensions de pions
// 50% de plus que xlv1_depthtarget maximum
if (levelmax_echecs>xlv1_levelmax_echecs) levelmax_echecs=xlv1_levelmax_echecs;
#endif


#if ALLOW_EXTEND_SINGLE_MOVE_EXTENSION==1
F_extension_echecs=false;
if (lmoins_check!=0 && check==0)
{
	if (lmoins_nb_coups_liste<=1)
	{
		 levelmax_echecs=xextendlevel+100; 
		 F_extension_echecs=true;
	}
}
#endif

#if RECHERCHE_DECOUVERTES==1 && DECOUVERTES_ON_EXTEND==1
if (F_decouverte && check==0)
{
		 levelmax_echecs=xextendlevel+100; 
		 F_extension_echecs=true;
}
#endif



// Autorisation Echecs
// aprs le calcul des niveau maximum
#if NO_EXTEND_CHECKS==0 
if (   (
	 	check==0 
	 	&& xlevel<=levelmax_echecs
	 	&& s->finale==MILIEU_DE_PARTIE
	 )
	 || F_extension_echecs
    ) 
{
	if (
		 (s->materiel_dames[wtm]>0)
	    // Extensions d'checs quel que soit le level
		|| F_extension_echecs)
	{
		F_autorisation_echecs=true; 
	}
	else
	{
		F_autorisation_echecs=false; 
	}
}
else
{
	F_autorisation_echecs=false; 
}
#else
// Cas "NO_EXTEND_CHECKS"
	if (F_extension_echecs)
	{
		if (check==0 && xlevel<=levelmax_echecs) 
		{
			F_autorisation_echecs=true; 
		}
		else
		{
			F_autorisation_echecs=false; 
		}
	}
	else F_autorisation_echecs=false;
#endif


// Activation level AUTRES_COUP si 
// jeu des autres coups autoris
#if EXTEND_VERIFY_LINE==1
if (F_play_non_tactical_moves)
{
levelmax_echecs=99;
F_autorisation_echecs=true; // active le level AUTRES_COUPS
}
#endif



// Echecs selectifs
// Un seul chec slectif autoris
#if ALLOW_SELECTIVE_CHECKS==1 && NO_EXTEND_CHECKS==0
char color01;
PIECE *wptr;
char k;
F_selective_checks=false; 
// Un seul chec slctif autoris dans les variantes
if (!F_autorisation_echecs // Pas au level d'checs
#if LIMIT_SELECTIVE_CHECKS==1
	&& s->selective_checks[wtm]<AVAILABLE_SELECTIVE_CHECKS
#endif
	&& check==0) 
{
selective_checks_piece_flag=0;
selective_checks_arrival_squares=0;

// Il faut faire une boucle sur les pices
// C'est un cot important !

color01=xwtm;
wptr=&xw[0+((1-color01)<<4)];
// Boucle sur les pices amies
for (k=0+((1-color01)<<4);k<=xw_size[color01];k++,wptr++)
{
	maj_cases_de_fourchette_avec_echec(wptr);
}
if (F_selective_checks==true) 
{ 
	F_autorisation_echecs=true; 
}
}
#endif
// Voir si on peut donner des checs complmentaires
#if ALLOW_COMPLEMENTARY_CHECKS==1
check_filter='A';
if (!F_autorisation_echecs)
{
if (s->complementary_checks[wtm]<2)
{
if (s->complementary_check_status[other_wtm]=='T')
{
	if (s->cases_echec_tour[wtm]&(cases_controle_exclusif_tour|cases_controle_exclusif_dame))
	{
		check_filter='T';
		F_autorisation_echecs=true;
	}
}
if (s->complementary_check_status[other_wtm]=='F')
{
	if (s->cases_echec_fou[wtm]&(cases_controle_exclusif_fou|cases_controle_exclusif_dame))
	{
		check_filter='F';
		F_autorisation_echecs=true;
	}
}
}
}
#endif




// Contrle alpha < beta
#if DEBUG==1
if (alpha-beta>=0)
{
log_error("\nErr EX_031",MAJOR);
}
#endif


// Initialisation de la liste de coups
extend_initialize_move_generator();

// Cration de la liste d'emble si chec
// permet de dterminer le nombre de coups disponibles
if (check!=0)
{	
	if (!F_existe_coup_legal) 
	{
		ASSERT(nb_coups_liste==0);
		goto MAT;
	}
}
else if (F_pas_de_prises && !F_autorisation_echecs 
		 /*
		 #if USE_CASES_COUPS_FORCANTS==1
		 && !F_no_check_play_all_moves
		 #endif
		 */
		 )
{
	ASSERT(check==0);
	goto END_ANALYSIS;
}

//SEARCHSTART:


#if COLLECT_STATS==1
nbplayed_before_best=-1; // car il faut retrancher le premier coup
nbplayed_before_best_2=0;
#endif

#if COLLECT_STATS==1
F_real_move_has_been_registered=false;
#endif



// Boucle gnrale sur les coups
do
{
// Avant get_move (et get_move passera  false si ncessaire)
F_nextlevel_try_anticipated_extend_cutoff=true;

move=extend_get_move();

if (move==0) break;

/*
si1=MOVE_CAPTURE_VALUE(move);
if (si1>max_capture_value)
{
   max_capture_value=si1;
}
*/

// Initilisations
hash=HASH_NON_DETERMINE;


// Jeu du coup slectionn
// *********************** //

#if _DEBUG==1
listmovesptr->dep88=MOVE_DEP88(move);
listmovesptr->arr88=MOVE_ARR88(move);
cc=0;
#endif

// Arrt xstopm
#if DEBUG!=0
if (xcompteur==xstopm)
{
log_error("\nstop : %d",xcompteur,MAJOR);
}
#endif
#if COLLECT_STATS==1
xlevel_hits[xlevel]++;
if (!xpb_explo)
{
xaverage_level+=xlevel;
xaverage_level_num++;
}
xcompteur_extend++;
#if ALLOW_NULLMOVE==1
if (xpasse) xcompteur_searchpasse++;
#endif
#endif


// Mmorisation du coup jou
// ici et non dans jouer ... cause de ligne
*ligne=move;
#if _DEBUG
		xligne2[xlevel].level=xlevel;
		xligne2[xlevel].color01=xwtm;
		xligne2[xlevel].dep88=MOVE_DEP88(move);
		xligne2[xlevel].arr88=MOVE_ARR88(move);
		xligne2[xlevel+1].level=xlevel+1;
		xligne2[xlevel+1].color01=1-xwtm;
		xligne2[xlevel+1].dep88=99;
		xligne2[xlevel+1].arr88=99;
#endif


// Test de scurit - ... conserver
#if DEBUG==1
cc=0;
num=MOVE_NUM_PIECE(move);
if (xboard[MOVE_DEP64(move)].num_piece!=num) cc=1;
if (MOVE_DEP64(move)!=xw[num].pos) cc=1;
if (cc==1)
{
log_error("\nErr EX_011",MAJOR);
}
#endif





// Jeu
xcompteur++; if (check_time_and_keyboard_for_return())
{ goto QUIT;}


#if COLLECT_STATS==1
xorigine_extend_essais[origine_coups_analysis_extend]++;
xorigine_extend_essais_total++;
#endif
(*s_plus)=(*s); // Avant jouer
#if DEBUG==1
si1=MOVE_NUM_PIECE(move);
cc=1;
#endif


#if COLLECT_STATS==1
xnodes_extend++;
#endif

/*
ASSERT(   dep==MOVE_DEP64(move) 
	   && arr==MOVE_ARR64(move)
	   && (num==MOVE_NUM_PIECE(move)||MOVE_IS_PASSE(move))
	   );
*/
next_search_level->jouer(move);
// Obtention hash_code avant recherche des rptitions
// et recherche en hash_table
h=gen_code(true);



#if DEBUG==1
wptr2=&xw[31];
for (i=31;i>=0;i--,wptr2--)
{
if (wptr2->nature==0) continue;
if (wptr2->nature=='P')
{
	ASSERT(bit(s_plus->cases_pions[wptr2->color01],wptr2->pos));
}
else
{
	ASSERT(bit(s_plus->cases_pieces[wptr2->color01],wptr2->pos));
}
}
#endif



#if DEBUG==1
// RLL - Recherche de ligne
*ligne=move;
while(1 && xextendlevel==2)
{

if (MOVE_DEP88(xligne[1])!=85 || MOVE_ARR88(xligne[1])!=87) break;
if (MOVE_DEP88(xligne[2])!=78 || MOVE_ARR88(xligne[2])!=87) break;
if (MOVE_DEP88(xligne[3])!=54 || MOVE_ARR88(xligne[3])!=66) break;
if (MOVE_DEP88(xligne[4])!=87 || MOVE_ARR88(xligne[4])!=86) break;
if (MOVE_DEP88(xligne[1])!=85 || MOVE_ARR88(xligne[1])!=87) break;
if (MOVE_DEP88(xligne[2])!=78 || MOVE_ARR88(xligne[2])!=87) break;
if (MOVE_DEP88(xligne[3])!=54 || MOVE_ARR88(xligne[3])!=66) break;
if (MOVE_DEP88(xligne[4])!=87 || MOVE_ARR88(xligne[4])!=86) break;
if (MOVE_DEP88(xligne[5])!=55 || MOVE_ARR88(xligne[5])!=74) break;
if (MOVE_DEP88(xligne[6])!=86 || MOVE_ARR88(xligne[6])!=75) break;
if (MOVE_DEP88(xligne[7])!=82 || MOVE_ARR88(xligne[7])!=84) break;
if (MOVE_DEP88(xligne[8])!=75 || MOVE_ARR88(xligne[8])!=64) break;
if (MOVE_DEP88(xligne[9])!=72 || MOVE_ARR88(xligne[9])!=73) break;
if (MOVE_DEP88(xligne[10])!=64 || MOVE_ARR88(xligne[10])!=63) break;
if (MOVE_DEP88(xligne[11])!=43 || MOVE_ARR88(xligne[11])!=52) break;
if (MOVE_DEP88(xligne[12])!=63 || MOVE_ARR88(xligne[12])!=72) break;
if (MOVE_DEP88(xligne[13])!=81 || MOVE_ARR88(xligne[13])!=82) break;
if (MOVE_DEP88(xligne[14])!=72 || MOVE_ARR88(xligne[14])!=71) break;
//break;
//if (xlevel<15) break;


/* LASKER
if (MOVE_DEP88(xligne[1])!=85 || MOVE_ARR88(xligne[1])!=87) break;
if (MOVE_DEP88(xligne[2])!=78 || MOVE_ARR88(xligne[2])!=87) break;
if (MOVE_DEP88(xligne[3])!=54 || MOVE_ARR88(xligne[3])!=66) break;
if (MOVE_DEP88(xligne[4])!=87 || MOVE_ARR88(xligne[4])!=86) break;
if (MOVE_DEP88(xligne[5])!=55 || MOVE_ARR88(xligne[5])!=74) break;
if (MOVE_DEP88(xligne[6])!=86 || MOVE_ARR88(xligne[6])!=75) break;
if (MOVE_DEP88(xligne[7])!=82 || MOVE_ARR88(xligne[7])!=84) break;
if (MOVE_DEP88(xligne[8])!=75 || MOVE_ARR88(xligne[8])!=64) break;
if (MOVE_DEP88(xligne[9])!=72 || MOVE_ARR88(xligne[9])!=73) break;
if (MOVE_DEP88(xligne[10])!=64 || MOVE_ARR88(xligne[10])!=63) break;
if (MOVE_DEP88(xligne[11])!=43 || MOVE_ARR88(xligne[11])!=52) break;
if (MOVE_DEP88(xligne[12])!=63 || MOVE_ARR88(xligne[12])!=72) break;
if (MOVE_DEP88(xligne[13])!=81 || MOVE_ARR88(xligne[13])!=82) break;
if (MOVE_DEP88(xligne[14])!=72 || MOVE_ARR88(xligne[14])!=71) break;
*/


sprintf(xbuffer, "\nValeur reperee --------------------------- : %d ", valpos);
display_info_force(xbuffer);
sprintf(xbuffer, "\nScore %d ", xstates[xlevel].materiel);
display_info_force(xbuffer);
sprintf(xbuffer, "\nDames %d ", xstates[xlevel].materiel_dames[1]);
display_info_force(xbuffer);
sprintf(xbuffer, "\nLevel : %d xcompteur : %d", xlevel, xcompteur);
display_info_force(xbuffer);
break;
}
#endif






// Contr"le intgrit matriel
// (aprs l'affichage du coup - gain de temps)
#if DEBUG==1
si1=0;
wptr=&xw[31];
for (i=31;i>=0;i--,wptr--)
{
if (wptr->nature==0) continue;
si1+=wptr->value;
}
if  (si1!=s_plus->materiel)
{
log_error("\nErr EX_019 en : %d",xcompteur,MAJOR);
}
#endif



// Arrt xstopm
#if DEBUG==1
CONSOLE_MODE
if (xcompteur==xstopm)
{
printf("\nstop : %d",xcompteur);
getch();
}
cc=0; // pour avoir un next statement de dbogage !
END_MODE;
#endif


// Affichage
#if DEBUG==1
CONSOLE_MODE;
if (xstop3) affichage(xligne[1],analysis);
if (xstop3) affiche_ligne(&xligne[1],0);
END_MODE;
#endif



/*
if ( 1==1 
	//&&       xlevel==2
    && xligne[1].move->dep==15
	&& xligne[1].move->arr==14
    && move->dep==34
	&& move->arr==52
   )
{
sprintf(xbuffer,"\nHash %d", hash);
display_info_force(xbuffer);
sprintf(xbuffer,"\ndepth_moins_level %d", xhash_depth_moins_level);
display_info_force(xbuffer);
sprintf(xbuffer,"\nxnbcoups+xlevel %d", xnbcoups+xlevel);
display_info_force(xbuffer);
}
*/


// Maj pour rptition
// Rgle des 50 coups et rptitions
// mise  jour lastprise2
// Test jeu pion
if (MOVE_CHANGES_LASTPRISE(move))
{
s_plus->lastprise2=xnbcoups+xlevel;
}
// Rcupration lastprise2
lastprise2=s_plus->lastprise2;

// Copie du coup dans la xliste50
if (xnbcoups-xlastprise1+xlevel<STMAX+2+100)
// ( test de scurit )
{
xliste50[xnbcoups-xlastprise1+xlevel]=h;
}


// Rinitialisation flag draw
if (MOVE_IS_CAPTURE(move))
	 draw_status=NOT_DRAW;
else if (MOVE_IS_PAWN(move))
	 draw_status=NOT_DRAW;
else 
{
draw_status=DRAW_STATUS_NOT_DETERMINED;

// Test 50 coups
// lastprise est un coup enregistr, mais qui ne compte pas pour les 50
// l'valuation est faite en level n+1, alors qu'aucun coup n'a encore
// t jou. Au total, level-1 coups ont t jous en analyse
// le test est fait ici afin que le coup soit jou, enregistr,
// et que value[level] soit mis ... jour par la procdure normale
// Note : lastprise2 a t mis ... jour et donc le cas o- le coup jou
// pourrait tre un coup de pion ou une prise
#if DEBUG==1
if (lastprise2<xlastprise1 || lastprise2>xnbcoups+xlevel)
{
log_error("\nErreur E_705 en : %d", xcompteur,MAJOR);
}
#endif
if (xnbcoups-lastprise2+xlevel>=100) // (on vient de jouer le 100ime)
{
// Attention : il ne faut pas qu'il y ait mat sur le 50ime coup
// Il faudrait en toute rigueur tester qu'il n'y a pas mat
// En effet, le 100ime coup peut tre un chec avec application de la rgle
// et le 101ime une prise par le roi adverse ou un mat
// Il y a donc un petit risque (parmi d'autres risques) de rater une suite nulle
// si le 100 ime coup est un chec
// Ce test est tout de mme utile
// Si on ne le fait pas, noir joue un coup numro 99
// blanc joue ensuite un mat en 1 qui serait valu "Nulle 50 coups"
// Ce problme n'est rellement un problme essentiellement qu'en SEARCHROOT
// car le risque est de dclarer nulle un MAT sur le 100 ime coup
// On ne fait donc le test qu'en searchroot et search
// PAS EN EXTEND
// if (!SEARCH::limited_testcheck(move,xw[xnum_roi[other_wtm]].pos, other_wtm))
{
lplus_value=-(0);
*bestplus=LigneEndDraw50;
alpha_transmis=alpha;
beta_transmis=beta;
next_search_level->dejouer(*ligne,0);
draw_status=RULE_50_MOVES_DRAW;
#if COLLECT_STATS==1
origine_coup_retenu=OR_EXTEND_DRAW;
xorigine_extend_essais[origine_coup_retenu]++;
xorigine_extend_essais_total++;
#endif
goto EVALUATION;
}
}

// Test rptition
draw_status=fct_repetition(move,h,lastprise2);
#if CHECK_REPET==1 && DEBUG==1
// Rptition de coups
// Copie de la position
// Ne reconnat pas les permutations de pices
ptr=&xpositions[xnbcoups-xlastprise1+xlevel][0];
wptr2=&xw[31];
for (ci1=31; ci1>=0;ci1--,wptr2--,ptr++)
{
if (wptr2->nature==0) { *ptr=0; continue; }
*ptr=wptr2->pos;
}
dd=fct_repetition2(move,lastprise2);
if (listmovesptr->draw_status!=dd)
{
printf("\nPb - Search_Repet");
getch();
}
#endif


// Rptition
if (draw_status==REPETITION_DRAW)
{
// Attention : il n'y a enregistrement que si la suite est retenue
alpha_transmis=alpha;
beta_transmis=beta;
lplus_value=0;
*bestplus=LigneEndDrawRepetition;
//listmovesptr->draw_status=REPETITION_DRAW;
next_search_level->dejouer(*ligne,0);
#if COLLECT_STATS==1
origine_coup_retenu=OR_EXTEND_DRAW;
xorigine_extend_essais[origine_coup_retenu]++;
xorigine_extend_essais_total++;
#endif
//F_no_hashtable_store=true;
goto EVALUATION;
}
} // fin MOVE_IS_NOT_CAPTURE

// Calcul hash et recherche hash
//if (!F_do_not_trust_hash_table)
{
#if NO_EXTENDLEVEL_HASH_HIT==1
if (xlevel>xextendlevel)
{
#endif
#if DEBUG==1
if (xcompteur%40000==0)
{
	H_CODE h2;
	h2=gen_code(false);
	if (h2.address!=h.address || h2.key!=h.key)
		log_error("Ex_614",MAJOR);
}
#endif
#if USE_HASH_TABLE==1
#if NO_EXTEND_HASH==0
hash=get_hash(h,0,
			  hash, 
			  hmove, 
			  hscore, 
			  hscore_status,
			  hash_depth_moins_level,
		      NODE_ALL
			  #if HASH_TRACK_PV==1
			  ,NODE_ALL
			  #endif			  
			  );
#endif
#endif
#if NO_EXTEND_HASH==1
hash=HASH_MISS;
#endif

//F_get_hash=true; // flag calcul hash 
#if NO_EXTENDLEVEL_HASH_HIT==1
}
else
{
hash=HASH_MISS;
//F_get_hash=true; // flag calcul hash 
}
#endif
}


// Utilisation hash 
// aprs recherche nulles
// Note : on peut considrer que hash==1 si
// le coup ne vas pas tre enregistr, c'est  dire pas remont ou si
// il doit provoquer un lagage alpha-beta.
// Cas :
// - xhscore >= beta avec xhscore upper bound (F_alphabeta_move=FAIL_HIGH)
// - xhscore <= alpha avec xhscore lower bound (F_alphabeta_move=FAIL_LOW)
#if USE_HASH_TABLE==1
#if NO_EXTEND_HASH==0
#if ALLOW_HASH_TRANSFORM==1
if (hash==HASH_FAIL_BOUNDS  
	//&& Fsel==false
	)
{
if (hscore_status==FAIL_LOW) // lower bound
{
if (hscore<=sup_alpha_value)
	{
		hash=HASH_TRANSFORM; // Finalement OK
	}
}
else if (hscore_status==FAIL_HIGH) // upper bound
{
if (hscore>=beta) 
{
	hash=HASH_TRANSFORM; // Finalement OK si lagage F_alphabeta_move
}
}
} // fin hash==HASH_FAIL_BOUNDS
#endif

if (hash==HASH_HIT || hash==HASH_TRANSFORM)
{
// Mise  jour statistiques de hits
#if COLLECT_STATS==1
xhhits++;
xhhits_level[xlevel]++;
#endif
lplus_value=-hscore;
alpha_transmis=alpha;
beta_transmis=beta;
#if _DEBUG==0
if (lplus_value>valuemoins)
#endif
{
if (hmove!=0) 
{
// Il faut enregistrer le 112 au dela de bestplus
// sinon le coup n'est pas affich
xbest[xlevel+1][xlevel+2]=LigneEndHashTable; // Hash
*bestplus=hmove;
}
else 
{
*bestplus=LigneEndHashTable;
}
}
next_search_level->dejouer(*ligne,0); // Attention ne pas mettre actu  1
goto EVALUATION;
}
#endif
#endif


// Contr"le de dpassement du levelmax
if (xlevel>=xdepthmax_struct)
{

// Evaluation en levelmax
xstates_mem=(*s); //  cause de maj_roque au level
maj_roque(move); // ncessaire
lplus_value=-PLAYER(player,next_search_level->fctn_eval());
(*s)=xstates_mem;

#if COLLECT_STATS==1
xcompteur6++; // nombre d'appels terminaux ... la fonction d'valuation
xlevel_hits[xlevel]++; 
#endif

// Obligation de djouer (levelmax)
next_search_level->dejouer(*ligne,0);


// Mise ... jour best
if (-lplus_value > value) // strict
{
value=-lplus_value;
if (value>sup_alpha_value) sup_alpha_value=value;
// Pas de copiebest car levelmax
#if _DEBUG==0
if (lplus_value>valuemoins)
#endif
{
Fsel=true;
(*best)=(*ligne);
*(best+1)=LigneEndLevelMax;
#if _DEBUG==1
xda[xlevel][xlevel+1].dep88=99;
xda[xlevel][xlevel+1].arr88=99;
#endif
}

#if COLLECT_STATS==1
origine_coup_retenu=origine_coups_analysis_extend;
#endif

// Elagages

// Elagage alpha-beta
if (value>=beta)
{
#if COLLECT_STATS==1
xelag_ex_alpha_beta_5++;
#endif
goto QUIT;
}

} // fin mise  jour best
} // fin levelmax


// Passage au level suprieur


else // level <15 (STMAX=15)
{

#if ALLOW_SELECTIVE_CHECKS==1
#if LIMIT_SELECTIVE_CHECKS==1
// S'agit-il d'un chec complmentaire
if (F_selective_checks)
{
ASSERT(check==0);
{
if (analysis==EXTEND_ANALYSE_ECHECS) // donc donne chec
{
    s_plus->selective_checks[wtm]++;
}
}
}
#endif
#endif
#if ALLOW_COMPLEMENTARY_CHECKS==1
// S'agit-il d'un chec complmentaire
if (check==0)
{
if (analysis==EXTEND_ANALYSE_AUTRES_COUPS) // donc donne chec
{
if (check_filter!='A')
{
    s_plus->complementary_checks[wtm]++;
}
}
}
#endif



// PVS Principal Variation Search

// Transmission alpha-beta
// et gestion du mode try_zerowindow

alpha_transmis=sup_alpha_value;
beta_transmis=beta;
	


#if DEBUG==1
if (alpha_transmis>beta_transmis) 
log_error("\nE_2345",MAJOR);
#endif


// Extend
lplus_value=next_search_level->extend(
				#if USE_EXTEND_NODE_PV==1
				node_type,
				#endif
				-beta_transmis,-alpha_transmis,hmove,valpos,value,
				check, nb_coups_liste,
	 			F_nextlevel_try_anticipated_extend_cutoff
			    #if NO_EXTENDLEVEL_CHECKS==0
				,search_node_type
				#endif
			); 
#if _DEBUG==1
cc=0;
#endif

//ASSERT(!(F_case_de_mat && check==0 && -next_search_level->value<beta && -next_search_level->value<MATE_VALUE_THRESHOLD));



EVALUATION:



#if DEBUG==1
CONSOLE_MODE;
fstop=0;
if (fstop==1)
{
log_error("\nLigne en %d",xcompteur,MAJOR);
getch();
}
if (xlevel<=xlstop && xstop4)
{
printf("\n");
if (!SAME_MOVE(move,NullMove))
{
affiche ((char) MOVE_DEP88(*ligne));
affiche ((char) MOVE_ARR88(*ligne));
}
else printf("Null");
printf(" >> stop level %d", (short) xlevel);
if (xretry) printf("R");
printf(" Anl-%d",(short) analysis); 
printf(" : %d",xcompteur);
printf("   xvalue : %d / %d",PLAYER(player,-lplus_value),PLAYER(player,value));
getch();
}
END_MODE;
#endif

if (xreturn) { value=valpos; goto QUIT; }

// Positionnement du flag Falphabeta 
// et ajustement de la valeur du coup
// En extend, on ramne les fail_high et low
// aux bornes
// En effet, il arrive que certains coups ne soient pas jous
// et la valeur fail_low n'est alors pas un minorant de la valeur relle
// alpha est par contre un minorant certain
// idem pour les fail_high

// Equivalent   : if (value<=alpha) // Alpha
if ( -lplus_value<=alpha_transmis ) 
    { 
	  F_alphabeta_move=FAIL_LOW; 
      //move_value=alpha_transmis;
	  move_value=-lplus_value;
    } 
// Equivalent   : if (value>beta) // Beta
else if ( -lplus_value>=beta_transmis ) 
	{ 
		F_alphabeta_move=FAIL_HIGH; 
		//move_value=beta_transmis;
		move_value=-lplus_value;
    }
else 
    {
		F_alphabeta_move=WINDOW_MATCH;
		move_value=-lplus_value;
    }

// Collecte stats before best
#if COLLECT_STATS==1
nbplayed_before_best_2++;
#endif


// Enregistrement
if (move_value>value/* || !Fsel superflu */)
{
Ftoregister=true;
// ici aussi on prend les fail_low (mais on ne redescend pas la ligne !)
}
else Ftoregister=false;



// Enregistrement en hash tables
// ( indpendant de l'enregistrement ventuel du coup )
// Aprs dtermination du flag alpha_beta
// Avant lagage
// Remarque : 
// si hash != HASH_HIT et HASH_TRANSFORM
// le programme a cherch et on peut enregistrer
#if USE_HASH_TABLE==1
#if NO_EXTEND_HASH==0
#if NO_PUT_HASH_ON_FAIL_LOW==1
if (F_alphabeta_move==WINDOW_MATCH)
{
#endif
if (	      hash!=HASH_HIT 
	   && hash!=HASH_TRANSFORM
	   //&& !F_no_hashtable_store
    )
{
    // Ne pas enregister les score DRAW qui ne sont pas fiables
	ASSERT(draw_status!=draw_status==DRAW_STATUS_NOT_DETERMINED);
    if (draw_status==NOT_DRAW)
    {
		put_hash(h,move_value,ENTREE_HASH_EXTEND,F_alphabeta_move,*bestplus
  		    #if HASH_TRACK_PV==1
			,NODE_ALL
			#endif			  
			); 
	}
    #if HASH_TRACE==1
    hashtrace(h);
    #endif
}
#if NO_PUT_HASH_ON_FAIL_LOW==1
}
#endif
#endif
#endif



// Enregistrement suite 
if (Ftoregister)
{
#if COLLECT_STATS==1
if (MOVE_IS_FOR_PLAY(move)) F_real_move_has_been_registered=true;
#endif+
Fsel=true;
value=-lplus_value; // pas move_value
// Copie de la meilleure ligne du level+1
// (ligne analyse aprs le coup ligne[level]
if (value>alpha) sup_alpha_value=value;
(*best)=(*ligne); // de toute faon
Fsel=true;
#if _DEBUG==0
if (lplus_value>valuemoins)
#endif
//{ copiebest(F_alphabeta_move); }
{ copiebest(); }
#if EXTEND_VERIFY_LINE==1
if (F_play_non_tactical_moves 
	 && value>alpha && value>=valpos)
{

	// Ne pas majorer le score
	// Non finalement : if (value>beta && value>valpos) value=valpos;

	// Si extension d'echecs
	if (F_extension_echecs)
	{
		//Poursuivre l'extension d'checs stricto sensu
		F_play_non_tactical_moves=false;
		// Mais reste en marqueur  :
		// F_some_non_tactical_moves_played;
	}
	else
	{
		// Inutile de poursuivre
		#if EXTEND_XEXTENDLEVEL_CHECKS==1
		if (xlevel==xextendlevel)
		{
			// Poursuivre sur le level d'checs
			F_play_non_tactical_moves=false;
		}
		else
		#endif
		{
			// Inutile de poursuivre car on a 
			// un coup satisfaisant !
			goto QUIT;
		}
	}
}
#endif

#if COLLECT_STATS==1
origine_coup_retenu=origine_coups_analysis_extend;
nbplayed_before_best+=nbplayed_before_best_2;
nbplayed_before_best_2=0;
#endif

/*
do {
cc=1;
do {
if ( xlevel>10) {cc=0;break;}
if (xbest[xlevel][10].move->dep!=75 || xbest[xlevel][10].move->arr!=48) cc=0;
if (xlevel==10) break;
if (xbest[xlevel][9].move->dep!=47 || xbest[xlevel][9].move->arr!=48) cc=0;
if (xlevel==9) break;
if (xbest[xlevel][8].move->dep!=27 || xbest[xlevel][8].move->arr!=22) cc=0;
if (xlevel==8) break;
if (xbest[xlevel][7].move->dep!=46 || xbest[xlevel][7].move->arr!=47) cc=0;
if (xlevel==7) break;
if (xbest[xlevel][6].move->dep!=57 || xbest[xlevel][6].move->arr!=27) cc=0;
if (xlevel==6) break;
if (xbest[xlevel][5].move->dep!=45 || xbest[xlevel][5].move->arr!=46) cc=0;
if (xlevel==5) break;
if (xbest[xlevel][4].move->dep!=66 || xbest[xlevel][4].move->arr!=54) cc=0;
if (xlevel==4) break;
if (xbest[xlevel][3].move->dep!=26 || xbest[xlevel][3].move->arr!=36) cc=0;
if (xlevel==3) break;
if (xbest[xlevel][2].move->dep!=58 || xbest[xlevel][2].move->arr!=68) cc=0;
if (xlevel==2) break;
if (xbest[xlevel][1].move->dep!=12 || xbest[xlevel][1].move->arr!=13) cc=0;
break;
} while (1);
if (cc==0) break;
cout << "\n Level retour : " << (short) xlevel << " " << xcompteur;
cout << "\n" << alpha << " " << value << " " << beta;
break;
} while (1);
*/



// Elagages 
// Remarque IMPORTANTE
// on ne teste les lagage que s'il vient 
// d'y avoir un enregistrement
// Sinon c'est inutile

// Elagage alpha-beta
if (F_alphabeta_move==FAIL_HIGH) // calcul ci-dessus
{
#if COLLECT_STATS==1
xelag_ex_alpha_beta_5++;
#endif
goto QUIT;
}



#if ALLOW_EXTEND_ELAGAGE_SUITE_FAVORABLE==1
// Elagage suite favorable
// Induit un biais ( on peut valuer une suite  +300
// alors qu'il y a un mat )
// mais quand la suite sera joue en search plutt qu'en extend 
// la distinction sera effectue
// Cette valuation est faite ds la premire suite rencontre
if ( value-PLAYER(player,xlastvalue0)>300
     // il ne faut pas que le gain empche de repasser en positif
     && value>250   
   ) 
{
#if COLLECT_STATS==1
xelag_ex_suite_favorable_1++; 
#endif
goto QUIT;
}
#endif


} // fin Enregistrement Ftoregister


} // fin du else level<=15 (15=STMAX)


continue; 
} while(1); // fin du do
// fin de l'tude des coups
// FIN ANALYSE

END_ANALYSIS:


// Quid si aucune suite slectionne
/*
 1 : MAT
 2 : PAT
*/

if (!Fsel)
{
if (check!=0)
{
#if DEBUG==1
if (nb_coups_liste!=0 || F_existe_coup_legal)
	log_error("\nEx_385", xcompteur,MAJOR);
#endif
if (!F_existe_coup_legal) // Sinon ne rien faire
{
MAT:
// MAT

// Mat
// MAX_VALUE pour permettre la recopie de la ligne de jeu gagnante
// -level pour forcer le mat immdiat en MAX_VALUE
Fsel=true;
value=-MATE_VALUE+xlevel-1;
*best=LigneEndMat;
#if _DEBUG==1
xda[xlevel][xlevel].dep88=99;
xda[xlevel][xlevel].arr88=99;
#endif
sup_alpha_value=sup(alpha,value);

#if COLLECT_STATS==1
origine_coup_retenu=OR_EXTEND_MAT;
xorigine_extend_essais[origine_coup_retenu]++;
xorigine_extend_essais_total++;
#endif
goto QUIT;
}
else 
log_error("\nEx_471",MAJOR);
} // fin mat 


// PAT
// PAS DE DETECTION DU PAT EN EXTEND !!!!!!
// TOUS LES COUPS NE SONT PAS JOUES !!
/*
PAT:
if (check==0)
{
if (!F_existe_coup_legal) // dtection du PAT
{

#if DEBUG==1
if (F_creation_liste)
{
// Vrification absence de coup lgal
listmovesptr=listmovesptr=&(*listmoves)[0]-1;
while ( (++listmovesptr)->move!=0 )
{
if ( listmovesptr->legal==ILLEGAL ) continue;
cc=legal(s,listmovesptr->move,num_roi,*lignemoins);
if ( F_existe_coup_legal )
{
	log_error("Err Ex_235", xcompteur,MAJOR);
	break; 
}
}
}

#endif


if (!F_existe_coup_legal)
{
value=0;
Fsel=true;
*best=LigneEndPat;
#if _DEBUG==1
xda[xlevel][xlevel].dep88=99;
xda[xlevel][xlevel].arr88=99;
#endif
if (value>sup_alpha_value) sup_alpha_value=value;
if (xlevel==1) xregister1=true;
#if COLLECT_STATS==1
origine_coup_retenu=OR_EXTEND_PAT;
xorigine_search_essais[origine_coup_retenu]++;
xorigine_extend_essais_total++;
#endif
goto QUIT;
}
} // fin PAT


// Remplacement value si aucun enregistrement
// Le cas du mat et du pat a t trait plus haut
// A priori pas d'occurrence si ce n'est 
// non enregistrement de passe passif de rcupration
ASSERT(false);
if (check==0)
{
#if DEBUG==1
	log_error("\nErr Ex_966",MAJOR);
#endif
Fsel=true;
value=sup(valpos, alpha);
*best=LigneEndAbsenceSuite;
#if _DEBUG==1
xda[xlevel][xlevel].dep88=99;
xda[xlevel][xlevel].arr88=99;
#endif
if (value>sup_alpha_value) sup_alpha_value=value;

#if COLLECT_STATS==1
origine_coup_retenu=OR_EXTEND_ABSENCE_SUITE;
xorigine_extend_essais[origine_coup_retenu]++;
xorigine_extend_essais_total++;
#endif

}
else // check!=0
{
// ANOMALIE
#if DEBUG==1
	log_error("\nE_248",MAJOR);
#endif
Fsel=true;
value=inf(valpos,alpha);
*best=Ligne;
#if _DEBUG==1
xda[xlevel][xlevel].dep88=99;
xda[xlevel][xlevel].arr88=99;
#endif
if (value>sup_alpha_value) sup_alpha_value=value;

#if COLLECT_STATS==1
origine_coup_retenu=OR_EXTEND_NON_COUVERTURE_ECHEC;
xorigine_extend_essais[origine_coup_retenu]++;
xorigine_extend_essais_total++;
#endif
}


// Controle
#if DEBUG==1
if (value==-MAX_VALUE)
{
log_error("\nErreur E_100 en %d", xcompteur,MAJOR);
}
#endif


// Affichage du coup passe en situation calme
#if DEBUG==1
CONSOLE_MODE;
if (xstop3) affichage (LignePasse,analysis); // passe
if (xstop3) affiche_ligne(&xligne[1],0);
END_MODE;
#endif


goto QUIT;
} // fin if check==0;
*/

} // fin !Fsel



QUIT:

// Statistiques 
#if COLLECT_STATS==1
ASSERT(origine_coup_retenu!=OR_EXTEND_DEPART);
if ( F_real_move_has_been_registered 
	 && !xreturn 
   )
{
if (value>alpha)
{
xcompteur_nbplayed_before_best_ex+=nbplayed_before_best;
xcompteur_nbplayed_num_ex++;
}
else
{
xcompteur_nbplayed_before_best_ex2+=nbplayed_before_best;
xcompteur_nbplayed_num_ex2++;
}
#if DEBUG==1
if ( nbplayed_before_best==-1 )
	log_error("\nErr Ex_895",MAJOR);
#endif
}
// Origine coups retenus
if ( !xreturn )
{
xorigine_extend_total++;
xorigine_extend[origine_coup_retenu]++;
}
#endif

#if DEBUG==1
// Contrles de bornage 
if (!xreturn && *best==0 )
{
log_error("\nErr Ex_298",MAJOR);
}
if ( !xreturn && !Fsel  )
{
log_error("\nErr Ex_299",MAJOR);
}
#endif



// Djouer

//ASSERT(!(F_case_de_mat && check==0 && value<beta && value<MATE_VALUE_THRESHOLD));


#if DEBUG==1
if ( ( MOVE_IS_LINE(*best) && (MOVE_BASE)*best==0 ) && !xreturn )
log_error("\nErr Ex_811",MAJOR);
#endif
#if COLLECT_STATS==1
if (idxmove>xlengthmax_listmoves) {xlengthmax_listmoves=idxmove;}
#endif


#if EXTEND_VERIFY_LINE==1
// Restauration 
xF_extend_allow_valpos_static_evaluation=F_extend_allow_valpos_static_evaluation_mem;
#endif


// Dcrmentation level
xlevel--; 
dejouer(*lignemoins,1);


// ne pas remplacer par ligne !!!
// car ligne dsigne maintenant xlevel+1
// Pas de rtablissement des variables de position


// Tests aprs djouer
// Contr"le intgrit matriel
// (aprs l'affichage du coup - gain de temps)
#if DEBUG==1
si1=0;
wptr=&xw[31];
for (i=31;i>=0;i--,wptr--)
{
if (wptr->nature==0) continue;
si1+=wptr->value;
}
if  (si1!=xstates[xlevel].materiel)
{
log_error("\nErr EX_119 en : %d",xcompteur,MAJOR);
}
#endif



#if EVAL_FAIL_LOW_TO_ALPHA==1
if (alpha>value && value>-MATE_VALUE_THRESHOLD)
{
	//value=inf(alpha,alpha+max_capture_value); 
	value=alpha;
	sup_alpha_value=alpha; // pour la forme
}
#endif


// Retour aprs djouer
ASSERT(value>-MAX_VALUE || xreturn);
ASSERT(value< MAX_VALUE || xreturn);
ASSERT(Fsel || xreturn);
return value;

} // fin search
#endif



