// Programme de listage de parties d'checs au format PGN
// version intgre au programme 

// A vrifier : signe + pour les checs
// et rsultat des parties (0-1);


#include "stdafx.h"
#include "Cchess_1.h"
#include "Cchess_2.h"
//#include "Cchess_3.h" 
#include "Cchess_4.h"
#include "Cchess_5.h"
#include "Cchess_6.h"


// Fonction globales
void read_bibliotheque(char play_moves);
char adjust_book_stats(char result);
void reset_book_stats(void);
void enregistre_pgn(void);
char french_to_english(char input);
void pgn_translate(char dep,char arr,
				   char prom,char prise_nat,char special,char piece,
				   char *string,char *board);
int  cree_partie_pgn(int xhandle, char *xnom_game, ENREGISTREMENT *xpartie,
		 short xnbcoups);
char pgn_a1_to_88(char *buff);
char pgn_a1_to_64(char *buff);
void initialize_standard_board_english(char *board);


// Fonctions locales
static char direction(char dep, char color, char piece, char inc, char *board);
static char cavalier(char dep, char color, char piece, char inc, char *board);
static void transforme_notation_pgn(char *string);
static void pgn_supprime_second_caractere(char *string);
static void convert_to_xx_and_play(short nbcoups, char *move, char stat, char *board);
static char recherche_coup_pion_2_caracteres(char* move, char color, char &dep, char &arr, char *board);
static char recherche_coup_pion_3_caracteres(char* move, char color, char &dep, char &arr, char *board);
static char recherche_coup_piece(char piece, char color, char provenance_x, char provenance_y, char &dep, char &arr, char *board  );
static char pgn_sub_recherche_cava_roi(char inc, char piece, char color, char &dep, char &arr, 
						char provenance_x, char provenance_y, char *board);
static char pgn_sub_recherche_piece(char inc, char piece, char color, char &dep, char &arr, 
					char provenance_x, char provenance_y, char *board);

 

void read_bibliotheque(char play_moves)
{
char handle1;
long size;
char F_game_info;
char F_game_variation;
char F_stat;
char F_waiting_stat;
char F_move_being_given;
char *ptr2,*ptr,lastchr;
char F_separator_given;
char book_default_stat[10];
char *temp_allocation;
long temp_allocation_size;
long mem_allocation;
short nbcoups;
//char F_newline_was_inserted=1;
char move[PGN_MOVE_LENGTH+1];
char nbchar;
char board[SIZE_OF_BOARD_88];
char stat;
char buff[5];
#if DEBUG==1
short comment_buffer_size=500;
short comment_buffer_chars=0;
char comment_buffer[501];
#endif
bool F_new_game_initializing;

// Initialisations
xbibliotheque_nb_games=0;
mem_allocation=MAX_OPENING_BOOK_MB_SIZE*1024*1024;
ptr=NULL;
//F_newline_was_inserted=0;
nbcoups=0;
temp_allocation=NULL;

// Ouverture fichier disque
if ((handle1=open(OPENING_BOOK_NAME, O_BINARY, S_IREAD | S_IWRITE)) == -1)
{
log_error_no_stop("\nErreur P_456 : Disque - Pas de bibliothque d'ouverture !",xcompteur);
xopeningbook_allowed=0;
temp_allocation_size=0;
temp_allocation=0;
} // fin while handle;
else // Lecture de la bibliothque
{
	
	
// Chargement bibliothque d'ouverture
//temp_allocation=(char*)calloc(mem_allocation,1);
temp_allocation=(char*)malloc(mem_allocation);
temp_allocation_size=read(handle1,temp_allocation,mem_allocation);
close(handle1);
if (temp_allocation_size<=0)
{ 
log_error("\nPas de bibliothque d'ouverture",MAJOR);
xbibliotheque=NULL; 
xtaille_bibliotheque=0;
if (temp_allocation != NULL) free(temp_allocation);
return;
}
temp_allocation=(char*)realloc(temp_allocation,temp_allocation_size);


// Allocation mmoire pour bibliothque modifie
// ( permet de gnrr les statistiques de rsultat sur les coups )
//xbibliotheque=(char*)calloc(mem_allocation,1);
xbibliotheque=(char*)malloc(mem_allocation);
itoa(xbook_default_stat,book_default_stat,10);
size=0;
F_game_info=0;
F_game_variation=0;
F_stat=0;
F_waiting_stat=0;
F_move_being_given=0;
F_separator_given=0;
F_new_game_initializing=false;
lastchr='-'; // pour initialisation, n'importe quel char
for (ptr2=temp_allocation;
     ptr2<=temp_allocation+temp_allocation_size-1
	 && ptr+10<xbibliotheque+mem_allocation-1;	 
	 ptr2++)
{
// Non prise en compte des @ dtachs
if (F_move_being_given!=1 && *ptr2=='@') continue;
// Mmorisation caractre prcedemment lu
if (ptr!=NULL) lastchr=*ptr;
// Stockage du caractre lu
ptr=xbibliotheque+size; // OK
*ptr=*ptr2;
// Incrmentation normale pour lecture suivante
size++; 
//// Remplacement des caractres de sparation si newline inserted
//if ( F_newline_was_inserted == 1 )
//{
//if ( *ptr=='\n' || *ptr=='\r' || *ptr==' ' )
//{ size--; continue; }
// Gestion des commentaires
if (*ptr=='[') 
{ 
	#if DEBUG==1
	comment_buffer[0]='\0';
	comment_buffer_chars=0;
	#endif
	if (!F_new_game_initializing)
	{
		xbibliotheque_nb_games++;
		F_new_game_initializing=true;
		// Realloc place
		#if USE_BOOK_TRANSPOSITIONS==1
		if ( xbibliotheque_nb_games>=xbibliotheque_nb_games_allocated)
		//if ( xbibliotheque_nb_games%100==0 )
		{
		xbibliotheque_nb_games_allocated+=100;
		xbibliotheque_88=(ENTREE_BIBLIOTHEQUE_88 (*)[OPENING_BOOK_LENGTH+1])realloc(xbibliotheque_88,
						xbibliotheque_nb_games_allocated*
						(OPENING_BOOK_LENGTH+1)*sizeof(ENTREE_BIBLIOTHEQUE_88));
		}
		#endif
		initialize_standard_board_english(board);
	}
	F_game_info=1; 
	//F_newline_was_inserted=0; 
	F_separator_given=0;

	// Remplacement caractre d'espacement prcdent par un carriage return
	if ( !( *(ptr-2)=='\r' && *(ptr-1)=='\n') 
		 && 
		 ptr-1 > xbibliotheque )
	{
		// Dplacement donne lue
		*(ptr+1)=*ptr;
		*(ptr-1) = '\r';
		*ptr = '\n';
		ptr=ptr+1;
		size+=1;
	}
	continue;
}
if (*ptr==']') 
{ 
	F_game_info=0; 
	F_move_being_given=0;
	F_waiting_stat=0; 
	nbcoups=0;
	*(ptr+1)='\r' ; *(ptr+2)='\n';
	size+=2;
	ptr=ptr+2;
	//F_newline_was_inserted=1;
	F_separator_given=1;
	continue;
}
if (F_game_info==1) 
{
	#if DEBUG==1
	// Afin de rcuprer facilement la partie qui pose problme
	if ( comment_buffer_chars<comment_buffer_size )
	{
		comment_buffer[comment_buffer_chars++]=*ptr;
		comment_buffer[comment_buffer_chars]='\0';
	}
	#endif
	continue;
}
if (*ptr=='{')
{
	F_game_variation=1;
	continue;
}
if (*ptr=='}')
{
	F_game_variation=0;
	continue;
}
if (F_game_variation==1) continue;

// Gestion des statistiques 
if (F_waiting_stat==1 && *ptr!='(')
{ 
// Owerflow ?
if (size+10>=mem_allocation) goto PARTIAL_LOAD;
// Dplacement de la donne lue
*(ptr+5)=*ptr; 
// Stat par dfaut = zbook_default_stat ( 30 par exemple )
*ptr='(';*(ptr+1)=book_default_stat[0];*(ptr+2)=book_default_stat[1];*(ptr+3)=')';*(ptr+4)=' ';
buff[0]=book_default_stat[0]; buff[1]=book_default_stat[1]; buff[2]='\0';
stat=atoi(buff);
size+=5;
ptr=ptr+5;
F_waiting_stat=0;
F_separator_given=1;
#if USE_BOOK_TRANSPOSITIONS==1
convert_to_xx_and_play(nbcoups, move, stat, board);
#endif
// Ajouts des sauts de lignes
// Si 4 coups donns, sauter une ligne
if (nbcoups%4==0)
{
	*(ptr+1)='\r' ; *(ptr+2)='\n';
	size+=2;
	ptr=ptr+2;
	F_separator_given=1;
	//F_newline_was_inserted=1;
	// Remplacement des caractres de sparation si newline inserted
	//if ( F_newline_was_inserted == 1 )
	//{
	//	if ( *ptr=='\n' || *ptr=='\r' || *ptr==' ' )
	//	{ size--; continue; }
	//}
}  // Fin saut de ligne
} // fin stats

if (*ptr=='(') 
{
	F_stat=1; 
	F_waiting_stat=0;
	continue;
} 
if (*ptr==')') 
{ 
F_stat=0; 
F_separator_given=0;
buff[0]=*(ptr-2); buff[1]=*(ptr-1); buff[2]='\0';
stat=atoi(buff);
// La statistique est connue : on peut jouer le coup
#if USE_BOOK_TRANSPOSITIONS==1
if (play_moves==1) convert_to_xx_and_play(nbcoups, move, stat, board);
#endif
// Recration des sauts de lignes
// Si 4 coups donns, sauter une ligne
if (nbcoups%4==0)
{
	*(ptr+1)='\r' ; *(ptr+2)='\n';
	size+=2;
	ptr=ptr+2;
	F_separator_given=1;
	//F_newline_was_inserted=1;
	// Remplacement des caractres de sparation si newline inserted
	//if ( F_newline_was_inserted == 1 )
	//{
	//	if ( *ptr=='\n' || *ptr=='\r' || *ptr==' ' )
	//	{ size--; continue; }
	//}
}  // Fin saut de ligne
continue;
}
if (F_stat==1) continue;
// Caractre de sparation
// Suppression de deux espaces conscutifs
if (F_separator_given==1 && *ptr==' ') { size--; continue; }
if (!(*ptr==' ' || *ptr=='\r' || *ptr=='\n')) 
{
	// Texte d'un coup
	// Initialisation texte du coup
	F_new_game_initializing=false; // L'initialisation est termine 
	if ( F_move_being_given==0 ) nbchar=1;
	else nbchar++;
	move[nbchar-1]=*ptr;
	move[nbchar]='\0';
	F_move_being_given=1;
	F_separator_given=0;
	//F_newline_was_inserted=0;
	// Numro des coups
	if (*ptr=='.') 
	{
		// Il s'agissait en fait du numro du coup
		size-=nbchar;
		F_move_being_given=0;
		continue;
	}
}
else
{
// Remplacement des carriages return initiaux par un espace
// avant flag sparateur
if (F_separator_given==1)
{
	if (*ptr=='\n') size--;
	if (*ptr=='\r') size--;
}
F_separator_given=1;
// Si un coup a ete entre, on attend sa statistique
if (F_move_being_given==1) 
{ 
	nbcoups++; F_move_being_given=0; F_waiting_stat=1; 
	#if DEBUG==1
	if ( xbibliotheque_nb_games==2354 && nbcoups==10 ) 
			nbcoups=nbcoups;
	#endif
	// Non : la stat n'est pas encore connue
	//#if USE_BOOK_TRANSPOSITIONS==1
	//if (play_moves==1) convert_to_xx_and_play(nbcoups, move, stat, board);
	//#endif
	continue; 
}
continue;
} 
} // fin while

xtaille_bibliotheque=size;
xbibliotheque=(char*)realloc(xbibliotheque,xtaille_bibliotheque);
// Allocation de mmoire
if (xbibliotheque==NULL)
{
log_error("\nErreur P_102",MAJOR);
}
} // fin else


// Warning
if (temp_allocation_size==mem_allocation)
{
	PARTIAL_LOAD:
	xF_opening_file_was_only_partially_loaded=true;
	sprintf(xbuffer,"\nWARNING : only %d opening games loaded", xbibliotheque_nb_games);
	display_info(xbuffer);
}
else 
{
	xF_opening_file_was_only_partially_loaded=false;
	sprintf(xbuffer,"\n%d opening games loaded", xbibliotheque_nb_games);
	display_info(xbuffer);
}


// Libration allocation temporaire
if (temp_allocation != NULL) free(temp_allocation);

} // fin read_bibliotheque



char adjust_book_stats(char result)
{
// result = 1 (gain), 0 (nulle), -1 (perte)
// Lister les parties au format PGN afin de trouver celles qui correspondent
char F_game_info;
char F_game_variation;
char F_stat;
char F_new_game;
char F_match;
char a;
short nbcoups;
char i;
// char cc;
char string[10];
char *ptr;
long compteur;
char stat;
char F_first_digit, F_second_digit;
char color;
char F_stat_was_given;
char F_move_was_given;
char score;
char handle1;

// xF_opening_file_was_only_partially_loaded
if (xF_opening_file_was_only_partially_loaded) return 1;

// Rcriture bibliothque d'ouvertures
// Relecture de la bibliothque afin d'viter tout problme de corruption possible
if (xbibliotheque != NULL) free(xbibliotheque);
read_bibliotheque(0);

// Initialisations
compteur=0;
ptr=xbibliotheque-1;
F_game_info=0;
F_game_variation=0;
F_first_digit=0;
F_second_digit=0;
F_stat_was_given=0;
F_move_was_given=0;

// Boucle de lecture
while (++compteur<=xtaille_bibliotheque)
{
a=*++ptr;

// Ne pas tenir compte des caractres @
// ( pour permettre la comparaison des coups )
if (a=='@') continue;

// Gestion des commentaires de dbut de partie
// Remarque : signalent le dbut d'une nouvelle partie
if (a=='[') 
{ 
F_game_info=1; 
continue;
}
if (a=='{') 
{ 
F_game_variation=1; 
continue;
}
if (F_game_info==1 && a!=']') continue;
if (F_game_variation==1 && a!='}') continue;
if (F_game_variation==1 && a=='}') 
{ 
	F_game_variation=0;
	continue;
}

if (F_game_info==1 && a==']') 
{ 
F_game_info=0; 
// Remplacement caractre d'espacement suivant par un carriage return
// ( retour  la ligne pour nouvelle partie )
// if (ptr+1>=xbibliotheque && ptr+1<=xbibliotheque+xtaille_bibliotheque-1) *(ptr+1) = '\n';
// Dbut nouvelle partie
for (i=0; i<=OPENING_BOOK_LENGTH; i++) strcpy(xbook[i],"\0");
F_match=0;
nbcoups=0;
F_stat=0;
F_new_game=1;
F_stat_was_given=0;
F_move_was_given=0;
continue;
}

// Si le nombre de coup de l'ouverture excde
// le dernier coup d'ouverture jou, continuer
// A placer avant la mise  jour des poids
// ou aprs la mise  jour de F_match  0
if (nbcoups>xlast_opening_move_used) continue;
if (nbcoups>OPENING_BOOK_LENGTH) continue;

// Gestion des poids
if (a=='(') { F_stat=1; continue; }
if (a==')') 
{
F_stat=0; F_first_digit=0; F_second_digit=0; 
F_stat_was_given=1; 
// Continuer si pas de match
if (F_match==0) continue;
string[2]='\0';
stat=atoi(string);
color=nbcoups%2*2-1;
if (color==1) score=(1+result)*100/2;
else score=(1-result)*100/2;
stat=(9*stat+score)/10;
if (stat>99) stat=99;
if (stat<0 ) stat=0;
itoa(stat,string,10);
// Seulement 1 digit
if (strlen(string)==1) { string[1]=string[0]; string[0]='0'; string[2]='\0'; }
// Ajustement pourcentage
if (ptr-2>=xbibliotheque && ptr-2<=xbibliotheque+xtaille_bibliotheque-1)
	 *(ptr-2)=string[0];
if (ptr-1>=xbibliotheque && ptr-1<=xbibliotheque+xtaille_bibliotheque-1) 
	 *(ptr-1)=string[1];
continue;
} // fin if (a==')')
if (F_stat==1) 
{
if (F_match==0) continue;
if (F_first_digit ==0) { F_first_digit =1; string[0]=a; continue;}
if (F_second_digit==0) { F_second_digit=1; string[1]=a; continue;}
continue;
}


// Caractre de sparation
if (a==' ' || a=='\r' || a=='\n' ) 
{
 if (F_move_was_given==1 && F_new_game==0 && 
	 nbcoups<=OPENING_BOOK_LENGTH) 
 { 
 // Consommation F_move_was_given
 F_move_was_given=0; 
 // Comparaison jusqu' xlast_opening_move_used
 if (nbcoups<=xlast_opening_move_used && nbcoups<=OPENING_BOOK_LENGTH)
 {
 strcpy(string,xpartie[nbcoups].pgn);

 /* Inutile maintenant
 // Afin de permettre la correspondance au niveau des 
 // prises de pions (ed=ed5), ne comparer que les deux premiers
 // caractres lorsque la longueur de la chane de bibliothque
 // est de 2
 if (strlen(xbook[nbcoups])==2) 
		string[2]='\0';
 */

 // xbook = bibliothque au format PGN
 // xpartie_pgn = partie au format PGN
 // pb : la correspondance n'est pas si vidente
 // xbook peut atteindre OPENING_BOOK_LENGTH mais c'est tout
 if (pgn_compare(xbook[nbcoups],string))
	{ if (nbcoups==1) F_match=1; }
 else F_match=0;

  } // fin (nbcoups<=xlast_opening_move_used && nbcoups<=OPENING_BOOK_LENGTH)
 } // fin if (F_new_game==0 && nbcoups <= OPENING_BOOK_LENGTH) 
 
 continue;
} // fin a==' '
if (a=='x') continue;
if (a=='+') continue;
if (a!=' ' && a!='\r' && a!='\n') F_new_game=0;

// Incrmenter le compteur de coups 
if ( F_move_was_given==0 )
{
F_move_was_given=1;
// F_stat_was_given passe  zro 
//  partir du moment o on a saisi un autre coup
F_stat_was_given=0; 
nbcoups++;
#if DEBUG==1
if (nbcoups>LENGTH_SEARCHLISTMOVES)
{
log_error("\nPb xbook\n",MAJOR);
}
#endif
}

// Copier le caractre lu
if (nbcoups<=OPENING_BOOK_LENGTH
	&& strlen(xbook[nbcoups])<=PGN_MOVE_LENGTH-1)
	 strncat(xbook[nbcoups],&a,1);

} // fin read sur bibiothque


// Rouverture bibliothque pour mise  jour statistiques
if ((handle1=open(OPENING_BOOK_NAME,O_WRONLY | O_CREAT | O_BINARY | O_TRUNC, S_IREAD|S_IWRITE)) == -1)
{
log_error("\nErreur P_925 : Disque - Pas de bibliothque d'ouverture !",MINOR);
return 1; // echec
} // fin while handle;
write(handle1,xbibliotheque,xtaille_bibliotheque);
close(handle1);
return 0;
} // fin adjust_book_stats




void reset_book_stats(void)
{
char handle1;
char F_game_info;
char F_game_variation;
char F_stat;
//char F_waiting_stat;
//char F_move_given;
//char F_stat_given;
char *ptr;
//char F_new_game;
//char F_separator_given;
char book_default_stat[10];
char F_first_digit, F_second_digit;
long compteur;
char a;


// xF_opening_file_was_only_partially_loaded
if (xF_opening_file_was_only_partially_loaded) return;

// Initialisations
itoa(xbook_default_stat,book_default_stat,10);
F_first_digit=0; F_second_digit=0;

// Rcriture bibliothque d'ouvertures
// Relecture de la bibliothque afin d'viter tout problme de corruption possible
if (xbibliotheque != NULL) free(xbibliotheque);
read_bibliotheque(0);



F_game_info=0;
F_game_variation=0;
F_stat=0;
compteur=0;
ptr=xbibliotheque-1;
// Boucle de lecture
while (++compteur<=xtaille_bibliotheque)
{
ptr++; a=*ptr;
// Gestion des commentaires
if (*ptr=='[') { F_game_info=1; continue; }
if (*ptr=='{') { F_game_variation=1; continue; }
if (*ptr==']') { F_game_info=0; continue; }
if (*ptr=='}') { F_game_variation=0; continue; }
if (F_game_info==1) continue;
if (F_game_variation==1) continue;
// Gestion des statistiques 
if (*ptr=='(') { F_stat=1; continue;} 
if (*ptr==')') { F_stat=0; F_first_digit=0; F_second_digit=0; continue;}
if (F_stat==1)
{
if (F_first_digit ==0) { F_first_digit= 1; *ptr=book_default_stat[0]; continue; }
if (F_second_digit==0) { F_second_digit=1; *ptr=book_default_stat[1]; continue; }
continue;
} // F_stat==1
} // fin while

// Rouverture bibliotheque en criture
if ((handle1=open(OPENING_BOOK_NAME,O_WRONLY | O_CREAT | O_BINARY | O_TRUNC, S_IREAD | S_IWRITE)) == -1)
{
log_error("\nErreur P_852 : disque - Pas de bibliothque d'ouverture !",MINOR);
} // fin while handle;
write(handle1,xbibliotheque,xtaille_bibliotheque);
close(handle1);

} // fin reset_book_stats



char french_to_english(char input)
{
if (input>0) 
{
switch(input)
{
case 'P' : return 'P';
case 'C' : return 'N';
case 'F' : return 'B';
case 'T' : return 'R';
case 'D' : return 'Q';
case 'R' : return 'K';
default : return input;
}
}
else
{
switch(input)
{
case -'P' : return -'P';
case -'C' : return -'N';
case -'F' : return -'B';
case -'T' : return -'R';
case -'D' : return -'Q';
case -'R' : return -'K';
default : return input;
}
}
}


char english_to_french(char input)
{
if (input>0) 
{
switch(input)
{
// Majuscules
case 'P' : return 'P';
case 'N' : return 'C';
case 'B' : return 'F';
case 'R' : return 'T';
case 'Q' : return 'D';
case 'K' : return 'R';
// Minuscules : ncessaire pour UCI
case 'p' : return 'P';
case 'n' : return 'C';
case 'b' : return 'F';
case 'r' : return 'T';
case 'q' : return 'D';
case 'k' : return 'R';
default : return input;
}
}
else
{
switch(input)
{
case -'P' : return -'P';
case -'N' : return -'C';
case -'B' : return -'F';
case -'R' : return -'T';
case -'Q' : return -'D';
case -'K' : return -'R';
default : return input;
}
}
}




int cree_partie_pgn(int handle_pgn, char *nom_game, ENREGISTREMENT *partie,
 		   short length_game)
{
short nbcoups;
char buff[50];
char dep,arr;
char piece;
char prise_nat;
char status;
char check;
char special;
char prom;
char color;
char Flag_complement_notation;
char Flag_complement_colonne;
char Flag_complement_ligne;
char board[SIZE_OF_BOARD_88];
char dep_array[8];
char i; 

// Initialisations
nbcoups=1;
status=0;
check=0;

/*
[Event "French Microcomputer Chess Championship"]
[Site "Clichy"]
[Date "1998.09.25"]
[Round "1"]
[White "Capture"]
[Black "La Dame Blanche"]
[Result "1-0"]
[ECO "B53"]
[PlyCount "159"]
*/

// Fermeture du fichier PGN sur disque pour rcration
close(handle_pgn);

// Ouverture fichier
if ((handle_pgn=open(nom_game, O_WRONLY | O_CREAT | O_BINARY | O_TRUNC,
S_IREAD | S_IWRITE)) == -1)
{
log_error("\nErr I_012 !",MAJOR);
}


// Impression des en-ttes
/*
[Event "French Microcomputer Chess Championship"]
[Site "Clichy"]
[Date "1998.09.25"]
[Round "1"]
[White "Capture"]
[Black "La Dame Blanche"]
[Result "1-0"]
[ECO "B53"]
[PlyCount "159"]
*/
strcpy(buff,"[Event \x22\x22]\n");
write(handle_pgn, buff,11);
strcpy(buff,"[Site \x22\x22]\n");
write(handle_pgn, buff,10);
strcpy(buff,"[Date \x22\x22]\n");
write(handle_pgn, buff,10);
strcpy(buff,"[Round \x22\x22]\n");
write(handle_pgn, buff,11);
strcpy(buff,"[White \x22\x22]\n");
write(handle_pgn, buff,11);
strcpy(buff,"[Black \x22\x22]\n");
write(handle_pgn, buff,11);
strcpy(buff,"[Result \x22\x22]\n");
write(handle_pgn, buff,12);
strcpy(buff,"[ECO \x22\x22]\n");
write(handle_pgn, buff,9);
strcpy(buff,"[PlyCount \x22");
write(handle_pgn, buff,11);
itoa(length_game, buff,10);
write(handle_pgn, buff,(char) strlen(buff));
strcpy(buff,"\x22]\n");
write(handle_pgn, buff,(char) strlen(buff));

// Recopie de xxboard_original_french
for (i=0;i<=88;i++) board[i]=french_to_english(xxboard_original_french[i]);

// Jeu des coup
nbcoups=1;
while (nbcoups<=length_game) 
{
// Saut de ligne tous les 6 coups
if (nbcoups%12==1)
{
buff[0]='\n'; 
write(handle_pgn,buff,1);
}


// Initialisations
dep=xpartie[nbcoups].dep88;
arr=xpartie[nbcoups].arr88;
status=xpartie[nbcoups].status;
check=xpartie[nbcoups].check;
memset(dep_array,0,8);


// Test fin de partie 
if (dep==0 && arr==0) 
{ 
goto FIN;
}

// Suite intialisations
prom=french_to_english(xpartie[nbcoups].prom);
prise_nat=french_to_english(xpartie[nbcoups].prise_nat);
special=xpartie[nbcoups].special;
if (board[dep]>0) color=1;
else			  color=-1;
piece=abs(board[dep]);


// Affichage du nombre de coups
if (nbcoups%2==1)
{
itoa((short) DIV2(nbcoups)+1+xpgn_move_offset, buff, 10);
write(handle_pgn, buff, (char) strlen(buff));
strcpy(buff,".");
write(handle_pgn, buff, 1);
}


// Recherche des complments de notation
// (Exemple : Rae8)

// Note : la question peut se poser pour toutes les pices
// y compris les fous du fait des promotions !!
// Principe : dnombrer le nombre de pices pouvant atteindre la case
// (au moins une pice !)
// Si plus d'une pice, alors, discriminer entre 2 pices
// Note : ceci est suffisant en pratique, mais insuffisant en thorie.
// En effet, on pourrait avoir trois dames et tre oblig de distinguer
// suivant deux coordonnes.
// En fait, jusqu' 8 pices peuvent atteindre une mme case
// On connat le coup jou
// il y a confusion de colonne si une pice de la mme nature
// peut atteindre la case d'arrive depuis la mme colonne
// il y a confusion de ligne si une pice de la mme nature
// peut atteindre la case d'arrive depuis la mme ligne

i=0;
if (piece=='Q' || piece=='R')
{
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,+10,board);
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,-10,board);
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,+ 1,board);
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,- 1,board);
}
if (piece=='Q' || piece=='B')
{
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,+11,board);
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,-11,board);
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,+ 9,board);
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,- 9,board);
}
if (piece=='N')
{
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,+12,board);
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,+21,board);
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,+19,board);
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,+ 8,board);
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,-12,board);
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,-21,board);
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,-19,board);
if (dep_array[i]!=0) {i++;}
dep_array[i]=direction(arr, color, piece,- 8,board);
}


// Faut-il un complment de notation
Flag_complement_notation=0;
Flag_complement_colonne=0;
Flag_complement_ligne=0;
for (i=0;i<=7 && dep_array[i]!=0;i++)
{
if (dep_array[i]==dep) continue;
// Il faut positionner un flag indiquant qu'un complment est ncessaire
// Ce flag ne sera utilis que si les deux autres flags sont nuls
// pour imposer un complment colonne
Flag_complement_notation=1; // par dfaut ce sera le complment colonne - Ex : Cbd7
// Qui si deux cavaliers b peuvent arriver sur la case d'arrive
if (X88(dep_array[i])==X88(dep)) Flag_complement_ligne=1;
if (Y88(dep_array[i])==Y88(dep)) Flag_complement_colonne=1;
} // fin for
if (Flag_complement_colonne==0 && Flag_complement_ligne==0 &&
	Flag_complement_notation==1) Flag_complement_colonne=1;


// Traitement des coups hors rosue //
if (special!=1)
{ 
if (piece=='P') 
{
}
else // Pice diffrente d'un pion
{
buff[0]=piece;
write(handle_pgn,buff,1);
if (Flag_complement_ligne==1) 
{buff[0]=((dep-dep%10)/10)+96; write(handle_pgn,buff,1);}
if (Flag_complement_colonne==1) 
{buff[0]=dep%10+48; write(handle_pgn,buff,1);}
}
// Affichage pour une prise
if (prise_nat!=0) 
{
if (piece=='P') 
{buff[0]=((dep-dep%10)/10)+96; write(handle_pgn,buff,1);}
if ( !(piece=='P' && prise_nat=='P') )
{
buff[0]='x';
buff[1]=((arr-Y88(arr))/10)+96;
buff[2]=(Y88(arr)+48);
buff[3]='\0';
}
else // prise d'un pion par un pion
{
buff[0]=((arr-Y88(arr))/10)+96;
buff[1]='\0';
}
write(handle_pgn,buff,(char) strlen(buff));
}
else // absence de prise
{
// Affichage de la case d'arrive
{
buff[0]=((arr-arr%10)/10)+96;
buff[1]=(arr%10+48);
write(handle_pgn,buff,2);
}
} // Fin else pice diffrente d'un pion
} // Fin traitement des coups normaux
else // Roque
{
if (special==1) // prcaution
{
switch(arr)
{
case 71 : // Petit roque blanc 
	     strcpy(buff,"o-o\0"); 
		 break;
case 31 : // Grand roque blanc
	     strcpy(buff,"o-o-o\0"); 
		 break;
case 78 : // Petit roque noir
	     strcpy(buff,"o-o\0"); 
		 break;
case 38 : // Grand roque noir
	     strcpy(buff,"o-o-o\0"); 
		 break;
#if DEBUG==1
default : log_error("\nErr P_789",MAJOR);
#endif
}
write(handle_pgn,buff,(char) strlen(buff));
}
}

/*
// Prises en passant
if (special==2) 
{
strcpy(buff,"e.p."); write(handle_pgn,buff,4);
}
*/
// Promotions
if (special==3) 
{
strcpy(buff,"="); write(handle_pgn,buff,1);
write(handle_pgn,&prom,1);
}


FIN:

switch ((short) status)
{
case UNDECIDED  : strcpy(buff,"\0"); break;
case WHITE_GIVES_MATE  : strcpy(buff,"# 1-0\0"); break;
case BLACK_GIVES_MATE  : strcpy(buff,"# 0-1\0"); break;
case WHITE_IS_MATE  : strcpy(buff,"\0");  break;
case BLACK_IS_MATE  : strcpy(buff,"\0");  break;
case PLAYER_IS_PAT    : strcpy(buff," 1/2-1/2\0"); break;
case DRAW_REPETITION  : strcpy(buff," 1/2-1/2\0"); break;
case DRAW_50_MOVES  : strcpy(buff," 1/2-1/2\0"); break;
case THEORETICAL_DRAW  : strcpy(buff," 1/2-1/2\0"); break;
case WHITE_RESIGNS  : strcpy(buff," 0-1 (resigns)\0"); break;
case BLACK_RESIGNS : strcpy(buff," 1-0 (resigns)\0"); break;
default :strcpy(buff,"\0");  break;
}
write(handle_pgn,buff,(char) strlen(buff));
// Signe + de mise en chec
if (check!=0)
{
if ( !( status==WHITE_GIVES_MATE  || status==BLACK_GIVES_MATE) )
{
  strcpy(buff,"+\0"); 
}
} // if check!=0


// Espace
strcpy(buff," "); write(handle_pgn,buff,1);


// Jeu du coup
board[arr]=board[dep]; // tout simplement
board[dep]=0;

// Complment des coups spciaux
switch((short) special)
{
case 1 : // Roques 
	switch(arr)
	{
	case 71 : board[61]= 'R';board[81]=0;
	     break;
	case 31 : board[41]= 'R';board[11]=0;
         break;
    case 78 : board[68]=-'R';board[88]=0;
         break;
    case 38 : board[48]=-'R';board[18]=0;
         break;
	}
	break;
case 2 : // prise en passant
	     if (arr%10>dep%10) board[arr-1]=0;
		 if (arr%10<dep%10) board[arr+1]=0;
		 break;
case 3 : // promotion
	     // => change la pice dans la nature de promotion
	     board[arr]=color*prom; // En anglais
		 break;
}

// Incrmentation nbcoups
nbcoups++;

} // fin while

// Pas de fermeture du fichier
return handle_pgn;

} // fin partie_pgn




void enregistre_coup_pgn(char F_write_to_pgn_file)
{
// opre sur xhandle qui est dja ouvert
// n'enregistre que le coup correspondant  xnbcoup 
// mais pour plus de simplicit, on rejoue toute la partie
// ce qui n'est a priori qu'une fraction de seconde
// ceci vite d'avoir  maintenir un xboard2 avec la position courante
// et ne complique pas la gestion des takeback
// On part donc  chaque fois de xxboard_original_french, c'est  dire de la position originale.
	
char i;
short nbcoups;
char buff[50];
char dep,arr;
char piece;
char prise_nat;
char status;
char check;
char special;
char prom;
char color;
char dep_temp, dep_1, dep_2;
char Flag_c;
char board[SIZE_OF_BOARD_88];
int  handle_pgn;
short length_game;
char (*pgn)[PGN_MOVE_LENGTH+1];

// Initialisation
nbcoups=0;
status=0;
check=0;
handle_pgn=xhandle; // Fichier de sortie
length_game=xnbcoups;
pgn=&xpartie[xnbcoups].pgn;
(*pgn)[0]='\0';

// Impression des en-ttes
/*
[Event "French Microcomputer Chess Championship"]
[Site "Clichy"]
[Date "1998.09.25"]
[Round "1"]
[White "Capture"]
[Black "La Dame Blanche"]
[Result "1-0"]
[ECO "B53"]
[PlyCount "159"]
*/

if ( F_write_to_pgn_file==1 )
{
if (xnbcoups==1)
{
strcpy(buff,"[Event \x22\x22]\n");
write(handle_pgn, buff,11);
strcpy(buff,"[Site \x22\x22]\n");
write(handle_pgn, buff,10);
strcpy(buff,"[Date \x22\x22]\n");
write(handle_pgn, buff,10);
strcpy(buff,"[Round \x22\x22]\n");
write(handle_pgn, buff,11);
strcpy(buff,"[White \x22\x22]\n");
write(handle_pgn, buff,11);
strcpy(buff,"[Black \x22\x22]\n");
write(handle_pgn, buff,11);
strcpy(buff,"[Result \x22\x22]\n");
write(handle_pgn, buff,12);
strcpy(buff,"[ECO \x22\x22]\n");
write(handle_pgn, buff,9);
strcpy(buff,"[PlyCount \x22");
write(handle_pgn, buff,11);
strcpy(buff,"\x22]\n");
write(handle_pgn, buff,(char) strlen(buff));
}
}

// Recopie de xxboard_original_french
for (i=0;i<=88;i++) board[i]=french_to_english(xxboard_original_french[i]);

// Jeu du coup
nbcoups=1;
while (nbcoups<=length_game) 
{
// Saut de ligne tous les 6 coups
if (nbcoups%12==1 && nbcoups==xnbcoups)
{
buff[0]='\n'; 
if ( F_write_to_pgn_file==1 ) write(handle_pgn,buff,1);
}


// Initialisations
dep=xpartie[nbcoups].dep88;
arr=xpartie[nbcoups].arr88;
status=xpartie[nbcoups].status;
// Test fin de partie 
if (dep==0 && arr==0) 
{ 
goto FIN;
}

// Suite intialisations
prom=french_to_english(xpartie[nbcoups].prom);
prise_nat=french_to_english(xpartie[nbcoups].prise_nat);
special=xpartie[nbcoups].special;
if (board[dep]>0) color=1;
else			color=-1;
piece=abs(board[dep]);


// Affichage du nombre de coups
if (nbcoups%2==1 && nbcoups==xnbcoups)
{
itoa((short) DIV2(nbcoups)+1+xpgn_move_offset, buff, 10);
if ( F_write_to_pgn_file==1 ) write(handle_pgn, buff, (char) strlen(buff));
strcpy(buff,".");
if ( F_write_to_pgn_file==1 ) write(handle_pgn, buff, 1);
}


// Recherche des complments de notation
// (Exemple : Rae8)

// Note : la question peut se poser pour toutes les pices
// y compris les fous du fait des promotions !!
// Principe : dnombrer le nombre de pices pouvant atteindre la case
// (au moins une pice !)
// Si plus d'une pice, alors, discriminer entre 2 pices
// Note : ceci est suffisant en pratique, mais insuffisant en thorie.
// En effet, on pourrait avoir trois dame et tre oblig de distinguer
// suivant deux coordonnes.
if (nbcoups==xnbcoups)
{
dep_1=0;
dep_2=0;

if (piece=='Q' || piece=='R')
{
dep_temp=direction(arr, color, piece,10,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=direction(arr, color, piece,-1,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=direction(arr, color, piece,-10,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=direction(arr, color, piece,+1,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
}

if (piece=='Q' || piece=='B')
{
dep_temp=direction(arr, color, piece,11,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=direction(arr, color, piece,9,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=direction(arr, color, piece,-11,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=direction(arr, color, piece,-9,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
}

if (piece=='N')
{
dep_temp=cavalier(arr, color, piece,12,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,21,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,19,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,8,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,-12,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,-21,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,-19,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,-8,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
}


// Colonnes diffrentes ?
Flag_c=0;
if (dep_2!=0) // deux pices possibles
{
if (dep_2-dep_2%10 != dep_1-dep_1%10) Flag_c=1;
else // mme colonne
{Flag_c=2;}
}


// Traitement des coups hors roque //
if (special!=1)
{ 
if (piece=='P') 
{
}
else // Pice diffrente d'un pion
{
buff[0]=piece;
if ( F_write_to_pgn_file==1 ) write(handle_pgn,buff,1);
strncat(*pgn,buff,1);
if (Flag_c==1) 
{
	buff[0]=((dep-dep%10)/10)+96; 
	if ( F_write_to_pgn_file==1 ) write(handle_pgn,buff,1);
	strncat(*pgn,buff,1);
}
if (Flag_c==2) 
{
	buff[0]=dep%10+48; 
	if ( F_write_to_pgn_file==1 ) write(handle_pgn,buff,1);
	strncat(*pgn,buff,1);
}
} // fin pice diffrente d'un pion
// Affichage pour une prise
if (prise_nat!=0) 
{
if (piece=='P') 
{
	buff[0]=((dep-dep%10)/10)+96; 
	if ( F_write_to_pgn_file==1 ) write(handle_pgn,buff,1);
	strncat(*pgn,buff,1);
}
if ( !(piece=='P' && prise_nat=='P') )
{
buff[0]='x';
buff[1]=((arr-Y88(arr))/10)+96;
buff[2]=(Y88(arr)+48);
buff[3]='\0';
}
else // Prise d'un pion par un pion
{
buff[0]=((arr-Y88(arr))/10)+96;
buff[1]='\0';
}
if ( F_write_to_pgn_file==1 ) write(handle_pgn,buff,(char) strlen(buff));
strncat(*pgn,buff,strlen(buff));
}
else // absence de prise
{
// Affichage de la case d'arrive
{
buff[0]=((arr-arr%10)/10)+96;
buff[1]=(arr%10+48);
if ( F_write_to_pgn_file==1 ) write(handle_pgn,buff,2);
strncat(*pgn,buff,2);
}
} // Fin else pice diffrente d'un pion
} // Fin traitement des coups normaux
else // Roque
{
if (special==1) // prcaution
{
switch(arr)
{
case 71 : // Petit roque blanc 
	     strcpy(buff,"o-o\0"); 
		 break;
case 31 : // Grand roque blanc
	     strcpy(buff,"o-o-o\0"); 
		 break;
case 78 : // Petit roque noir
	     strcpy(buff,"o-o\0"); 
		 break;
case 38 : // Grand roque noir
	     strcpy(buff,"o-o-o\0"); 
		 break;
#if DEBUG==1
default : log_error("\nErr P_789",MAJOR);
#endif
}
if ( F_write_to_pgn_file==1 ) write(handle_pgn,buff,(char) strlen(buff));
strncat(*pgn,buff,strlen(buff));
}
}


/*
// Prises en passant
if (special==2) 
{ 
strcpy(buff,"e.p."); 
if ( F_write_to_pgn_file==1 ) write(handle_pgn,buff,4);
strncat(*pgn,buff,strlen(buff));
}
}
*/

// Promotions
if (special==3) 
{
strcpy(buff,"="); write(handle_pgn,buff,1);
if ( F_write_to_pgn_file==1 ) write(handle_pgn,&prom,1);
strncat(*pgn,buff,strlen(buff));
}




FIN:


switch ((short) status)
{
case UNDECIDED  : strcpy(buff,"\0"); break;
case WHITE_GIVES_MATE  : strcpy(buff,"# 1-0\0"); break;
case BLACK_GIVES_MATE  : strcpy(buff,"# 0-1\0"); break;
case WHITE_IS_MATE  : strcpy(buff,"\0");  break;
case BLACK_IS_MATE  : strcpy(buff,"\0");  break;
case PLAYER_IS_PAT    : strcpy(buff," 1/2-1/2\0"); break;
case DRAW_REPETITION  : strcpy(buff," 1/2-1/2\0"); break;
case DRAW_50_MOVES  : strcpy(buff," 1/2-1/2\0"); break;
case THEORETICAL_DRAW  : strcpy(buff," 1/2-1/2\0"); break;
case WHITE_RESIGNS  : strcpy(buff," 0-1 (resigns)\0"); break;
case BLACK_RESIGNS : strcpy(buff," 1-0 (resigns)\0"); break;
default : strcpy(buff,"\0"); break;
}
if ( F_write_to_pgn_file==1 ) write(handle_pgn,buff,(char) strlen(buff));

// Signe + de mise en chec
if (check!=0)
{
if ( !( status==WHITE_GIVES_MATE||status==BLACK_GIVES_MATE) )
{
	  if ( F_write_to_pgn_file==1 ) strcpy(buff,"+\0"); 
}
} // if check!=0


// Espace
if ( F_write_to_pgn_file==1 ) strcpy(buff," "); write(handle_pgn,buff,1);

// Terminaison coup dans xpartie
strncat(*pgn,"\0",1);


} // Fin if (nbcoups==xnbcoups)


// Jeu du coup
board[arr]=board[dep]; // tout simplement
board[dep]=0;

// Complment des coups spciaux
switch((short) special)
{
case 1 : // Roques 
	switch(arr)
	{
	case 71 : board[61]= 'R';board[81]=0;
	     break;
	case 31 : board[41]= 'R';board[11]=0;
         break;
    case 78 : board[68]=-'R';board[88]=0;
         break;
    case 38 : board[48]=-'R';board[18]=0;
         break;
	}
	break;
case 2 : // prise en passant
	     if (arr%10>dep%10) board[arr-1]=0;
		 if (arr%10<dep%10) board[arr+1]=0;
		 break;
case 3 : // promotion
	     // => change la pice dans la nature de promotion
	     board[arr]=color*prom; // En anglais
		 break;
}

// Incrmentation nbcoups
nbcoups++;

} // fin while

// Pas de fermeture du handle de fichier

} // fin enregistre_pgn




void pgn_translate(char dep,char arr,
				   char prom,char prise_nat,char special,char piece,
				   char *string,char *board)
{
char color;
char dep_temp, dep_1, dep_2;
char Flag_c;
char buff[15];


//if (xzboard[dep]>0) color=1;
if (board[dep]>0) color=1;
else	          color=-1;

// Recherche des complments de notation
// (Exemple : Rae8)

// Note : la question peut se poser pour toutes les pices
// y compris les fous du fait des promotions !!
// Principe : dnombrer le nombre de pices pouvant atteindre la case
// (au moins une pfice !)
// Si plus d'une pice, alors, discriminer entre 2 pices
// Note : ceci est suffisant en pratique, mais insuffisant en thorie.
// En effet, on pourrait avoir trois dame et tre oblig de distinguer
// suivant deux coordonnes.

dep_1=0;
dep_2=0;

if (piece=='Q' || piece=='R')
{
dep_temp=direction(arr, color, piece,10,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=direction(arr, color, piece,-1,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=direction(arr, color, piece,-10,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=direction(arr, color, piece,+1,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
}

if (piece=='Q' || piece=='B')
{
dep_temp=direction(arr, color, piece,11,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=direction(arr, color, piece,9,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=direction(arr, color, piece,-11,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=direction(arr, color, piece,-9,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
}


if (piece=='N')
{
dep_temp=cavalier(arr, color, piece,12,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,21,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,19,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,8,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,-12,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,-21,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,-19,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
dep_temp=cavalier(arr, color, piece,-8,board);
if (dep_temp!=0 && dep_1==0) dep_1=dep_temp;
else if (dep_temp!=0 && dep_1!=0) dep_2=dep_temp;
}


// Colonnes diffrentes ?
Flag_c=0;
if (dep_2!=0) // deux pices possibles
{
if (dep_2-Y88(dep_2) != dep_1-Y88(dep_1) ) Flag_c=1;
else // mme colonne
{Flag_c=2;}
}


// Traitement des coups hors roque
if (special!=1)
{ 
if (piece=='P') 
{
}
else // Pice diffrente d'un pion
{
buff[0]=piece;
strncat(string,buff,1);
if (Flag_c==1) 
{buff[0]=((dep-Y88(dep))/10)+96; strncat(string,buff,1);}
if (Flag_c==2) 
{buff[0]=Y88(dep)+48; strncat(string,buff,1);}
}
// Affichage pour une prise
if (prise_nat!=0) 
{
if (piece=='P') 
{buff[0]=((dep-Y88(dep))/10)+96; strncat(string,buff,1);}
if ( !(piece=='P' && prise_nat=='P') )
{
buff[0]='x';
buff[1]=((arr-Y88(arr))/10)+96;
buff[2]=(Y88(arr)+48);
buff[3]='\0';
}
else // Prise d'un pion par un pion
{
buff[0]=((arr-Y88(arr))/10)+96;
buff[1]='\0';
}
strncat(string,buff,strlen(buff));
}
else // absence de prise
{
// Affichage de la case d'arrive
{
buff[0]=((arr-Y88(arr))/10)+96;
buff[1]=(Y88(arr)+48);
strncat(string,buff,2);
}
} // Fin else pice diffrente d'un pion
} // Fin traitement des coups normaux
else // Roques
{
switch(arr)
{
case 71 : // Petit roque blanc 
	     strcpy(buff,"o-o\0"); 
		 break;
case 31 : // Grand roque blanc
	     strcpy(buff,"o-o-o\0"); 
		 break;
case 78 : // Petit roque noir
	     strcpy(buff,"o-o\0"); 
		 break;
case 38 : // Grand roque noir
	     strcpy(buff,"o-o-o\0"); 
		 break;
}
strncat(string,buff,strlen(buff));
}

if (special==3) // Promotions
{
strcpy(buff,"=\0"); strncat(string,buff,1);
strncat(string,&prom,1);
// board[dep]=color*prom;
}

} // fin pgn_translate







// Pour pgn
char direction(char arr,char color,char piece,char inc,char *board)
{
char dep;
char dep_color;

dep=arr+inc;
do
{
if (dep%10==0) break;
if (dep%10==9) break;
if (dep<11) break;
if (dep>88) break;
if (board[dep]==0) {dep=dep+inc;continue;}
dep_color=SIGNE(board[dep]);
if (dep_color==-color) break;
if (abs(board[dep])!=piece) break; 
return dep; 
}while(1);

return 0;
}


// Pour pgn
char cavalier(char arr,char color,char piece, char inc, char *board)
{

char dep;

dep=arr+inc;
do 
{
if (dep%10==0) break;
if (dep%10==9) break;
if (dep<11) break;
if (dep>88) break;
if (board[dep]==0) break; 
if (abs(board[dep])/board[dep]==-color) break;
if (abs(board[dep])/board[dep]==color && abs(board[dep])==piece)
{ return dep; }
break;
} while (1);

return 0;
}


void transforme_notation_pgn(char *string)
{
char i,j;
char *ptr;
char temp_string[PGN_MOVE_LENGTH+1];

j=-1;
ptr=temp_string;
strncpy(temp_string, string, PGN_MOVE_LENGTH);
// Y compris le caractre final \0
for (i=0;i<=PGN_MOVE_LENGTH;i++,ptr++)
{
// Remarque : 
// b n'est pas traduit
// Si b tait traduit en B, il ne serait plus possible de distinguer
// bxc6 et Bxc6
// Avec la solution retenue, il reste une confusion possible
// si le fichier de bibliothque contient bxc6 pour une prise par fou
// Aprs transformation, cela donne Bc6.
// Si le coup de xpartie_pgn est bc, la comparaison sera effectue et valide
// Le coup retenu sera bxc6 au lieu de Bxc6
// La seule solution possible  ce problme consiste  ne avoir une
// bibliothque d'ouverture avec la bonne notation ( Bxc6 et non bxc6 )
switch(*ptr)
{
	case 'x' : continue; 
	case 'X' : continue;
	case '+' : continue;
	case ' ' : continue;
	case 'O' : *ptr='o'; break;
	case 'k' : *ptr='K'; break;
	case 'q' : *ptr='Q'; break;
	case 'r' : *ptr='R'; break;
	case 'n' : *ptr='N'; break;
	//:case 'b' : *ptr='B'; break;
}
j++;
string[j]=*ptr;
if ( *ptr=='\0' ) break;
}

/*
// Ancienne implmentation alternative
char string2[PGN_MOVE_LENGTH+1];
char i;
strncpy(string2,string,PGN_MOVE_LENGTH);
string[0]='\0';
for (i=0; i<=PGN_MOVE_LENGTH; i++)
{
if (string2[i]=='x') continue;
if (string2[i]=='') continue;

else strncat(string,&string2[i],1);
if (string2[i]=='\0') break;
}
*/

} //  fin transforme_notation_pgn



void pgn_supprime_second_caractere(char *string)
{
char i;

// Supprimer le deuxime caractre
for (i=1;i<=PGN_MOVE_LENGTH-1;i++)
{
string[i]=string[i+1];
}
}

bool pgn_compare(char* string1,char* string2)
{
// Remarque:  strcmpi permet de comparer en ignorant la casse
// Autre :
// Afin de permettre la correspondance au niveau des 
// prises de pions (ed=ed5), ne comparer que les deux premiers
// caractres lorsque la longueur de la chane de bibliothque
// est de 2
// En effet : aprs Nxc6 ( parfois not Nc6 ), on trouve bxc6 ou bc

// Dclarations
// char i;
char temp_string1[PGN_MOVE_LENGTH+1], temp_string2[PGN_MOVE_LENGTH+1];
char cc;
char length1, length2;
char a;

// Recopie des chanes pour comparaison 
// Rappel : les chanes sont transmises par rfrence
// Si on ne veut pas affecter le chanes initiales, 
// il faut utiliser des copies
strncpy(temp_string1,string1,PGN_MOVE_LENGTH);
strncpy(temp_string2,string2,PGN_MOVE_LENGTH);

// Eliminer le caracre x de chacune des deux chanes
// Mettre en majuscule les N, R, K, Q initiaux ( mais pas les b )
// Supprime les checs (+)
transforme_notation_pgn(temp_string1);
transforme_notation_pgn(temp_string2);

// Longueur des chanes aprs transformation
length1=(char) strlen(temp_string1);
length2=(char) strlen(temp_string2);

// Tronquer  deux caractres si une des deux entres contient deux caractres
// ( permet de comparer ed et ed5 )
if (length1==2) temp_string2[2]='\0';
if (length2==2) temp_string1[2]='\0';

// Permettre de matcher Nd7 et Nbd7
// => si Nd7 est prsent, c'est que Nbd7 est superflu
// => Transformer Nbd7 en Nd7
if ( length1==3 && length2==4 )
{
a=temp_string2[2]; // troisime caractre
if ( a=='a' || a=='b' || a=='c' || a=='d' || a=='e' || a=='f' || a=='g' || a=='h' )
{
pgn_supprime_second_caractere(temp_string2);
}
}
if ( length1==4 && length2==3 )
{
a=temp_string1[2]; // troisime caractre
if ( a=='a' || a=='b' || a=='c' || a=='d' || a=='e' || a=='f' || a=='g' || a=='h' )
{
pgn_supprime_second_caractere(temp_string1);
}
} 


// Comparer les deux chanes 
// ( en tenant compte de casse pour distinguer bxc6 et Bxc6 )
cc=strcmp(temp_string1, temp_string2);
if (cc==0) return true; else return false;
} // fin pgn_compare


void initialize_standard_board_english(char *board)
{

// Initialisation board
memset(board,0,SIZE_OF_BOARD_88);

// Equivalent  
/*
for (i=0; i<=88; i++)
{
board[i]=0;
}
*/

// Remplissage de l'chiquier
// blancs
board[11]='R';
board[12]='P';
board[21]='N';
board[22]='P';
board[31]='B';
board[32]='P';
board[41]='Q';
board[42]='P';
board[51]='K';
board[52]='P';
board[61]='B';
board[62]='P';
board[71]='N';
board[72]='P';
board[81]='R';
board[82]='P';
// noirs
board[18]=-'R';
board[17]=-'P';
board[28]=-'N';
board[27]=-'P';
board[38]=-'B';
board[37]=-'P';
board[48]=-'Q';
board[47]=-'P';
board[58]=-'K';
board[57]=-'P';
board[68]=-'B';
board[67]=-'P';
board[78]=-'N';
board[77]=-'P';
board[88]=-'R';
board[87]=-'P';

} // fin initialize_standard_xxboard_english



void convert_to_xx_and_play(short nbcoups, char *move, char stat, char *board)
{
ENTREE_BIBLIOTHEQUE_88 * entree;
char length;
//char F_petit_roque;
//char F_grand_roque;
//char F_promotion;
//char F_coup_pion_2_caracteres;
//char F_ep;
//char *ptr;
char buff[4];
char dep, arr;
char provenance_x;
char provenance_y;
char piece;
char special;
char piece_prom;
char F_coup_identifie;
char color;

// Initialisations
F_coup_identifie=0;
special=0;
piece_prom=0;
dep=0;
arr=0;
provenance_x=0;
provenance_y=0;



// Contrle de limite
if (nbcoups>OPENING_BOOK_LENGTH) return;

// Tableau xbibliotheque_xx
entree=&xbibliotheque_88[xbibliotheque_nb_games-1][nbcoups-1];

// Initialisations 
entree->nbcoups=nbcoups;
entree->prom=0;
// Marquage fin de partie
(entree+1)->dep88=0;

// Couleur
color=2*M_2(nbcoups)-1;

// Purge des caractres inutiles
transforme_notation_pgn(move);

// F_interdiction
length=(char) strlen(move);
if (move[length-1]=='@') 
	{ entree->F_interdiction=1; move[length-1]='\0'; length--; }
else 	{ entree->F_interdiction=0; }


// Do identification
do
{

// S'agit-il d'un roque
if ( strcmpi(move,"o-o")==0 )   
{ 
	if ( color==1 )	{ special=1; dep=51; arr=71; }
	else 			{ special=1; dep=58; arr=78; }
	F_coup_identifie=1; 
	break;
}
if ( strcmpi(move,"o-o-o")==0 ) 
{ 
	if ( color==1 )	{ special=1; dep=51; arr=31; }
	else 			{ special=1; dep=58; arr=38; }
	F_coup_identifie=1; 
	break;
}

// S'agit-il d'une promotion
// ( tronquer move aprs obtention de la pice promue )
if ( move[length-2]=='=' ) 
{ 
special=3;
piece_prom=move[length-1];
move[length-2]='\0';
length-=2;
}

// S'agit-il d'un coup de pion sur 2 caracteres ( c7 ou c8 ou cd )
if ( length==2 )
{
	piece='P'; // Supposition car il peut s'agir d'une prise de pice
	F_coup_identifie=recherche_coup_pion_2_caracteres(move, color, dep, arr, board);
	if ( F_coup_identifie==1 )
	{
		// Identification des prises en passant
		if ( 
			(color== 1 && board[arr]==0 && Y88(arr)==6 && board[arr-color]==-color*'P') 
			||
		    (color==-1 && board[arr]==0 && Y88(arr)==3 && board[arr-color]==-color*'P') 
           )
		{ special=2; }
		break;
	}
}



// Length>=3 pouvant aller jusqu' 5 : Nd2b3

// Dtermination de la case d'arrive
buff[0]=move[length-2];
buff[1]=move[length-1];
buff[2]='\0';
// 'A' = 97
arr=(buff[0]-'a'+1)*10+buff[1]-'0';
if ( arr<11 || arr>88 || buff[1]=='0' || buff[1]=='9' ) return;

// bxc6 ( s'agit-il de bxc6 ou de Bxc6 ? )
if ( length==3 && move[0]=='b' && ( buff[0]>='a' && buff[0]<='h' ) )
{
	piece='P'; // supposition
    F_coup_identifie=recherche_coup_pion_3_caracteres(move, color, dep, arr, board);	
	if ( F_coup_identifie==0 ) { move[0]='B'; piece='B'; }
	else // coup de pion identifie
	{
		// Identification des prises en passant
		if ( 
			(color==1  && Y88(arr)==6 && board[arr-color]==-color*'P') ||
		     	(color==-1 && Y88(arr)==3 && board[arr-color]==-color*'P') 
               )
		{ special=2; }
		break;
	}	
}
else 
{
// Coup de pion sur 3 caractres
if ( length==3 && move[0]>='a' && move[0]<='h' )
{
	piece='P'; // supposition
    F_coup_identifie=recherche_coup_pion_3_caracteres(move, color, dep, arr, board);	
	if ( F_coup_identifie==1 )
	{
		// Identification des prises en passant
		if ( 
			(color== 1 && board[arr]==0 && Y88(arr)==6 && board[arr-color]==-color*'P') 
			||
		    (color==-1 && board[arr]==0 && Y88(arr)==3 && board[arr-color]==-color*'P') 
           )
		{ special=2; }
		break;
	}
	break;
}
}


// Piece
piece=move[0];

// Indicateur de provenance - ex : Cbd7 ou C6d7
if ( length==4 || length==5 ) 
{
if ( move[1]>='a' && move[1]<='h' ) provenance_x=move[1]-'a'+1;
if ( move[1]>='1' && move[1]<='8' ) provenance_y=move[1]-'1'+1;
}
if ( length==5 ) 
{
if ( move[2]>='a' && move[2]<='h' ) provenance_x=move[2]-'a'+1;
if ( move[2]>='1' && move[2]<='8' ) provenance_y=move[2]-'1'+1;
}



// Recherche coup piece ( recherche case de dpart )
F_coup_identifie=recherche_coup_piece(piece, color, provenance_x, provenance_y, dep, arr, board);

// Sortie de la boucle
break;

} while(1); // fin do identification

if ( F_coup_identifie==0 ) 
	return; // coup non identifi

// Stat
entree->stat=stat;


// Contrle 
#if DEBUG==1
if ( dep<11 || dep>88 || arr<11 || arr>88 )
{
	log_error("\nErreur P_874",MAJOR);
}
#endif

// Jeu du coup
switch((short) special)
{
case 0 : // Coup normal
		  board[arr]=board[dep]; // so simple 
	      board[dep]=0;
		break;
case 1 : // Roques
	switch(arr)
	{
	case 71 : // Petit roque blanc
	      board[51]=0;
	      board[61]='R';
		  board[71]='K';
	      board[81]=0;
		break;
	case 31 : // Grand roque blanc 

	      board[51]=0;
	      board[31]='K';
		  board[41]='R';
	      board[11]=0;
		break;
	case 78 : // Petit roque noir 
	      board[58]=0;
	      board[68]=-'R';
		  board[78]=-'K';
	      board[88]=0;
		break;
    case 38 : // Grand roque noir
	      board[58]=0;
	      board[38]=-'K';
		  board[48]=-'R';
	      board[18]=0;
		break;
	}
	break;
case 2 : // Prise en passant
		board[arr]=board[dep]; 
		board[arr-color]=0;
		board[dep]=0;
		break;
case 3 : // Promotion
		board[arr]=piece_prom*color;
		board[dep]=0;
		break;
default : break;
}

entree->dep88=dep;
entree->arr88=arr;
entree->special=special;
entree->prom=english_to_french(piece_prom);
entree->F_match=0;
if ( nbcoups==1) 
{ 
entree->signature_blanc=arr*arr-dep*dep;
entree->signature_noir=0;
}
else
{
#if DEBUG==1
//char cc;
//if (nbcoups==2 && entree->dep88==47 && entree->arr88==45 && (entree-1)->dep88==52 && (entree-1)->arr88==54)
//	cc=0;
#endif
if ( color==1 ) 
{ 
// blanc
entree->signature_blanc=(entree-1)->signature_blanc+arr*arr-dep*dep;
entree->signature_noir =(entree-1)->signature_noir;
}
else // noir
{
entree->signature_blanc=(entree-1)->signature_blanc;
entree->signature_noir =(entree-1)->signature_noir+arr*arr-dep*dep;
}
} // fin premier else


} // fin convert_to_xx_and_play



char recherche_coup_pion_2_caracteres(char *move, char color, char &dep, char &arr, char *board)
{
// retourne le couple (dep, arr)
char col_arr, col_dep;
char y;
char dep1, dep2;

// Test : la case d'arrive est-elle numrique ( Ex: d4 )
if ( move[1]>='1' && move[1]<='8' )
{
arr=(move[0]-'a'+1)*10+(move[1]-'0');
if ( arr<11 || arr>88 ) return 0;
dep=arr-color; if ( board[dep]=='P'*color ) { return 1; }
dep=arr-color-color; if ( board[dep]=='P'*color ) { return 1; }
return 0; 
}

// Prise - Ex : bc

// Initialisations
col_dep=move[0]-'a'+1;
col_arr=move[1]-'a'+1;

// Recherche  partir de la colonne d'arrive
for ( y=1; y<=8; y++ )
{
arr=col_arr*10+y;
if ( SIGNE(board[arr])!=-color ) continue;
// La case d'arrive est bien occupe par une pice adverse
// Deux possibilits
dep1=arr-11*color;
dep2=arr+ 9*color;
if ( dep1<11 || dep1>88 ) dep1=0;
if ( dep2<11 || dep2>88 ) dep2=0;
if ( X88(dep1)==col_dep && board[dep1]=='P'*color ) { dep=dep1; return 1; }
if ( X88(dep2)==col_dep && board[dep2]=='P'*color ) { dep=dep2; return 1; }
// si on n'a pas trouv de pion pouvant prendre la pice, passer  la case d'arrive suivante
continue;
}
// Recherche prise en passant 
if ( color==1 )
{
arr=col_arr*10+6;
if ( board[arr]==0 && board[arr-color]=='P'*-color )
{
dep1=arr-11*color;
dep2=arr+ 9*color;
if ( dep1<11 || dep1>88 ) dep1=0;
if ( dep2<11 || dep2>88 ) dep2=0;
if ( X88(dep1)==col_dep && board[dep1]=='P'*color ) { dep=dep1; return 1; }
if ( X88(dep2)==col_dep && board[dep2]=='P'*color ) { dep=dep2; return 1; }
}
}
if ( color==-1 )
{
arr=col_arr*10+3;
if ( board[arr]==0 && board[arr-color]=='P'*-color )
{
dep1=arr-11*color;
dep2=arr+ 9*color;
if ( dep1<11 || dep1>88 ) dep1=0;
if ( dep2<11 || dep2>88 ) dep2=0;
if ( X88(dep1)==col_dep && board[dep1]=='P'*color ) { dep=dep1; return 1; }
if ( X88(dep2)==col_dep && board[dep2]=='P'*color ) { dep=dep2; return 1; }
}
}

// Sinon problme
return 0;
}


char recherche_coup_pion_3_caracteres(char *move, char color, char &dep, char &arr, char *board)
{
// retourne le couple (dep, arr)
// le coup est une prise du type bc6
// la case d'arrive a dja t dtermine
char dep1, dep2;
char col_dep;

// Initialisations
col_dep=move[0]-'a'+1;

// Deux possibilits
dep1=arr-11*color;
dep2=arr+ 9*color;
if ( dep1<11 || dep1>88 ) dep1=0;
if ( dep2<11 || dep2>88 ) dep2=0;
if ( X88(dep1)==col_dep && board[dep1]=='P'*color ) { dep=dep1; return 1; }
if ( X88(dep2)==col_dep && board[dep2]=='P'*color ) { dep=dep2; return 1; }

// Recherche prise en passant 
if ( color==1 && Y88(arr)==6 )
{
if ( board[arr]==0 && board[arr-color]=='P'*-color )
{
dep1=arr-11*color;
dep2=arr+ 9*color;
if ( dep1<11 || dep1>88 ) dep1=0;
if ( dep2<11 || dep2>88 ) dep2=0;
if ( X88(dep1)==col_dep && board[dep1]=='P'*color ) { dep=dep1; return 1; }
if ( X88(dep2)==col_dep && board[dep2]=='P'*color ) { dep=dep2; return 1; }
}
}
if ( color==-1 && Y88(arr)==3 )
{
if ( board[arr]==0 && board[arr-color]=='P'*-color )
{
dep1=arr-11*color;
dep2=arr+ 9*color;
if ( dep1<11 || dep1>88 ) dep1=0;
if ( dep2<11 || dep2>88 ) dep2=0;
if ( X88(dep1)==col_dep && board[dep1]=='P'*color ) { dep=dep1; return 1; }
if ( X88(dep2)==col_dep && board[dep2]=='P'*color ) { dep=dep2; return 1; }
}
}


// Sinon il y a problme !!
return 0;
}



char recherche_coup_piece(char piece, char color, char provenance_x, char provenance_y, char &dep, char &arr, char *board)
{
// retourne le couple (dep, arr) 
// mais arr est dja connu

// provenance_x et provenance_y doivent matcher ou tre gaux  -1

char F_coup_identifie;

// Initialisations
F_coup_identifie=0;


switch(piece)
{
case 'N' : // Cavaliers
	     F_coup_identifie=pgn_sub_recherche_cava_roi(+12,'N',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(+21,'N',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(+19,'N',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(+ 8,'N',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(-12,'N',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(-21,'N',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(-19,'N',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(- 8,'N',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     break;
case 'B' : // Premire diagonale
	     F_coup_identifie=pgn_sub_recherche_piece(-11,'B',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_piece(+11,'B',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     // Deuxime diagonale
	     F_coup_identifie=pgn_sub_recherche_piece(- 9,'B',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_piece(+ 9,'B',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     break;
case 'R' : // Verticale
	     F_coup_identifie=pgn_sub_recherche_piece(- 1,'R',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_piece(+ 1,'R',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     // Horizontale
	     F_coup_identifie=pgn_sub_recherche_piece(-10,'R',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_piece(+10,'R',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     break;
case 'Q' : // Premire diagonale
	     F_coup_identifie=pgn_sub_recherche_piece(-11,'Q',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_piece(+11,'Q',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     // Deuxime diagonale
	     F_coup_identifie=pgn_sub_recherche_piece(- 9,'Q',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_piece(+ 9,'Q',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_piece(- 1,'Q',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_piece(+ 1,'Q',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     // Horizontale
	     F_coup_identifie=pgn_sub_recherche_piece(-10,'Q',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_piece(+10,'Q',color,dep,arr,provenance_x,provenance_y, board);
     	     if ( F_coup_identifie==1 ) break;
	     break;
case 'K' : F_coup_identifie=pgn_sub_recherche_cava_roi(-11,'K',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(+11,'K',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(- 9,'K',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(+ 9,'K',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(- 1,'K',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(+ 1,'K',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(-10,'K',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     F_coup_identifie=pgn_sub_recherche_cava_roi(+10,'K',color,dep,arr,provenance_x,provenance_y, board);
	     if ( F_coup_identifie==1 ) break;
	     break;
}

return F_coup_identifie;
} // fin recherche_coup_piece



char pgn_sub_recherche_cava_roi(char inc, char piece, char color, char &dep, char &arr, 
					  char provenance_x, char provenance_y, char *board)
{
char dep_color;

// Dep
dep=arr+inc;

// Contrle limites
if ( dep<11 || dep>88 ) return 0;

// Cavalier ou roi demand ?
if ( abs(board[dep])!=piece ) return 0;

// Pice de la bonne couleur ?
dep_color=SIGNE(board[dep]);
if ( dep_color!= color) return 0;

// Correspondance provenance
if ( X88(dep)!= provenance_x && provenance_x!=0 ) return 0;
if ( Y88(dep)!= provenance_y && provenance_y!=0 ) return 0;

// Succs ( dep a t positionn )
return 1;
} // fin pgn_sub_recherche_cava



char pgn_sub_recherche_piece(char inc, char piece, char color, char &dep, char &arr, 
					char provenance_x, char provenance_y, char *board)
{
char dep_color;
char dep_x, dep_y;
char case_cible;

// Initialisation dep
dep=arr;

// Boucle
do
{
dep=dep+inc;
if ( dep<11 || dep>88 ) return 0;
dep_y=Y88(dep);
if ( dep_y==0 || dep_y==9 ) return 0;
dep_x=X88(dep);

// Case vide ?
case_cible=board[dep];
if  ( case_cible==0 ) continue;

// Piece demande ?
if ( abs(case_cible)!=piece ) return 0;

// Pice de la bonne couleur ?
dep_color=SIGNE(case_cible);
if ( dep_color!= color) return 0;

// Correspondance provenance
if ( dep_x != provenance_x && provenance_x!=0 ) return 0;
if ( dep_y != provenance_y && provenance_y!=0 ) return 0;

// Succs : dep est positionn
break; 
} while(1);

// Succs
// ( dep a t positionn )
return 1;
} // fin pgn_sub_recherche_cava


char pgn_a1_to_88(char *buff)
{
	return (buff[0]-'a'+1)*10+buff[1]-'0';
;
}

char pgn_a1_to_64(char *buff)
{
	return ((buff[0]-'a'+1)<<3)+buff[1]-'1';
;
}
