#include "stdafx.h"
#include "Cchess_1.h"
#include "Cchess_2.h"
//#include "Cchess_3.h"
#include "Cchess_4.h"
#include "Cchess_5.h"
#include "Cchess_6.h"
 


void SEARCH::search_initialize_move_generator()
{
char dep, arr;
char cc,dd;
MOVE move;

#if USE_REDUCTIONS==1
F_allow_reduction=false;
#endif
F_hint_move_has_been_played=false;
nb_coups_liste=0;
F_creation_liste=false;
F_utilisation_liste=false;
//nb_attaques_pion=0;
idxmove=-1;
#if USE_CASES_ACTUALISATION==1
F_piece_with_possibly_illegal_moves=true;
#endif

// Contrle de lgalit du hint_move
// et insertion dans liste hint_move
if (hint_move!=0) 
{
if (MOVE_IS_FOR_PLAY(hint_move))
{
dd=0;
do
{
	dep=MOVE_DEP64(hint_move);
	arr=MOVE_ARR64(hint_move);
	num=xboard[dep].num_piece;
	if (num<debut_blanc || num>fin_blanc)
	{
		#if DEBUG==1
		{

			// Minor car aprs tout une collision en hash table
			// et tout de mme possible, retournant un hint_move impossible
			log_error("SM_814", xcompteur,MINOR);
		}
		#endif
		break;
      }
	numptr=&xw[num];
	if (numptr->nature==0) break;
	if (MOVE_IS_CAPTURE(hint_move) || MOVE_PROMOTION(hint_move)=='D')
	{
		moveptr=numptr->psptr->moves2;
	}
	else
	{
		moveptr=numptr->psptr->moves;
	}
	for(;;moveptr++)
	{
		move=*moveptr;
		if (move==0) break;
		
		if (SAME_MOVE(move,hint_move))
		{
			// Contrle lgalit
			#if USE_CASES_ACTUALISATION==1
			if (bit(pieces_with_possible_illegal_moves,numptr->num_piece))
			#endif
			{
				cc=SEARCH::legal(num,move,num_roi,*lignemoins);
				if (cc!=1) break;
			}

			dd=1; // hint_move est lgal : IMPORTANT
			nb_coups_liste=1;
			listmovesptr=&listmoves[0];
			*listmovesptr=xempty_listlevel_entry;
			listmovesptr->move=move; 		   	            (listmovesptr+1)->move=0;
			#if _DEBUG==1
			listmovesptr->dep88=MOVE_DEP88(move);
			listmovesptr->arr88=MOVE_ARR88(move);
			#endif
			listmovesptr->num=num;
			listmovesptr->type=numptr->type;
			//listmovesptr->legal=LEGAL;
			//F_hint_move_has_been_played=true; // si : pour la cration de liste 
			//*listmovesptr=move;
			//listmovesptr->move_nature=MOVE_NATURE(move);
			//listmovesptr->categorie=(char) MOVE_CATEGORY(move);
			//listmovesptr->capture_value=MOVE_CAPTURE_VALUE(move);
			//listmovesptr->Fplay=0;
			//listmovesptr->bilan_coup=BILAN_NON_CALCULE;
			//listmovesptr->hash=HASH_NON_DETERMINE;
			//listmovesptr->draw_status=DRAW_STATUS_NOT_DETERMINED;
			//F_nouvelle_piece=true; // ?? pas si utilisation liste
			F_utilisation_liste=true;
			ASSERT(!F_listmoves2_created);
			listmovesptr=&listmoves[0]-1;
			break;
		}
	} 
	break;
} while(1);
// Annulation du hint_move si illgal
if (dd==0) 
{
	hint_move=0;
}
}
} // fin hint_move!=0


// Attention : le hint_move peut avoir t annul
if (hint_move!=0) 
{
		phase_generation=PRISES;
		analysis=SEARCH_ANALYSE_HINT_MOVE;
	    #if COLLECT_STATS==1
		   origine_coups_analysis=OR_SEARCH_ANALYSE_HINT_MOVE;
		#endif
}
else 
{
		phase_generation=PRISES;
		listmovesptr=&listmoves[0]-1;
		listmoves[0].move=0;
		numptr=&xw[debut_blanc]; num=debut_blanc;
		while(num<=fin_blanc)
		{
			if (numptr->nature!=0 && numptr->psptr->mobility_prises!=0)
			{ break; }
			numptr++; num++;
		}
		// Si pas de prises sortir en crant une liste de prises vides
		// afin de repartir sur les killermoves
		// On ne peut pas aller directement aux coups heuristiques
		if (num>fin_blanc) 
		{
			phase_generation=AUTRES_COUPS;
			numptr=&xw[debut_blanc]; num=debut_blanc;
			while(num<=fin_blanc)
			{
				if (numptr->nature!=0 && numptr->psptr->mobility_others!=0)
				{ break; }
				numptr++; num++;
			}
			// Absence de prises
			// Si chec, on peut aller en autres coup
			// Maus c'est dommage de court-circuiter les tsts sur la futilit
			// Donc on cre une liste vide de prises et on prend les tests de futilit
			// if (check) { analysis=SEARCH_ANALYSE_AUTRES_COUPS; } else
			{ 
				// Liste vide permettant de passer ensuite aux killermoves
				analysis=SEARCH_ANALYSE_PRISES;
				F_utilisation_liste=true;
				idxmove=-1;
				listmovesptr=&listmoves[0]-1;
				listmoves[0]=xempty_listlevel_entry;;
				return;
			}

		    #if COLLECT_STATS==1
			 origine_coups_analysis=OR_SEARCH_ANALYSE_COUPS_HEURISTIQUES;
			#endif
			F_nouvelle_piece=true; 
			#if USE_CASES_ACTUALISATION==1
			F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
			#endif
			moveptr=numptr->psptr->moves; // 
			goto RETURN;
		}
		analysis=SEARCH_ANALYSE_COUPS_FAVORABLES;
	    #if COLLECT_STATS==1
		    origine_coups_analysis=OR_SEARCH_ANALYSE_COUPS_FAVORABLES;
		#endif
		F_nouvelle_piece=true; 
		#if USE_CASES_ACTUALISATION==1
		F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
		#endif
		moveptr=numptr->psptr->moves2; // prises
		goto RETURN;
}


RETURN:
return;
} // fin initialize



// le SEARCH::get_move renvoie en fait le couple move+listmovesptr 
MOVE SEARCH::search_get_move(void)
{
char cc;
char bilan_coup;
char cat;
char i;
MOVE move,move2;
char dep, arr;

//NEXT_MOVE:
if (F_utilisation_liste)
{
	if (F_listmoves2_created 
		)
	{
		NEXT_MOVE_LISTMOVES2:
		do {
		listmovesptr=*(++listmoves2ptr); 
		if (listmovesptr==NULL) return 0;
		idxmove++;
		}
		while(listmovesptr->Fplay!=0); 
		return listmovesptr->move;
		// pas de test sur Fplay
	}
	else 
	{
		NEXT_MOVE_LISTMOVES:
		ASSERT(!F_listmoves2_created);
		do {
			move=(++listmovesptr)->move; 

			if (move==0)
			{
				goto CHANGEMENT_ANALYSIS;
			}
			idxmove++;
		}
		while (listmovesptr->Fplay!=0);
		// NON : return move; le coup doit tre filtr
	}
}
else 
{
NEXT_MOVE_NO_LISTE:
// !F_utilisation_liste
if (F_nouvelle_piece)
{
	F_nouvelle_piece=false;
	move=*moveptr;
	ASSERT(move!=0);
}
else // !F_nouvelle_piece
{
	move=*(++moveptr);
	if (move==0)
	{
			switch(phase_generation)
			{
			case PRISES : 
				numptr++; num++;
				while(num<=fin_blanc)
				{
					if (numptr->nature!=0 && numptr->psptr->mobility_prises!=0)
					{ break; }
					numptr++; num++;
				}
				if (num>fin_blanc) 
				{ goto CHANGEMENT_ANALYSIS; }
				moveptr=numptr->psptr->moves2; 
				F_nouvelle_piece=true; 
				#if USE_CASES_ACTUALISATION==1
				F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
				#endif
				goto NEXT_MOVE_NO_LISTE;
				break;
			case AUTRES_COUPS :
				numptr++; num++;
				while(num<=fin_blanc)
				{
					if (numptr->nature!=0 && numptr->psptr->mobility_others!=0)
					{ break; }
					numptr++; num++;
				}
				if (num>fin_blanc) 
				{ goto CHANGEMENT_ANALYSIS; }
				moveptr=numptr->psptr->moves; 
				F_nouvelle_piece=true; 
				#if USE_CASES_ACTUALISATION==1
				F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
				#endif
				goto NEXT_MOVE_NO_LISTE;
				break;
			}
			// Seulement par goto
			CHANGEMENT_ANALYSIS:
			switch(analysis)
			{
				case SEARCH_ANALYSE_HINT_MOVE :
						  F_hint_move_has_been_played=true;
						  #if COLLECT_STATS==1
						  origine_coups_analysis=OR_SEARCH_ANALYSE_COUPS_FAVORABLES;
						  #endif
						  analysis=SEARCH_ANALYSE_COUPS_FAVORABLES;
						  phase_generation=PRISES;
			 			  numptr=&xw[debut_blanc]; num=debut_blanc;
		  				  while(num<=fin_blanc)
						  {
							if (numptr->nature!=0 && numptr->psptr->mobility_prises!=0)
							{ break; }
							numptr++; num++;
						  }
						  // Si pas d'autres coups, sortir
						  if (num>fin_blanc) 
						  {
							  F_pas_de_prises=true;
							  goto SEARCH_KILLERMOVES;
						  }		
						  F_utilisation_liste=false;
						  F_nouvelle_piece=true; 
						  #if USE_CASES_ACTUALISATION==1
						  F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
						  #endif
						  idxmove=-1;
						  moveptr=numptr->psptr->moves2;
						  listmovesptr=&listmoves[nb_coups_liste]-1; // aprs le hint_move
						  goto NEXT_MOVE_NO_LISTE; // pour contrle de lgalit
				break;

				case SEARCH_ANALYSE_COUPS_FAVORABLES : 
 
				      // Cloture provisoire de liste
					  listmoves[nb_coups_liste].move=0;

					  #if ALLOW_REDUCTIONS==1
					   ASSERT(F_allow_reduction==false);
					  #endif
						  analysis=SEARCH_ANALYSE_PRISES;
						  #if COLLECT_STATS==1
						  origine_coups_analysis=OR_SEARCH_ANALYSE_PRISES;
						  #endif


							#if USE_SEARCH_UNDEFENDED_PIECES==1
							// Inventaire des pices non dfendues
							if (!F_inventaire_pieces_non_defendues)
							{
							#if USE_SEARCH_ALL_UNDEFENDED_PIECES==1
							inventaire_pieces_non_defendues(
								//s,a,b,pieces_non_defendues,F_piece_non_defendue,
								//nb_pieces_non_defendues, nb_pions_non_defendus,
								//max_valeur_pieces_non_defendues,
								//max_valueprise_bilan,
								//case_cible_heuristique_protection
								);
							#else
							inventaire_pieces_non_defendues();
							#endif
							}
							#endif




					F_utilisation_liste=true;
					idxmove=-1;
					listmovesptr=&listmoves[0]-1;
					goto NEXT_MOVE_LISTMOVES;


				  break;


						  
				case SEARCH_ANALYSE_PRISES :

					SEARCH_KILLERMOVES:

					  // Si pas de killermoves
					  if (killermoves[0]==0) 
					  {	 goto SEARCH_COUPS_HEURISTIQUES; } 


						// Futility is ok here WITH condition CHECK!=0
					    // Because killer moves are not captures
					    // Therefore they cannot improve value unless
					    // there is sufficient depth search
					    // Mais le coup pourrait tre bon s'il donnait chec
                        // Ce qui n'est probablement pas le cas si nous sommes nous mmes en chec
					    // Donc ok pour ma futilit si et seulement si nous sommes en chec
							#if ALLOW_FUTILITY_4==1
							if (//1==2 &&
								check!=0 && // !=0
								#if FUTILITY_4_ONLY_LASTDEPTH==1
								 xF_derniere_profondeur_a_examiner
								&&
								#endif
								(
								 F_depthtarget_level_reached
								  #if ALLOW_FUTILITY_4_EXTENSION_1==1
								   || (xlevel>=depthtarget_level-1
								    // les killermoves ne sont pas des captures
								    && valpos+POSITIONAL_PRUNING_MARGIN<sup_alpha_value
 									  //&& alpha<MATE_VALUE_THRESHOLD
								  )
								  #endif
								  #if ALLOW_FUTILITY_4_EXTENSION_2==1
   								  || (xlevel>=depthtarget_level-2
								     // In theory We could have checkmate after defending against check
									 // In practice, if black defends against mate threat
									 // with a sacrifice check, we are above alpha
									 && valpos+POSITIONAL_PRUNING_MARGIN<sup_alpha_value
   									 //&& alpha<MATE_VALUE_THRESHOLD
									)
								  #endif
									
								)
								// && check==0 inutile
								// && node_type!=NODE_PV
								//&& previous_search_level->node_type!=NODE_PV
								// && previous_search_level->check==0 // inutile : checs en heuristiques
								// Seules les reprises/echecs nous feraient passer au dessus de sup_alpha_value
								&& valpos+POSITIONAL_PRUNING_MARGIN<sup_alpha_value
								&& alpha<MATE_VALUE_THRESHOLD
								//&& F_real_move_has_been_registered
								//&& F_level_impair // pas de futilit 4 pour pair
								&& s->finale!=ROI_VS_ROI
								)
							{
								if (valpos+POSITIONAL_PRUNING_MARGIN>value)
								{
									Fsel=true;
									xcompteur++; if (check_time_and_keyboard_for_return()) { xreturn=true; }
									#if COLLECT_STATS==1
									switch(node_type)
									{
										case NODE_PV  : xnodes_pv++; break;
										case NODE_CUT : xnodes_cut++; break;
										case NODE_ALL : xnodes_all++; break;
									}
									#endif
									value=inf(sup_alpha_value,valpos+POSITIONAL_PRUNING_MARGIN);
									*best=LigneEnd;
								}
								//min_fail_low_value=sup(min_fail_low_value,valpos+POSITIONAL_PRUNING_MARGIN);
								//min_fail_low_value=inf(valpos+POSITIONAL_PRUNING_MARGIN,alpha);
								ASSERT(value<=sup_alpha_value);
								// Court-circuite les "autres coups"
								return 0;
							}
							#endif



					  analysis=SEARCH_ANALYSE_KILLERMOVES;
				      #if COLLECT_STATS==1
				       origine_coups_analysis=OR_SEARCH_ANALYSE_KILLERMOVES;
					  #endif

					  F_utilisation_liste=true;
					  for (i=0;i<NOMBRE_KILLERMOVES;i++)
					  {
						  listlevel_killermoves[i]=xempty_listlevel_entry;
						  ASSERT(listlevel_killermoves[i].Fplay==0);
						  // listlevel_killermoves[i].Fplay=0;
						  listlevel_killermoves[i].move=killermoves[i];
					  }
					  // Clture liste listlevel_killermoves
					  listlevel_killermoves[NOMBRE_KILLERMOVES].move=0;
					  listmovesptr=&listlevel_killermoves[0]-1;
					  idxmove=-1;
					  goto NEXT_MOVE_LISTMOVES;


				case SEARCH_ANALYSE_KILLERMOVES:

					// La recherche des coups heuristiques permet 
					// de crer la listmoves et donc la listmoves2 est d'ordonner les coups
					// par priorit, ce qui est intressant
					// si on compte appliquer depthmoves-2 derrire

					SEARCH_COUPS_HEURISTIQUES:

					if (check==0
						#if SEARCH_ANALYSE_COUPS_HEURISTIQUES_ONLY_ON_DEPTHTARGET==1
						&&
						F_depthtarget_level_reached						
						#endif
						)
					{
						  analysis=SEARCH_ANALYSE_COUPS_HEURISTIQUES;
						  #if COLLECT_STATS==1
						  origine_coups_analysis=OR_SEARCH_ANALYSE_COUPS_HEURISTIQUES;
						  #endif
						  // Could be commented
						  // It remains to be decided whether or not to allow 
						  // fruit pruning for heuristic moves
					      #if USE_REDUCTIONS==1
						  SEARCH::set_allow_reduction();
						  #endif

						  #if HEURISTIC_PIECE_EVASION==1
						  hanging_pieces=cases_occupees_color01[wtm]
										& (~cases_controlees_joueur)
										& cases_controlees_adversaire
										& (~((unsigned __int64)1<<s->roi_pos[wtm]))
										;
						  #endif


						  phase_generation=AUTRES_COUPS;
						  numptr=&xw[debut_blanc]; num=debut_blanc;
		  				  while(num<=fin_blanc)
						  {
							if (numptr->nature!=0 && numptr->psptr->mobility_others!=0)
							{ break; }
							numptr++; num++;
						  }				  // Si pas d'autres coups, sortir
						  if (num>fin_blanc) { goto CHANGEMENT_ANALYSIS; }
						  // Pour compltion par la suite des autres coups
						  moveptr=numptr->psptr->moves;
						  // Remarque : si on sort d'analyse des coups favorables
						  // listmovesptr pointe sur la premire entre nulle
						  // nb_coups_liste==listmovesptr-&listmoves[0]
						  // Si pas de prises, listmovesptr

						  //listmovesptr=&listmoves[nb_coups_liste];
					

						  listmovesptr=&listmoves[nb_coups_liste]-1;
						  idxmove=nb_coups_liste-1;
						  F_utilisation_liste=false;
						  F_nouvelle_piece=true; 
						  #if USE_CASES_ACTUALISATION==1
						  F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
						  #endif
						  goto NEXT_MOVE_NO_LISTE;
					}
					else // check!=0
					{

							#if ALLOW_FUTILITY_4==1
							if (//check==0 &&
								#if FUTILITY_4_ONLY_LASTDEPTH==1
								 xF_derniere_profondeur_a_examiner
								&&
								#endif
								(
								 F_depthtarget_level_reached
								  #if ALLOW_FUTILITY_4_EXTENSION_1==1
								   || (xlevel>=depthtarget_level-1
								    // les killermoves ne sont pas des captures
								    && valpos+POSITIONAL_PRUNING_MARGIN<sup_alpha_value
 									  //&& alpha<MATE_VALUE_THRESHOLD
								  )
								  #endif
								  #if ALLOW_FUTILITY_4_EXTENSION_2==1
   								  || (xlevel>=depthtarget_level-2
								     // In theory We could have checkmate after defending against check
									 // In practice, if black defends against mate threat
									 // with a sacrifice check, we are above alpha
									 && valpos+POSITIONAL_PRUNING_MARGIN<sup_alpha_value
   									 //&& alpha<MATE_VALUE_THRESHOLD
									)
								  #endif
								)
								// && check==0 inutile
								// && node_type!=NODE_PV
								//&& previous_search_level->node_type!=NODE_PV
								// && previous_search_level->check==0 // inutile : checs en heuristiques
								// Seules les reprises/echecs nous feraient passer au dessus de sup_alpha_value
								&& valpos+POSITIONAL_PRUNING_MARGIN<sup_alpha_value
								&& alpha<MATE_VALUE_THRESHOLD
								//&& F_real_move_has_been_registered
								//&& F_level_impair // pas de futilit 4 pour pair
								&& s->finale!=ROI_VS_ROI
								)
							{
								if (valpos+POSITIONAL_PRUNING_MARGIN>value)
								{
									Fsel=true;
									xcompteur++; if (check_time_and_keyboard_for_return()) { xreturn=true; }
									#if COLLECT_STATS==1
									switch(node_type)
									{
										case NODE_PV  : xnodes_pv++; break;
										case NODE_CUT : xnodes_cut++; break;
										case NODE_ALL : xnodes_all++; break;
									}
									#endif
									value=inf(sup_alpha_value,valpos+POSITIONAL_PRUNING_MARGIN);
									*best=LigneEnd;
								}
								//min_fail_low_value=sup(min_fail_low_value,valpos+POSITIONAL_PRUNING_MARGIN);
								//min_fail_low_value=inf(valpos+POSITIONAL_PRUNING_MARGIN,alpha);
								ASSERT(value<=sup_alpha_value);
								// Court-circuite les "autres coups"
								return 0;
							}
							#endif
 			
						
						  analysis=SEARCH_ANALYSE_AUTRES_COUPS;
						  #if USE_REDUCTIONS==1
							SEARCH::set_allow_reduction();
						  #endif

						  #if COLLECT_STATS==1
						  origine_coups_analysis=OR_SEARCH_ANALYSE_AUTRES_COUPS;
						  #endif

						  phase_generation=AUTRES_COUPS;
						  numptr=&xw[debut_blanc]; num=debut_blanc;
		  				  while(num<=fin_blanc)
						  {
							if (numptr->nature!=0 && numptr->psptr->mobility_others!=0)
							{ break; }
							numptr++; num++;
						  }				  // Si pas d'autres coups, sortir
						  if (num>fin_blanc) { goto CHANGEMENT_ANALYSIS; }
						  // Pour compltion par la suite des autres coups
						  moveptr=numptr->psptr->moves;
						  // Remarque : si on sort d'analyse des coups favorables
						  // listmovesptr pointe sur la premire entre nulle
						  // nb_coups_liste==listmovesptr-&listmoves[0]
						  // Si pas de prises, listmovesptr

						  //listmovesptr=&listmoves[nb_coups_liste];
					

						  listmovesptr=&listmoves[nb_coups_liste]-1;
						  idxmove=nb_coups_liste-1;
						  F_utilisation_liste=false;
						  F_nouvelle_piece=true; 
						  #if USE_CASES_ACTUALISATION==1
						  F_piece_with_possibly_illegal_moves=bit(pieces_with_possible_illegal_moves,num);
						  #endif
						  goto NEXT_MOVE_NO_LISTE;
					}

				break;


				case SEARCH_ANALYSE_COUPS_HEURISTIQUES:
			
				  // Cloture de liste
				 listmoves[nb_coups_liste].move=0;

				 // Allow reductions
				 #if USE_REDUCTIONS==1
				 SEARCH::set_allow_reduction();
				 #endif


  
				  #if ALLOW_FUTILITY_4==1
						if (
							#if FUTILITY_4_ONLY_LASTDEPTH==1
							 xF_derniere_profondeur_a_examiner
							&&
							#endif
							(
							 F_depthtarget_level_reached
						      #if ALLOW_FUTILITY_4_EXTENSION_1==1
							   || (xlevel>=depthtarget_level-1
							  #if USE_FRUIT_PRUNING==0                     
							    && valpos+600<sup_alpha_value
							  #endif
							  #if USE_FRUIT_PRUNING==1                     
   							    && valpos+POSITIONAL_PRUNING_MARGIN<sup_alpha_value
							    //&& valpos+600<sup_alpha_value
							  #endif
 								  //&& alpha<MATE_VALUE_THRESHOLD
							  )
							  #endif
							  #if ALLOW_FUTILITY_4_EXTENSION_2==1
   							  || (xlevel>=depthtarget_level-2
                                 && valpos+600<sup_alpha_value
   							     //&& alpha<MATE_VALUE_THRESHOLD
							    )
							  #endif
								
						    )
							// && check==0 inutile !
							// && node_type!=NODE_PV
							//&& previous_search_level->node_type!=NODE_PV
							// && previous_search_level->check==0 // inutile : checs en heuristiques
							// Seules les reprises/echecs nous feraient passer au dessus de sup_alpha_value
							&& valpos+POSITIONAL_PRUNING_MARGIN<sup_alpha_value
							&& alpha<MATE_VALUE_THRESHOLD
							//&& F_real_move_has_been_registered
							//&& F_level_impair // pas de futilit 4 pour pair
							&& s->finale!=ROI_VS_ROI
							)
						{
							if (valpos+POSITIONAL_PRUNING_MARGIN>value)
							{
								Fsel=true;
								xcompteur++; if (check_time_and_keyboard_for_return()) { xreturn=true;}
								#if COLLECT_STATS==1
								switch(node_type)
								{
									case NODE_PV  : xnodes_pv++; break;
									case NODE_CUT : xnodes_cut++; break;
									case NODE_ALL : xnodes_all++; break;
								}
								#endif
								value=inf(sup_alpha_value,valpos+POSITIONAL_PRUNING_MARGIN);
								*best=LigneEnd;
							}
							//min_fail_low_value=sup(min_fail_low_value,valpos+POSITIONAL_PRUNING_MARGIN);
							//min_fail_low_value=inf(valpos+POSITIONAL_PRUNING_MARGIN,alpha);
							ASSERT(value<=sup_alpha_value);
							// Court-circuite les "autres coups"
							return 0;
						}
				 #endif
 			
											  
					F_creation_liste=true;
					F_utilisation_liste=true;
					analysis=SEARCH_ANALYSE_AUTRES_COUPS;
					#if USE_REDUCTIONS==1
					SEARCH::set_allow_reduction();
					#endif
					#if COLLECT_STATS==1
					  origine_coups_analysis=OR_SEARCH_ANALYSE_AUTRES_COUPS;
					#endif
					if (F_no_listmoves2)
					{
						idxmove=-1;
						listmovesptr=&listmoves[0]-1;
						goto NEXT_MOVE_LISTMOVES;
					}
					else
					{
	  					search_listmoves2_create(
							true,false,false,false // ne pas tenir compte des wasbest pour le tri
							   );
						idxmove=-1;
						listmoves2ptr=&listmoves2[0]-1;
						goto NEXT_MOVE_LISTMOVES2;
					}

	
				break;

				case SEARCH_ANALYSE_AUTRES_COUPS :
					// Cloture de liste si direct depuis killermoves
					listmoves[nb_coups_liste].move=0;	
					
					return 0;
					break;

				case SEARCH_ANALYSE_LISTE :
					return 0;
					break;
			} 
			ASSERT(false);
	} // fin move==0
} // !F_nouvelle_piece
			

// Pas de test sur Fplay

// Elimination du hint_move si dja jou
if (F_hint_move_has_been_played)
{
if (SAME_MOVE(move,hint_move))
{
	goto NEXT_MOVE_NO_LISTE;
}
}


// Lgalit
#if USE_CASES_ACTUALISATION==1
if (F_piece_with_possibly_illegal_moves)
#endif
{
	cc=legal(num,move,num_roi,*lignemoins);
	if (cc!=1) // coup illgal
	{
		goto NEXT_MOVE_NO_LISTE;
	}
}
#if _DEBUG
cc=MOVE_NUM_PIECE(move);
cc=MOVE_ARR64(move);
ASSERT(legal(num,move,num_roi,*lignemoins)==1);
#endif

// Compteur de coups
nb_coups_liste++;
idxmove++;
listmovesptr++;
*listmovesptr=xempty_listlevel_entry;
listmovesptr->move=move;
listmovesptr->type=numptr->type;
//listmovesptr->move_nature=move_nature;
//listmovesptr->legal=LEGAL;
listmovesptr->num=num;
#if _DEBUG==1  
listmovesptr->dep88=MOVE_DEP88(move);
listmovesptr->arr88=MOVE_ARR88(move);
#endif

} // fin !F_creation_liste


PLAY_MOVES:
switch (analysis)
{
case SEARCH_ANALYSE_HINT_MOVE :
		
        /*
	    #if ALLOW_FUTILITY_4==1
		short valeur_prise;
		valeur_prise=MOVE_CAPTURE_VALUE(move);
		if 
		(							
		 valpos+valeur_prise+600<sup_alpha_value
		 && node_type!=NODE_PV
		 && !F_case_de_mat
		 &&
		#if FUTILITY_4_ONLY_LASTDEPTH==1
		 xF_derniere_profondeur_a_examiner
		&&
		#endif
			(
			F_depthtarget_level_reached
			#if ALLOW_FUTILITY_4_EXTENSION_1==1
  			|| (xlevel>=depthtarget_level-1
   			//&& alpha<MATE_VALUE_THRESHOLD
			)
			#endif
			
		 
			#if ALLOW_FUTILITY_4_EXTENSION_2==1
   			|| (xlevel>=depthtarget_level-2
    	     //&& alpha<MATE_VALUE_THRESHOLD
		    )
			#endif
			)
		 )
		{
			if (!(MOVE_IS_QUEEN(move) && SEARCH::givecheck(move,wtm))
				&& !MOVE_IS_FORCING(move)
		 //&& check==0
 		 //&& node_type!=NODE_PV
		 // && previous_search_level->check==0 // inutile : checs en heuristiques
		 // Seules les reprises/echecs nous feraient passer au dessus de sup_alpha_value

		 && alpha<MATE_VALUE_THRESHOLD
		 //&& F_level_impair // pas de futilit 4 pour pair
		 && s->finale!=ROI_VS_ROI
)
			{

							// Si enregistr > alpha, value
							// Sinon alpha
							// Donc :
							if (valpos+valeur_prise+POSITIONAL_PRUNING_MARGIN>value)
							{
								Fsel=true;
								xcompteur++; if (check_time_and_keyboard_for_return() { xreturn = true;}
								#if COLLECT_STATS==1
								switch(node_type)
								{
									case NODE_PV  : xnodes_pv++; break;
									case NODE_CUT : xnodes_cut++; break;
									case NODE_ALL : xnodes_all++; break;
								}
								#endif
								if (valpos+valeur_prise+POSITIONAL_PRUNING_MARGIN>value)
								{ value=valpos+valeur_prise+POSITIONAL_PRUNING_MARGIN; }
								value=inf(valpos+valeur_prise+POSITIONAL_PRUNING_MARGIN,sup_alpha_value);
								*best=LigneEnd;
							}
							//min_fail_low_value=sup(min_fail_low_value,valpos+POSITIONAL_PRUNING_MARGIN);
							//min_fail_low_value=inf(valpos+si1+POSITIONAL_PRUNING_MARGIN,alpha);
							ASSERT(value<=sup_alpha_value);
							// Court-circuite les "autres coups"
							goto CHANGEMENT_ANALYSIS;
						}
				}
				 #endif
	*/

		listmovesptr->priority=TransScore; // Au minimum
		return move;
		break;

case SEARCH_ANALYSE_COUPS_FAVORABLES :

		cat=MOVE_CATEGORY(move);

		if (cat==COUP_FORCANT) 
		{ 
			listmovesptr->priority=MaterialWinScore;
			#if COLLECT_STATS==1
			origine_coups_analysis=OR_SEARCH_COUP_FORCANT;
			#endif
			return move;
		}



		// Promotion
		if (cat==PROMOTION) 
		{
		//if (node_type==NODE_PV)
		{
			bilan_coup=bilan_attaque_defense_avant_coup(move);
			switch(bilan_coup)
			{
				case GAIN_MATERIEL : 
							listmovesptr->priority=MaterialWinScore;
							#if COLLECT_STATS==1
							origine_coups_analysis=OR_SEARCH_PROMOTION;
							#endif
							return move;
							break;
				case PERTE_MATERIELLE :
							//listmovesptr->priority=BadScore;
						    listmovesptr->priority=CaptureScore;
							// NON : laisser le score historique
							//listmovesptr->priority=HistoryScore;
							goto NEXT_MOVE_NO_LISTE; 
							break;
				case COUP_NEUTRE :
							listmovesptr->priority=CaptureScore;
							goto NEXT_MOVE_NO_LISTE;
							break;
			}
		}
		}


		#if ALLOW_SEARCH_BILAN_AD==1
		// Prise de pices non dfendues hors pions
		//if (node_type==NODE_PV /*|| !MOVE_TAKES_PAWN(move)*/ )
		{
		//ASSERT(!MOVE_IS_EN_PASSANT(move));
		// rem : il est plus efficace de tester directement bilan_avant_coup
		// de manire  choisir la prise de pice !
		// Pas de notion safe/unsafe pour une prise
		bilan_coup=bilan_attaque_defense_avant_coup(move);
		switch (bilan_coup)
		{
			case GAIN_MATERIEL :
					#if COLLECT_STATS
					origine_coups_analysis=OR_SEARCH_PRISE_PIECE_NON_DEFENDUE;
					#endif
					listmovesptr->priority=MaterialWinScore;
					//listmovesptr->selected_move=true;
					return move;
					break;
			case PERTE_MATERIELLE :
					ASSERT(listmovesptr->givecheck==CHECK_NOT_DETERMINED);
					//if (listmovesptr->givecheck==CHECK_NOT_DETERMINED)
					//{
					//}
					listmovesptr->priority=CaptureScore;
					goto NEXT_MOVE_NO_LISTE;
					/*
					listmovesptr->givecheck=SEARCH::givecheck(move,wtm);
					if (listmovesptr->givecheck==CHECK)
					{
						// Laisser CaptureScore
						// pour permettre une analyse  depthtarget_level
						// au niveau des changes
						listmovesptr->priority=CaptureScore;
					}
					else
					{
						listmovesptr->priority=CaptureScore;
					}
					goto NEXT_MOVE_NO_LISTE;
					*/
					break;
			case COUP_NEUTRE :
			//case NEUTRAL : 
					listmovesptr->priority=CaptureScore;
					goto NEXT_MOVE_NO_LISTE; // Pas de gain matriel
					break;
		}
		}
		#endif



		#if ALLOW_SEARCH_BILAN_AD==0
		// Prise de la pice dernier coup
		// ( forte probabilit de bonne prise )
		if (MOVE_ARR64(move)==case_objectif_dernier_coup) 
		{
		#if COLLECT_STATS==1
		xprise_piece_dernier_coup_attempts++;
		#endif
		// Pas de notion safe/unsafe pour une prise
		// Ok pour la prise de la pice dernier coup
		// bilan_coup=bilan_attaque_defense_avant_coup(s,move);
		// LE BILAN COUP EST PRESUME FAVORABLE
		bilan_coup=GAIN_MATERIEL; // choix a priori
		#if COLLECT_STATS==1
		xprise_piece_dernier_coup_done++;
		origine_coups_analysis=OR_SEARCH_PRISE_PIECE_DERNIER_COUP;
		#endif
		listmovesptr->priority=MaterialWinScore;
		return move;
		}
		#endif


		#if DEBUG==1
		if (cat==COUP_FORCANT || cat==PROMOTION)
		log_error("\nErreur S221",MAJOR);
		#endif

		goto NEXT_MOVE_NO_LISTE;
		break; // case
		



	case SEARCH_ANALYSE_PRISES :


		// SEARCH_NO_NEED_TO_EXTEND
		#if SEARCH_NO_NEED_TO_EXTEND==1
		if (//xlevel>=depthtarget_level-1
			F_depthtarget_level_reached
			)
		{
		if (check==0 && node_type!=NODE_PV)
		{
			if (valpos+MOVE_CAPTURE_VALUE(move)
				//+(xlevel==depthtarget_level-1?550:0)
				+POSITIONAL_PRUNING_MARGIN
				<sup_alpha_value)
			{
			if (alpha<MATE_VALUE_THRESHOLD &&
				move!=hint_move)
			{
				if (listmovesptr->givecheck==CHECK_NOT_DETERMINED)
				{
					listmovesptr->givecheck=SEARCH::givecheck(move,wtm);
				}
				if (listmovesptr->givecheck==CHECK)
				{
					return move;
				}
				// Attention aux pions passs qu'il faut jouer 
				// car ils peuvent beaucoup augmenter 
				// la fonction d'valuation d'un coup sur l'autre
				if (MOVE_IS_PAWN(move)) 
				{
				   if(EST_PION_PASSE(wtm,MOVE_ARR64(move),s)) 
				   {
					   return move;
				   }
				}
				if (valpos+MOVE_CAPTURE_VALUE(move)+POSITIONAL_PRUNING_MARGIN>value)
				{
						Fsel=true;
					    xcompteur++; if (check_time_and_keyboard_for_return()) { xreturn = true; }
						#if COLLECT_STATS==1
						switch(node_type)
						{
							case NODE_PV  : xnodes_pv++; break;
							case NODE_CUT : xnodes_cut++; break;
							case NODE_ALL : xnodes_all++; break;
						}
						#endif
						// On n'enregistre pas le coup
						value=valpos+MOVE_CAPTURE_VALUE(move)+POSITIONAL_PRUNING_MARGIN;
						ASSERT(valpos+MOVE_CAPTURE_VALUE(move)+POSITIONAL_PRUNING_MARGIN<sup_alpha_value);
						*best=LigneEnd;
				}
				listmovesptr->Fplay=2;
				//min_fail_low_value=sup(min_fail_low_value,valpos+MOVE_CAPTURE_VALUE(move)+POSITIONAL_PRUNING_MARGIN);
				//min_fail_low_value=inf(min_fail_low_value,alpha);
				goto NEXT_MOVE_LISTMOVES;
			}
			}
		}
		}
		#endif

		return move;
		break;


	case SEARCH_ANALYSE_KILLERMOVES:

/*
#if DEBUG==1
if (compteur_mem==65251)
{
	char cc;
	cc=0;
	cc=1/cc;
}
#endif
*/

		if (MOVE_IS_PASSE(move))
		{
				goto NEXT_MOVE_LISTMOVES;	
		}

		dep=MOVE_DEP64(move);
		arr=MOVE_ARR64(move);
		num=xboard[dep].num_piece;
		if (num<debut_blanc || num>fin_blanc)
		{
			goto NEXT_MOVE_LISTMOVES;	
		}
		numptr=&xw[num];
		if (numptr->nature==0) break;
		if (MOVE_IS_CAPTURE(move) || MOVE_PROMOTION(move)=='D')
		{
			moveptr=numptr->psptr->moves2;
		}
		else
		{
			moveptr=numptr->psptr->moves;
		}
		for(;;moveptr++)
		{
			move2=*moveptr;
			if (move2==0) break;
			
			if (SAME_MOVE(move2,move))
			{
				if SAME_MOVE(move,hint_move)
				{
					goto NEXT_MOVE_LISTMOVES;
				}
				// Contrle lgalit
				#if USE_CASES_ACTUALISATION==1
				if (bit(pieces_with_possible_illegal_moves,numptr->num_piece))
				#endif
				{
					cc=SEARCH::legal(num,move,num_roi,*lignemoins);
					if (cc!=1) 
					{
						goto NEXT_MOVE_LISTMOVES;
					}
				}
				listmovesptr->num=num;
				listmovesptr->type=numptr->type;
				return move2; // move2 de prfrence
			}
		} 
		
		goto NEXT_MOVE_LISTMOVES;
		break;



	case SEARCH_ANALYSE_COUPS_HEURISTIQUES:

		// forc
		arr=MOVE_ARR64(move);
		dep=MOVE_DEP64(move);

		ASSERT(F_utilisation_liste==false);
		#if SEARCH_NO_EARLY_HEURISTIC_MOVES==1
		if (xlevel<depthtarget_level-6)
		{ goto NEXT_MOVE_NO_LISTE; }
		#endif



		
		// Heuristiques supposant l'absence d'chec
		// if (check==0 /*&& NONNNN : node_type!=NODE_ALL*/)
		ASSERT(check==0);
		{
			#if USE_NULLMOVE_REFUTATION==1
			if (SAME_MOVE(move,previous_level_nullmove_refutation))
			{
				goto VALIDER_COUP_HEURISTIQUE;
			}
			if (nullmove_refutation_arr>=0)
			{
				// beta n'est pas dfini
				ASSERT(valpos>=alpha);

				// Interdiction case d'arrive 
				// nullmove_refutation_arr
				// Objectif, contrler cette case, ou la quitter
				cc=0;
				// Fuir la case d'arrive
				if (
					MOVE_DEP64(move)==nullmove_refutation_arr
					// A depthtarget_level, rduire le nombre
					// de coups 
					//&& !F_deptharget_level_reached
					)
				{ cc=1; }
				else
				{
				if (!F_nullmove_refutation_cannot_be_defended)
				{
				// Le coup apporte-t-il de la protection ?
				arr=MOVE_ARR64(move);
				switch(MOVE_NATURE(move))
				{
				case 'D' : 
					ASSERT(arr==MOVE_ARR64(move));
					if (bit(xcases_arrivee_dame[arr],nullmove_refutation_arr))
					{ cc=1; }
					break;
				case 'T' : 
					ASSERT(arr==MOVE_ARR64(move));
					if (bit(xcases_arrivee_tour[arr],nullmove_refutation_arr))
					{ cc=1; }
					break;
				case 'F' : 
					ASSERT(arr==MOVE_ARR64(move));
					if (bit(xcases_arrivee_fou[arr],nullmove_refutation_arr))
					{ cc=1; }
					break;
				case 'C' : 
					ASSERT(arr==MOVE_ARR64(move));
					if (bit(xcases_arrivee_cavalier[arr],nullmove_refutation_arr))
					{ cc=1; }
					break;
				case 'P' :
					if (nullmove_refutation_arr==arr+PLAYER(player,9)
						||
						nullmove_refutation_arr==arr-PLAYER(player,7)
						)
					{ cc=1; }
					break;
				case 'R' : 
					ASSERT(arr==MOVE_ARR64(move));
					if (bit(xcases_arrivee_roi[arr],nullmove_refutation_arr))
					{ cc=1; }
					break;
				} // fin switch
				} // fin if
				} // fin else
				if (cc==1)
				{
					bilan_coup=bilan_attaque_defense_avant_coup_simplifie(move);
					if (bilan_coup==MATERIAL_LOSS)
					{
						 listmovesptr->priority=BadScore;
					}
					else
					{	
						//listmovesptr->priority=HeuristicScore;
						#if COLLECT_STATS
						origine_coups_analysis=OR_SEARCH_EVASION_PIECE_ATTAQUEE;
						#endif
						cat=COUP_HEURISTIQUE;
						//listmovesptr->categorie=COUP_HEURISTIQUE_2;
						goto VALIDER_COUP_HEURISTIQUE;
					}
				}

			} // fin nullmove refutation
			#endif
			


		#if SEARCH_COUPS_HEURISTIQUES_ECHECS==1
		if (s->finale==MILIEU_DE_PARTIE
			//&& xlevel>=depthtarget_level-1
			)
		{
		// F_depthtarget_level_reached pour position Lasker
		if (true
			// Sinon on a des variantes ridicules
			// Noir joue d5 et blanc analyse 2 millions de coups 
			//  la profondeur 10 quand il y a mat en 1
			// F_depthtarget_level_reached 
			/*|| MOVE_IS_QUEEN(move)*/)
		//if (//F_depthtarget_level_reached
			//xF_derniere_profondeur_a_examiner
		//	)
		{
		listmovesptr->givecheck=SEARCH::givecheck(move,wtm);
		if (listmovesptr->givecheck==CHECK) 
		{
			#if _DEBUG
			cc=0;
			#endif
			#if COLLECT_STATS==1
			origine_coups_analysis=OR_SEARCH_ANALYSE_ECHEC;
			#endif
			goto VALIDER_COUP_HEURISTIQUE;
		}
		}
		}
		#endif


					#if USE_MATE_THREATS==1
					// Menaces avec la dame
					// Ici forcment car on accde pas  depthtarget 
					// au level autres coups
					// on souhaite pouvoir excuter uen menance et tendre de 1  depthtarget
					if (this->F_allow_mate_threats
					&& xlevel>=(depth>>FD)-MATE_THREAT_EXT_DISTANCE_FROM_DEPTHTARGET)
					{
					cc=0;
					if (MOVE_IS_QUEEN(move))
					{
					arr=MOVE_ARR64(move);
					// Test A
					if (xcases_arrivee_dame[arr] & xcases_arrivee_roi[s->roi_pos[other_wtm]])
						{
						// Menace-t-on une case adjacente au roi 
						// supporte par nous
						// mais non contrle par l'adversaire
						// si oui : extension
						// (excellent rsultat sur Rotman.fch)
						// forc 
						dep=MOVE_DEP64(move);
						if (
						xcases_arrivee_dame[arr] 
						&xcases_arrivee_roi[s->roi_pos[other_wtm]]
						//s->cases_echec_dame[wtm] (inutile car vrifi avec le test prcdent
						// relatif aux cases  proximit du roi
						&(~cases_controlees_adversaire_hors_roi)
						&(
						      cases_controle_exclusif_pion
							| cases_controle_exclusif_cavalier
							| cases_controle_exclusif_fou
							| cases_controle_exclusif_tour
						)
						&(~xcases_arrivee_dame[dep]) 
						)
						{
							 #if USE_MATE_THREATS_EXTENSIONS==1
							 if (s->queen_threat_extensions<AVAILABLE_MATE_THREAT_EXTENSIONS
								 && xlevel>=(depth>>FD)-MATE_THREAT_EXT_DISTANCE_FROM_DEPTHTARGET
									// dja vrifi : && SEARCH::givecheck(move,wtm)!=CHECK
										#if MATE_THREATS_ONLY_ON_NODE_PV==1
										&& node_type==NODE_PV
									    #endif
								)
							{
								// Il faut au moins 1 de profondeur par rapport au level
								// pour rentabiliser le coup
								// Et plus encore si l'adversaire rpond par un chec
								// Si l'adversaire rpond par un chec, cela ajoute 
								// 2 de profondeur, mais je rcupre 1 grce  l'chec
								// Profondeur de dpart minimum 2
								// - chec de l'adversaire en profondeur 1
								// - ma rponse en profondeur 0 mais extension de 1
								// - mon adversaire joue en profondeur search 0
								// - je place la menace en extend 
								depthmove=depth+(1<<FD);
								//if ((depthmove>>FD)-xlevel<2) depthmove=(xlevel+2)<<FD;
								F_queen_threat_extension=true;			
						}
							#endif
							F_do_see_evaluation=false; // inutile (dame protge et non attaque)
							F_move_should_be_explored_without_reduction=false; // inutile on vrifie ci-aprs
							goto JOUER_COUP_HEURISTIQUE;
						}
					}
					}
					#if QUEEN_THREATS_ONLY==0
					else 
					// Menace avec l'aide d'autres pices
					{
					if (king_attack_squares)
					{
					switch(MOVE_NATURE(move))
					{
					// Les pions sont inutiles
					//
					//case 'P' :  if (xwtm==1)
					//			{
					//			if (
					//			king_attack_squares
					//			&(unsigned __int64 ((1<<arr)<<9) || ((1<<arr)>>7))
					//			)
					//			{
					//			    #if USE_MATE_THREATS_EXTENSIONS==1
					//				if (// && dja vrifi SEARCH::givecheck(move,wtm)!=CHECK
					//					s->queen_threat_extensions<AVAILABLE_MATE_THREAT_EXTENSIONS
					//					&& xlevel==(depth>>FD)
					//					#if MATE_THREATS_ONLY_ON_NODE_PV==1
					//					&& node_type==NODE_PV
					//					#endif
					//					)
					//				{
					//					depthmove=depth+((1<<FD)); 
					//					F_queen_threat_extension=true;
					//				}
					//				#endif
					//				F_do_see_evaluation=false;
					//				F_move_should_be_explored_without_reduction=true;
					//				goto JOUER_COUP_HEURISTIQUE;
					//			}
					//			break;
					//			}
					//			else // wtm==0
					//			{
					//			if (
					//			king_attack_squares
					//			&(unsigned __int64 ((1<<arr)>>9) || ((1<<arr)<<7))
					//			)
					//			{
					//				#if USE_MATE_THREATS_EXTENSIONS==1
					//				if (// d&ja vrifi	SEARCH::givecheck(move,wtm)!=CHECK
					//					s->queen_threat_extensions<AVAILABLE_MATE_THREAT_EXTENSIONS
					//					&& xlevel==(depth>>FD)
					//					#if MATE_THREATS_ONLY_ON_NODE_PV==1
					//					&& node_type==NODE_PV
					//					#endif
					//					)
					//				{
					//					depthmove=depth+((1<<FD));
					//					F_queen_threat_extension=true;
					//				}
					//				#endif
					//				F_do_see_evaluation=false;
					//				F_move_should_be_explored_without_reduction=true;
					//				goto JOUER_COUP_HEURISTIQUE;
					//			}
					//			break;
					//			}
					case 'C' : if (
							   king_attack_squares
							   &xcases_arrivee_cavalier[arr]
							   )
							   {
								    #if USE_MATE_THREATS_EXTENSIONS==1
			   						// Extension car fait augmenter l'arbre
								   	if (s->queen_threat_extensions<AVAILABLE_MATE_THREAT_EXTENSIONS
									&& xlevel>=(depth>>FD)-MATE_THREAT_EXT_DISTANCE_FROM_DEPTHTARGET
									#if MATE_THREATS_ONLY_ON_NODE_PV==1
									&& node_type==NODE_PV
									#endif
									)
									{ 
									// dja vrifi : if (SEARCH::givecheck(move,wtm)!=CHECK)
									{ 
										F_queen_threat_extension=true;
										depthmove=depth+((1<<FD)); 
										//if ((depthmove>>FD)-xlevel<2) depthmove=(xlevel+2)<<FD;
									}
									}
									#endif
									F_do_see_evaluation=false;
									F_move_should_be_explored_without_reduction=true;
									goto JOUER_COUP_HEURISTIQUE;
							   }
								   break;
					case 'F' : if (
							    king_attack_squares
							    & xcases_arrivee_fou[arr]
							    &(~xcases_arrivee_fou[dep]) 
							   )
							   {
			   						// Extension
								    #if USE_MATE_THREATS_EXTENSIONS==1
									if (s->queen_threat_extensions<AVAILABLE_MATE_THREAT_EXTENSIONS
									&& xlevel>=(depth>>FD)-MATE_THREAT_EXT_DISTANCE_FROM_DEPTHTARGET
									#if MATE_THREATS_ONLY_ON_NODE_PV==1
									&& node_type==NODE_PV
									#endif
									)
									// dja vrifi if (SEARCH::givecheck(move,wtm)!=CHECK)
									{ 
										depthmove=depth+((1<<FD)); 
										//if ((depthmove>>FD)-xlevel<2) depthmove=(xlevel+2)<<FD;
										F_queen_threat_extension=true;
									}
									#endif
									F_do_see_evaluation=false;
									F_move_should_be_explored_without_reduction=true;
									goto JOUER_COUP_HEURISTIQUE;
							   }
								   break;
					case 'T' : if (
							   king_attack_squares
							   &xcases_arrivee_tour[arr]
							   &(~xcases_arrivee_tour[dep])
							   )
							   {
								    #if USE_MATE_THREATS_EXTENSIONS==1
			   						// Extension 
									if (s->queen_threat_extensions<AVAILABLE_MATE_THREAT_EXTENSIONS
										&& xlevel>=(depth>>FD)-MATE_THREAT_EXT_DISTANCE_FROM_DEPTHTARGET
										#if MATE_THREATS_ONLY_ON_NODE_PV==1
										&& node_type==NODE_PV
										#endif
										)
									// dja vrifi : if (SEARCH::givecheck(move,wtm)!=CHECK)
									{
										depthmove=depth+((1<<FD)); 
										//if ((depthmove>>FD)-xlevel<2) depthmove=(xlevel+2)<<FD;
										F_queen_threat_extension=true;
									}
									#endif
									F_do_see_evaluation=false;
									F_move_should_be_explored_without_reduction=true;
									goto JOUER_COUP_HEURISTIQUE;
							   }
								   break;
				 //    Inutile galement
					//case 'R' : if (
					//		    king_attack_squares							   
					//			&xcases_arrivee_roi[arr]
					//		   )
					//		   {
					//				#if USE_MATE_THREATS_EXTENSIONS==1
			  // 						// Extension car fait augmenter l'arbre
					//				if (s->queen_threat_extensions<AVAILABLE_MATE_THREAT_EXTENSIONS
					//			        && xlevel==(depth>>FD)
					//					#if MATE_THREATS_ONLY_ON_NODE_PV==1
					//					&& node_type==NODE_PV
					//					#endif
					//					)
					//				{ 
					//					depthmove=depth+((1<<FD));
					//					//if ((depthmove>>FD)-xlevel<2) depthmove=(xlevel+2)<<FD;
					//					F_queen_threat_extension=true;
					//				}
					//				#endif
					//				F_do_see_evaluation=false;
					//				F_move_should_be_explored_without_reduction=true;
					//				goto JOUER_COUP_HEURISTIQUE;
					//		   }
					//		   break;
					default : break; 
					} // fin switch
					} // fin king_attacks
					} // fin else
					#endif
					} // fin condition profondeur
					#endif


				// Pions avancs
				if (MOVE_IS_PAWN(move)) 
				{
				#if DEBUG==1
				if ((s->cases_pions[other_wtm]&xmasque_pion_passe[wtm][dep])==0
					&& s->passed[wtm]==0)
					log_error("\nErr S_098",MAJOR);
				#endif

				// Pions candidats
				//if (finale>=FIN_DE_PARTIE_1)
				//{
					if (wtm==1) cc=Y64(dep);
					else cc=7-Y64(dep);
					// Pions passs
					if (cc==5) // pion en sixime
					{
						// Pour les pions en sixime, toujours prciser la menace
						// Blanc joue en septime
						// Noir joue  *depthtarget
						// Blanc fait dame
						// et faire dame en extend
						// Rem : tous les pions en sixime sont candidats
						// et ce test est inutile !!!!
						if (//node_type==NODE_PV
							//&& 
						    xlevel>=(depthmove>>FD)-4
							)
						{
							#if USE_RESTRICT_NULLMOVE==1
							F_restrict_nullmove=true; 
							#endif
							F_move_should_be_explored_without_reduction=true;
							F_do_see_evaluation=false;
							//if (node_type==NODE_PV)
							//if (xlevel==(depth>>FD))
							{ depthmove+=((1<<FD)); }
							//else depthmove+=((1<<FD)>>2);
							goto VALIDER_COUP_HEURISTIQUE;
						}
					}
					#if ALLOW_MODIFIED_PAWN_EXTENSIONS==1
					/*
					if (cc==3 
						//&& node_type==NODE_PV 
						&& finale>=FIN_DE_PARTIE_1
						&& (xlevel<=3 || (node_type==NODE_PV && (depthmove>>FD)-xlevel<=4))
					   ) 
					{
					// Ne pas faire des extensions de pions dans des positions
					// ou cela n'est pas souhaitable
					// c'est trop couteux !!!
					// if (valpos<alpha-50) break; 
					// Blanc doit pouvoir pousser en cinquime  -3
					// Noir joue en -2
					// Blanc est en cinquime  -1 et tend
					// Noir joue  depthtarget
					// Blanc fait dame en extend
					if (EST_PION_CANDIDAT(wtm,arr,s)||EST_PION_PASSE(wtm,arr,s))
					{
						#if USE_RESTRICT_NULLMOVE==1
						F_restrict_nullmove=true;
						#endif
						F_move_should_be_explored_without_reduction=true;
						F_do_see_evaluation=false;
						depthmove+=((1<<FD));
						break;
					}
					}
					else
					*/
					if (cc==4 
						// && node_type==NODE_PV 
						&& finale>=FIN_DE_PARTIE_1
						&& xlevel>=(depthmove>>FD)-4
						)
					{
					// Ne pas faire des extensions de pions dans des positions
					// ou cela n'est pas souhaitable
					// c'est trop couteux !!!
					// if (valpos<alpha-50) break; 
					// Blanc doit pouvoir pousser en sixime  -2
					// Noir joue en -1
					// Blanc joue en depthtarget en septime et tend de 1 car pion en septime
					// Noir joue  depthtarget
					// Blanc fait dame en extend
					// Concrtement, il faut pouvoir avoir  nouveau le trait avant depthtarget
					// afin d'enchaner sur une autre extension
					// et donc le problme ne se pose que si on est  *depthtarget-2
					//if (EST_PION_CANDIDAT(wtm,arr,s)||EST_PION_PASSE(wtm,arr,s))
					// Pions candidats et pions passs
					if (EST_PION_PASSE(wtm,arr,s))
					{
						#if USE_RESTRICT_NULLMOVE==1
						F_restrict_nullmove=true;
						#endif	
						F_move_should_be_explored_without_reduction=true;
						F_do_see_evaluation=true;
						depthmove+=((1<<FD));
						goto VALIDER_COUP_HEURISTIQUE;
					}
					}
					#endif

				} // fin move_nature=='P'



		// Dplacement des hanging pieces
		if (valpos+POSITIONAL_PRUNING_MARGIN>sup_alpha_value)
		{
			#if HEURISTIC_PIECE_EVASION==1
			if (hanging_pieces!=0)
			{
				if (bit(hanging_pieces,MOVE_DEP64(move)))
				{
					#if _DEBUG==1
					cc=0;
					#endif
					goto VALIDER_COUP_HEURISTIQUE;
				}
			}
			#endif




		
		#if USE_CASES_COUPS_FORCANTS==1
		if (hint_move==0 && F_existe_coup_forcant_adversaire
			&& 
			(valpos>sup_alpha_value 
			//&& node_type!=NODE_PV
			)
			)
		{
		// Dplacement des pices menaces par des coups forants
		if (bit(s->cases_coup_forcant[other_wtm],MOVE_DEP64(move))==1)
		{
			goto VALIDER_COUP_HEURISTIQUE;
		}
		} // fin F_existe_coup_forant_adversaire
		#endif
		
		

		#if USE_SEARCH_UNDEFENDED_PIECES==1
		// Test pices non dfendues
		// sur la base d'un inventaire ou de la liste des dernires pices attaques
		// Et on en profite pour initialiser si besoin est 
		// l'heuristique de dtection des coups de protection
		// Attention : ne fait pas obligatoirement appels aux __int64
		if (F_piece_non_defendue 
			// Si coup forant adversaire, il ne suffit pas de dfendre
			//&& !F_existe_coup_forcant_adversaire
			// Si valpos<alpha, il ne suffira pas de dfendre
			//&& valpos<sup_alpha_value-500
			)
		{
		if (bit(pieces_non_defendues,num)==1)
		{
			goto VALIDER_COUP_HEURISTIQUE;
		}
		}
		#endif

		/*
		// Initialisation heuristique protection
		// pour la pice menace la plus importante
		// On se limite  une pice d'o le flag
		if (!F_initialisation_protection && valpos>sup_alpha_value)
		{
			// Note : xpiece_cible_heuristique_protection
			// n'est pas forcment num 
			// car il peut y avoir plusieurs pice attaques
			  // mais une seule pice est prise en compte pour l'heuristique protection
			F_initialisation_protection=true;
			case_cible_heuristique_protection=dep;
			SEARCH::inventaire_cases_protection(wtm,case_cible_heuristique_protection); 
		}
		


		// Heuristique coups de protection
		// Le coup intercepte une menace ou protge
		// L'heuristique n'est initialise que si valpos>sup_alpha_value
		if (F_initialisation_protection)
		{
		cc=0;
		if (interception(*cases_interception,MOVE_ARR64(move))==1)
		{
			//if (MOVE_NUM_PIECE(move)!=piece_cible_heuristique_protection) 
			if (dep!=case_cible_heuristique_protection) 
			{ cc=1; }
		}
		else
		{
			if (SEARCH::give_protection(case_cible_heuristique_protection,move))
			{ cc=1; }
		}


		if (cc==1)
		{
			#if COLLECT_STATS==1
			origine_coups_analysis=OR_SEARCH_HEURISTIQUE_PROTECTION;
			#endif
			cat=COUP_HEURISTIQUE_2;
			listmovesptr->categorie=COUP_HEURISTIQUE_2;
			listmovesptr->priority=HeuristicScore;
			goto VALIDER_COUP_HEURISTIQUE;
		} // fin if cc==1
		} // fin intitialisation protection
		} // fin pice non dfendue 1
		} // fin pice non dfendue 1
		#endif
		*/

		} // fin value+POSITIONAL_PRUNING_MARGIN>sup_alpha_value

		#if HEURISTIQUE_THREAT_GREATER_PIECE==1
		unsigned __int64 cible_candidate, cases_controlees_hors_piece;
		char arr2;
		char nature;
		if (xlevel>(depthtarget>>FD)-6 
			// On ne peut pas valider une menace non chec  depthtarget
			&& !F_depthtarget_level_reached
			)
		{
		arr=MOVE_ARR64(move);
		nature=MOVE_NATURE(move);
		switch(nature)
		{
		case 'D': cible_candidate=0;
		case 'T': cible_candidate=xcases_arrivee_tour[arr]&s->cases_pieces[other_wtm]
				  ;
			break;
		case 'F': cible_candidate=xcases_arrivee_fou[arr]&s->cases_pieces[other_wtm]
				  ;
			break;
		case 'C': cible_candidate=xcases_arrivee_cavalier[arr]&s->cases_pieces[other_wtm]
				  ;
			break;
		case 'P': cible_candidate=xcases_controlees_pion[wtm][arr]&s->cases_pieces[other_wtm]
				  ;
			break;
		default : cible_candidate=0;
		}
		while(cible_candidate)
		{
			arr2=bitScanForward_Clear(cible_candidate);
			if (arr2==s->roi_pos[other_wtm]) { continue; }
			if (xboard[arr2].wptr!=NULL)
			{
			ASSERT(xboard[arr2].color01==other_wtm);
			ASSERT(xboard[arr2].nature!='R');
			#if _DEBUG==1
			dep=MOVE_DEP64(move);
			#endif
			if (abs(xboard[arr2].wptr->value)-abs(xw[MOVE_NUM_PIECE(move)].value)>=QUALITE)
			{
			if (nature=='C'
				||
				nature=='P'
				||
				(
				 ( // Important : sinon NOK
				 xmasque_dep_arr[arr][arr2]
			      & cases_occupees
				  )
				==0)
				)
			{
				// Case d'arrive non menace
				if (bit(cases_controlees_adversaire,arr)==0)
				{ return move; }

				#if MULTI_CONTROL==1
				// Case d'arrive controle par une autre pice
				if (bit(cases_multi_controlees_joueur,arr))
				{
					#if  _DEBUG
					cc=0;
					#endif
					goto VALIDER_COUP_HEURISTIQUE; 
				}
				#endif

				#if MULTI_CONTROL==0
				// Pice protge ?
				switch(nature)
				{
				case 'T' : 
					cases_controlees_hors_piece=
						  cases_controle_exclusif_pion
						| cases_controle_exclusif_cavalier
						| cases_controle_exclusif_fou
						| cases_controle_exclusif_dame
						| cases_controle_exclusif_roi;
					break;
				case 'F' :
	  					  cases_controlees_hors_piece=
						  cases_controle_exclusif_pion
						| cases_controle_exclusif_cavalier
						| cases_controle_exclusif_tour
						| cases_controle_exclusif_dame
						| cases_controle_exclusif_roi;
					break;
				case 'C' :
					      cases_controlees_hors_piece=
						  cases_controle_exclusif_pion
						| cases_controle_exclusif_tour
						| cases_controle_exclusif_fou
						| cases_controle_exclusif_dame
						| cases_controle_exclusif_roi;
					break;
				case 'P' :
					      cases_controlees_hors_piece=
						  cases_controle_exclusif_cavalier
						| cases_controle_exclusif_tour
						| cases_controle_exclusif_fou
						| cases_controle_exclusif_dame
						| cases_controle_exclusif_roi;
					break;
				case 'D' : 
					break;
				default : break;
				}
				
				// Ok si pice protge
				if (bit(cases_controlees_hors_piece,arr))
				{
					goto VALIDER_COUP_HEURISTIQUE;
				}
				#endif
			}
			}
			}

		}
		}
		#endif

	} // fin heuristiques sans checs
	    
	// Retour sans jeu du coup
	goto NEXT_MOVE_NO_LISTE;

	VALIDER_COUP_HEURISTIQUE:
	bilan_coup=bilan_attaque_defense_avant_coup(move);
	switch(bilan_coup)
	{
		case GAIN_MATERIEL :
					ASSERT(1==2 || MOVE_IS_PROMOTION(move)); // Should not happen
					listmovesptr->priority=HeuristicScore;
					#if COLLECT_STATS==1
					origine_coups_analysis=OR_SEARCH_COUPS_HEURISTIQUE;
					#endif
					return move;
					break;
		case PERTE_MATERIELLE :
					listmovesptr->priority=BadScore;
					// Rinitialisation de valeurs qui ont pu tre modifies
					// par accord d'extension
					// this_move_extension=0;
					depthmove=depth;
					F_move_should_be_explored_without_reduction=false;
					F_do_see_evaluation=false;
				    goto NEXT_MOVE_NO_LISTE; 
					break;
		case COUP_NEUTRE :
					listmovesptr->priority=HeuristicScore;
					return move;
					break;
	}
	JOUER_COUP_HEURISTIQUE:
	return move;
	break;

	case SEARCH_ANALYSE_AUTRES_COUPS :
			return move;
    			break;

	case SEARCH_ANALYSE_LISTE :
			return move;
		      break;

}

JOUER_COUP:
return move;
} // fin get_move